drop package apollosearch;
/
create or replace package apollosearch is
procedure start1(keyword varchar2, document varchar2);
procedure start1(keyword varchar2);

procedure header_output(keyword varchar2,document varchar2);
procedure header_list(keyword varchar2,total number,seed number,qid integer,dpath varchar2);
function url(curl in varchar2, cname in varchar2) return varchar2;

root_url varchar2(200) := '/apollo/owa';
root_url1 varchar2(200) := '/cgi-bin/apollo';
server_name varchar2(200) := 'http://osprey7.npac.syr.edu:1963/apollo/';
  end;
/
show errors;
/
create or replace package body apollosearch is

usr_query_id number;
key varchar2(200);
perpath varchar2(250);
leftpath varchar2(250);
docpath varchar2(250);
hits integer := 15;


function url    (curl   in varchar2, cname   in varchar2) return varchar2 is
begin return('<a href="' || curl || '">' || cname || '</a>'); end;

procedure start1(keyword varchar2) is
begin
	start1(keyword,'%/%');
end;




procedure start1(keyword varchar2, document varchar2) is
  front boolean := true;
  more boolean := false;
  lastpath boolean := false;
  ch char(1);
  
  position integer;
  total number(8) := 0;
  ptotal number(8) := 0;
  cursor_handle integer;
  exect integer;
  
  begin
--htp.p('We are updating the database, please search later. Thanks!!');return;
	if ((instr(keyword,'&') = 0) and (instr(keyword,'|') = 0) and 
		(instr(keyword,'-') = 0) and (instr(keyword,',') = 0)) then
	     for n in 1 .. length(keyword) loop
		ch := substr(keyword,n,1);
		if (ch != ' ') then
			if (front) then	
				key := ch;
				front := false;
			elsif (more) then 
				more := false; 
				key := key||'&'||ch;
			else key := key||ch;
			end if;
		else 
			if (not (front or more)) then more := true; end if;
		end if;
	     end loop;
	else
		key := replace(keyword,' ');
	end if;
        
	docpath := replace(document,'%2F','/');
        docpath := replace(docpath,'%25','%');

	--docpath := replace(document,'&', ' or path like ');

	if (key IS NULL) then 
		htp.p('Please type one or more keywords to start your search');
		wow.sig;
		return;
	end if;

	select query_id.nextval into usr_query_id from dual;
	ctx_query.contains('SEARCH_POLICY','('||key||'):500','QUERY_TEMP',1,usr_query_id,NULL);

	--select count(*) into total from query_temp where conid=usr_query_id;
	--select count(*) into total from body_hitlist  where conid=usr_query_id 
        --                                              and path like docpath;
	
	total := 0;
	leftpath := docpath;
	position := instr(leftpath,'&');
	
    while ( not lastpath ) loop
	if ( not (position=0)) then
	   perpath := substr(leftpath,1,position - 1);
	else
	   perpath := leftpath;
	end if;
	cursor_handle := DBMS_SQL.OPEN_CURSOR;
        DBMS_SQL.PARSE( cursor_handle,'select count(*) from body_hitlist  where conid = '''|| usr_query_id ||
                                ''' and  path like '''|| perpath || '''',
                                DBMS_SQL.V7);
 
	DBMS_SQL.DEFINE_COLUMN(cursor_handle, 1, ptotal);
	exect := DBMS_SQL.EXECUTE(cursor_handle);
	if (DBMS_SQL.FETCH_ROWS(cursor_handle) = 0) then
	   ptotal:=0;
        else 
	   DBMS_SQL.COLUMN_VALUE(cursor_handle,1,ptotal);
 	end if;
	DBMS_SQL.CLOSE_CURSOR(cursor_handle);
	total := total + ptotal;
	leftpath := substr(leftpath,position + 1);
	if (  position = 0 ) then
	   lastpath := true; 
	else
	   position := instr(leftpath,'&');
	end if;
	end loop;

        if (total = 0) then
        	header_output(keyword,docpath);
            --htp.p('<center>'||docpath||'</center><p>');
                htp.p('<center><u><blink>0 document found.</blink></u></center>');
		wow.sig;
		htp.p('</TD></TR></TABLE>');
	else
		key := replace(key,'&','~');
		header_list(key,total,1,usr_query_id,docpath);
	end if;
end;

procedure header_list(keyword varchar2,total number,seed number,qid integer,dpath varchar2) is

--cursor cresult(cid number) is select *
--                from body_hitlist where conid=cid 
--		and path like dpath order by score desc;
  result_rec body_hitlist%ROWTYPE;
  cursor_handle integer;
  position integer;
  lastpath boolean := false;
  
  view_url varchar2(200) := root_url1||'/textview?keyword=';
  npacurl varchar2(255);
  tit search.title%TYPE;
  next number(8);   
  prev number(8);
  next_str varchar2(20):=NULL;
  prev_str varchar2(20):=NULL;
  curr_str varchar2(20):=NULL;
  counter integer := 0;
  iseed integer;
  s_subject long;
  n integer; 
  rowcount integer;
  totalnum integer;
  execute_feedback integer;
  article_rec search%ROWTYPE;
  ii number;
  oldpath varchar2(250);
 -- mypath varchar2(255);
 -- cid integer;

begin
	header_output(replace(keyword,'~','&'), dpath);
	key := keyword;
--	htp.p('<center>'||dpath||'</center>');
        oldpath := replace(dpath,'&','&dpath=');
        oldpath := replace(oldpath,'%','%25');
	next := seed+hits;
	if (next<=total) then
		if ((next+hits)<=total) then
			next_str := (next+hits-1);
		else
			next_str := total;
		end if;
		next_str := next||'-'||next_str;
		curr_str := (next-1);
	else
		curr_str := total;
	end if;
	prev := seed - hits;
        if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
        elsif (seed > 1) then
                        prev := 1;
                        prev_str := '1-'||hits;
        end if;

	htp.p('<center><table border=0><tr>');
	htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
	htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
		htp.p(' <b>|</b> <td align=right>');
		htp.p(url(root_url||'/apollosearch.header_list?keyword='||key
		||'&total='||total||'&seed='||next||'&qid='||qid||'&dpath='||oldpath,
		'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
		htp.p(' <b>|</b><td align=right>');
		htp.p(url(root_url||'/apollosearch.header_list?keyword='||key  
		||'&total='||total||'&seed='||prev||'&qid='||qid||'&dpath='||oldpath,
		'Prev '||prev_str));
	end if;
	htp.p('</table></center><dl>');
		
 --  	open cresult(qid);


	leftpath :=dpath;
        totalnum := 0;
	leftpath := replace(leftpath,'%25','%');
	position := instr(leftpath,'&');
    while (not lastpath) loop
	if (counter > hits) then  exit; end if;
	if ( not (position=0)) then
	   perpath := substr(leftpath,1,position - 1);
	else
	   perpath := leftpath;
	end if; 
	cursor_handle := DBMS_SQL.OPEN_CURSOR;
	DBMS_SQL.PARSE( cursor_handle,'select * from body_hitlist where conid =  '''|| qid ||
				''' and  path like '''|| perpath ||''' order by score desc ', 
				DBMS_SQL.V7);
	
--	DBMS_SQL.BIND_VARIABLE(cursor_handle, 'cid', qid);
--	DBMS_SQL.BIND_VARIABLE(cursor_handle, 'mypath', dpath);
		DBMS_SQL.DEFINE_COLUMN(cursor_handle, 1, result_rec.score);
                DBMS_SQL.DEFINE_COLUMN(cursor_handle, 2, result_rec.conid);
                DBMS_SQL.DEFINE_COLUMN(cursor_handle, 3, result_rec.fid);
                DBMS_SQL.DEFINE_COLUMN(cursor_handle, 4, result_rec.title, 255);
                DBMS_SQL.DEFINE_COLUMN(cursor_handle, 5, result_rec.host1,60);
                DBMS_SQL.DEFINE_COLUMN(cursor_handle, 6, result_rec.path,255);
                DBMS_SQL.DEFINE_COLUMN(cursor_handle, 7, result_rec.fsize);
                DBMS_SQL.DEFINE_COLUMN(cursor_handle, 8, result_rec.time);
                DBMS_SQL.DEFINE_COLUMN(cursor_handle, 9, result_rec.subject,255);
 	execute_feedback := DBMS_SQL.EXECUTE(cursor_handle);

	loop 
	     rowcount := DBMS_SQL.FETCH_ROWS (cursor_handle);
	     if (rowcount = 0) then
		exit;
             else
		DBMS_SQL.COLUMN_VALUE(cursor_handle, 1, result_rec.score);
		DBMS_SQL.COLUMN_VALUE(cursor_handle, 2, result_rec.conid);
		DBMS_SQL.COLUMN_VALUE(cursor_handle, 3, result_rec.fid);
		DBMS_SQL.COLUMN_VALUE(cursor_handle, 4, result_rec.title);
		DBMS_SQL.COLUMN_VALUE(cursor_handle, 5, result_rec.host1);
		DBMS_SQL.COLUMN_VALUE(cursor_handle, 6, result_rec.path);
		DBMS_SQL.COLUMN_VALUE(cursor_handle, 7, result_rec.fsize);
		DBMS_SQL.COLUMN_VALUE(cursor_handle, 8, result_rec.time);
		DBMS_SQL.COLUMN_VALUE(cursor_handle, 9, result_rec.subject);

		--fetch cresult into result_rec;
		--exit when cresult%NOTFOUND;
		totalnum := totalnum + 1;
                if (totalnum >= seed) then
		tit := result_rec.title;
		--tit := replace(result_rec.title,'''','''''');
       	 	--tit := replace(tit,'&','&amp');
        	tit := replace(tit,'<','&lt');
        	tit := replace(tit,'>','&gt');
        	tit := replace(tit,'"','&quot');
		if (tit IS NULL) then
			tit := 'No Title';
		end if;
		htp.p('<p><dt>');
		if (result_rec.score>70) then
			htp.p('<img src="'||server_name||'reddot.gif" border=0>');
		elsif (result_rec.score>40) then
			htp.p('<img src="'||server_name||'green_dot.gif"  border=0>'); 
		else
			htp.p('<img src="'||server_name||'cy_ball.gif"  border=0>'); 
    		end if; 

		htp.p('<a href="'||view_url||key||'&f_id='||result_rec.fid||'&cid='||qid||
			'"><strong>');
		htp.p(tit);
		htp.p('</strong></a>');
		htp.p(' <font size=-1>(<cite>Score: '||result_rec.score||
		'; Size: '||round((result_rec.fsize/1024),1)||'KB; Date: '||to_char(result_rec.time,'dd Mon yy')||'</cite></font>)<dd>');
		ii := result_rec.fid;
		--select * into article_rec from search where fid=ii;
		--htp.p(substr(article_rec.text,1,240));
		htp.p(result_rec.subject);
		npacurl := 'http://'||result_rec.host1||result_rec.path;
		htp.p('<br><font size="-1">'||url(npacurl,npacurl)||'</font>');
		counter := counter + 1;
		if (counter >= hits ) then exit; end if; 
		end if;
	   end if;
	end loop;
	htp.p('</dl>');
--	close cresult;
   	DBMS_SQL.CLOSE_CURSOR(cursor_handle);
	leftpath := substr(leftpath,position + 1);
	if ( position =0 ) then
	   lastpath := true;
	else
	   position := instr(leftpath,'&');
	end if;
	end loop;

	htp.p('<center>');
 	if (prev_str IS NOT NULL) then
		htp.p('['||url(root_url||'/apollosearch.header_list?keyword='||key
                ||'&total='||total||'&seed='||prev||'&qid='||qid||'&dpath='||oldpath, 'Prev')||']');
	end if;
	htp.p(' p.');
	n := ceil(total/hits);
	if (n > 20) then n := 20; end if;
	for i in 1..n loop
		iseed := (i-1)*hits + 1;
		if (iseed = seed) then
			htp.p(' '||i);
		else
			htp.p(' '||url(root_url||'/apollosearch.header_list?keyword='||key
                ||'&total='||total||'&seed='||iseed||'&qid='||qid||'&dpath='||oldpath,i));
		end if;
	end loop;
	if (seed < ((n-1)*hits+1)) then
		htp.p('['||url(root_url||'/apollosearch.header_list?keyword='||key
                ||'&total='||total||'&seed='||next||'&qid='||qid||'&dpath='||oldpath,'Next')||']');
        end if;
	htp.p('</center>');
	wow.sig;
	htp.p('</TD></TR></TABLE></HTML>');
  end;

procedure header_output(keyword varchar2, document varchar2) is
begin
	htp.p('<HTML><head><title>Apollo Search</title></head>');
	htp.p('<body bgcolor="#ffffff">');
	--htp.p('<TABLE><TR><TD WIDTH=24px><IMG SRC="'||server_name||'search.old.gif" WIDTH=24 HEIGHT=24></TD><TD>');
	
	htp.p('<form method="GET" action="'||root_url||'/apollosearch.start1">');
	htp.p('<center><table><tr><td><IMG SRC="'||server_name||'search.old.gif"></td><td>');
	htp.p('<b>Keyword</b><INPUT NAME=keyword size=40 maxlength=200 VALUE="'||keyword||'">');
	htp.p('<INPUT TYPE="submit" VALUE="Go">');
	--htp.p('<INPUT TYPE="reset" VALUE="Clear">');
	--htp.p('<input TYPE="button" OnClick="top.right.location='''||server_name||'help.html''" value="Help">');
	htp.p('<a href="'||server_name||'help.html">Help</a>');
	htp.p('<INPUT TYPE="hidden" NAME="document" VALUE="'||document||'">');
 	htp.p('</FORM></CENTER></td></tr></table></center>');
	
end;	

end apollosearch;
/
show errors;
/

