/*
** Update a look up table row
** Class: UpdateRow
** Author: Yuping Zhu
** Date: 04-09-1999
*/

package ascdb.admin;

// import package java.sql to use JDBC
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.conf;
import ascdb.pub.UserCheck;
import java.text.Collator;

public class UpdateRow extends HttpServlet {
     public void doPost(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
	// Output HTML page header+ name + "'"
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();
	conf dbconf = new conf(req);
	String me = req.getParameter("me");
	UserCheck u = new UserCheck(me);
	String TableName = req.getParameter("TName");
	String name = req.getParameter("name");
	String Id = req.getParameter("id");
	String code;
	String Cap;
	
	try {
	   if (u.UserRole(1) != 0)
	   {
		out.println(u.userid + "! You have no this privilege!");
		return;
	   }
	   // Load the Oracle JDBC driver
	   Class.forName (dbconf.JdbcDriver);
	
	   // Connect to the database
 	   Connection conn =
    		DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);

	   // Create a Statement
	   Statement stmt = conn.createStatement ();
	    
	   Collator cl = Collator.getInstance();
	   String SetClause = " set surtitle = '" + name + "' where surtitle = '";
	   code = name;
	   Cap = "surtitle";
	   if (cl.equals(TableName,"v_states"))
	   {
		Cap = "state";
		code = req.getParameter("code");
		SetClause = " set state = '" + code + "',state_nam = '" + name + "' where state ='";
	   }
	   else if (cl.equals(TableName,"v_countries"))
	   {
		Cap = "country";
		code = req.getParameter("code");
	 	SetClause = " set country_abbr = '" + code + "',country_nam = '" + name + "' where country_abbr = '";
	   }
	   String UpdateString = "update " + TableName + SetClause + Id + "'";
	   int rcount = stmt.executeUpdate(UpdateString);

	   if (rcount == 1)
		out.println(Id + " has been updated by a new " + Cap + " " + code);
	   else
		out.println("Error: " + UpdateString);
	
	   }
	   catch(ClassNotFoundException e) {
                 out.println("Couldn't load database driver: " + e.getMessage());
           }
           catch (SQLException e) { 
                out.println(e.getMessage());
           }
	   catch(Exception e) {
		out.println(e.getMessage());
	   }
   }
}  