/*
** Cancel Registration of Class
** Class: CancelRegister
** Author: Yuping Zhu
** Date: 02-02-2000
*/

package ascdb.classes;

//import package java.sql to use JDBC
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;

import java.io.*;
import ascdb.conf;
import ascdb.users.UserValidation;

public class CancelRegister extends HttpServlet {
    public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException
    {
    // Output HTML page header
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();
    conf dbconf= new conf(req);
    String uid = req.getParameter("uid");
    String cid = req.getParameter("cid");
    int ClassId = (new Integer(cid)).intValue();
    UserValidation UserV = new UserValidation();

    try {
	int TabRow = UserV.Validation(req);
	if (TabRow < 4)
	   {
		out.println("Sorry! You do not have this priviledge!");
		return;
	   }
	 // Load the Oracle JDBC driver
	 Class.forName (dbconf.JdbcDriver);

	 // Connect to the database
	 Connection conn =
		DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
	
	 // Create a Statement
	 Statement stmt = conn.createStatement ();
	 
	 int count = stmt.executeUpdate("delete from class_students where student_uid = '" + uid + "'");
	 if (count == 1)
	    out.println("You have cancelled your registration!");
	 else
	     out.println("You did not register the class!");
	 out.println("<form method=\"POST\" action=\"ascdb.users.FrontPage\">");
	 out.println("<input type=hidden name=\"uid\" value=\"" + uid + "\">");
	 out.println("<input type=submit name=\"submit\" value=\"Back To Main Menu\">");
	 out.println("</form>");
    }
    catch (ClassNotFoundException e) {
	  out.println("Can not load JDBC driver: " + e.getMessage());
    }
    catch (SQLException e) {
	  out.println(e.getMessage());
    }
    catch (Exception e) {
	  out.println(e.getMessage());
    }
    }
}
		 

	
