/*
** Add new Course information into table  from administrator input
** Class: AddCourse
** Author: Yuping Zhu
** Date: 12-01-1999
*/

package ascdb.courses;

import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.users.UserValidation;
import ascdb.conf;

public class AddCourse extends HttpServlet {
    public void doPost(HttpServletRequest req, HttpServletResponse res)
                throws ServletException, IOException
    {
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();
    conf dbconf = new conf(req);
    UserValidation UserV = new UserValidation();
    
    try {
	//Load JDBC Driver
	Class.forName(dbconf.JdbcDriver);
	// Connect to DB
	Connection conn =
	    DriverManager.getConnection(dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
	// Create a statement
	Statement stmt = conn.createStatement ();

	// Get the course_id from seg
	ResultSet IdSeq = stmt.executeQuery ("select courses_seq.nextval from dual");
	int CourseId = 0;
	if (IdSeq.next ())
	    CourseId = IdSeq.getInt(1);
	
	// insert course informtaion into table catalog
	String CourseStr = "insert into catalog values ("
	                   + CourseId + ",'"
                           + req.getParameter("courseNum") + "','"
                           + req.getParameter("tit") + "','"
	                   + req.getParameter("overview") + "','"
	                   + req.getParameter("days") + "','"
	                   + req.getParameter("agenda") + "','"
	                   + req.getParameter("prereq") + "','"
	                   + req.getParameter("size") + "','Y')";

	int count1 = stmt.executeUpdate(CourseStr);
	out.println("<body bgcolor=white>");
	if (count1 == 1)
	    out.println("A new Catalog record has been created!");
	else
	    out.println("Can not create Course record!");
	out.println(BackHome(req.getParameter("uid")));
	}
    catch(ClassNotFoundException e) {
	out.println("Can not load JDBC driver!");
    }
    catch(SQLException e) {
         out.println(e.getMessage());
    }
    }

    private String BackHome(String uid)
    {
	StringBuffer StrBuf = new StringBuffer(1500);
	StrBuf.append("<form method=\"POST\" action=\"ascdb.users.FrontPage\">\n");
	StrBuf.append("<input type=hidden name=\"uid\" value=\"" + uid + "\">\n");
	StrBuf.append("<input type=submit name=\"submit\" value=\"Back Menu\">\n");
	String BackStr = new String(StrBuf);
	return BackStr;
    }
}
	
