/*
** Accept user's registration and put the information into DB
** Class: InsertUser
** Author: Yuping
** Date: 03-16-1999
**
** Modified Date: 04-06-1999
** 		  Add to modify a user information 
*/

package ascdb.pub;

//import package java.sql to use JDBC
import java.sql.*;

// import package java.util.Date to get current time
import java.util.Date;
import java.text.Collator;

//import package javax.servlet.http to get URL parameters
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import ascdb.conf;

public
class TestInsertUser extends HttpServlet
{
public void doGet(HttpServletRequest req, HttpServletResponse res)
   throws ServletException, IOException
{
// Output HTML page header
res.setContentType("text/html");
PrintWriter out = res.getWriter();
conf dbconf = new conf(req);

// Pick up all URL parameters

try {

String passwd1 = req.getParameter("passwd1");
String passwd2 = req.getParameter("passwd2");
String pass = "N";
if (passwd1 != null)
	pass =  "Y";

Collator myCollator = Collator.getInstance();
if (myCollator.compare(passwd1,passwd2) != 0)
{
out.println("Your Password Confirm is not the same as your password input! Please Input again!");
return;
} 

String me= "N/A";
String u = "N/A";
int op = (new Integer(req.getParameter("op"))).intValue();
if (op == 1)
{
	me = req.getParameter("me");
	u = req.getParameter("db_uid");
}

/*String uid = req.getParameter("db_uid");
String lName = req.getParameter("lastname");
int LastNameLen = lName.length();

if (LastNameLen > 3)
   LastNameLen = 3;
String db_uid = lName.substring(0,LastNameLen) + uid;
*/

String fName =  req.getParameter("firstname");
String mName =  req.getParameter("middlename");
String inst =  req.getParameter("institution");
String sub =  req.getParameter("submitter");

//Date currentTime = new Date();
//String currtimestr = currentTime.toString();
//DateFormat df = DateFormat.getDateTimeInstance(DateFormat.LONG,DateFormat.LONG);
//String currtimestr = df.format (currentTime);

String msrc = req.getParameter("msrc");
String tit =  req.getParameter("surtitle");
String c_ship =  req.getParameter("citizenship");
String company =  req.getParameter("company");
String c_us =  req.getParameter("us_company");
String univ =  req.getParameter("university");
String cont =  req.getParameter("contractor");
String forei =  req.getParameter("foreign");
String asylum =  req.getParameter("asylum");
String greencard =  req.getParameter("greencard");
String temp =  req.getParameter("temporary");
String perm =  req.getParameter("permanent");
String refugee =  req.getParameter("refugee");
String org =  req.getParameter("org");
String pur =  req.getParameter("purpose");
String spon =  req.getParameter("sponsor");
String pos =  req.getParameter("position");
String poc =  req.getParameter("poc");
String myreq =  req.getParameter("require");

// Pick up user's address informaion

String addr = req.getParameter("address");
String u_city = req.getParameter("city");
String u_state =  req.getParameter("state");
String u_zip =  req.getParameter("zip");
String u_country =  req.getParameter("country");
String ph =  req.getParameter("phone");
String ext =  req.getParameter("ext");
String alt = req.getParameter("alt_phone");
String fax = req.getParameter("fax");
String email =  req.getParameter("email");
String bldg =  req.getParameter("bld_addr");
String pocn =  req.getParameter("pocn");
String alt_poc =  req.getParameter("alt_poc");

int db_role = (new Integer(req.getParameter("db_role"))).intValue();

// Load the Oracle JDBC driver
Class.forName (dbconf.JdbcDriver);
	
// Connect to the database
Connection conn =
    DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);

// Create a Statement
Statement stmt = conn.createStatement ();

// Get user ID from users_seq
ResultSet UserIdrset = stmt.executeQuery("select users_seq.nextval from dual");
String uid = null;

if (UserIdrset.next())
    uid = UserIdrset.getString(1);

UserIdrset.close();
/*
String lName = req.getParameter("lastname");
int LastNameLen = lName.length();

if (LastNameLen > 3)
   LastNameLen = 3;
String db_uid = lName.substring(0,LastNameLen) + uid;*/


//System.out.println("Content-type: text/html\n\n");
out.println("<body bgcolor= \"#fffff2\">");
out.println(uid);

// Insert user information into DB

/*int rcount1;
if (op == 0)
	rcount1 = stmt.executeUpdate ("insert into users (oracle_uid,institution,submitter,create_date,valid_user,first_nam,last_nam,middle_nam,surtitle,citizenship,company_nam,us_or_foreign,univ_nam,contractor,foreign_national,asylum_num,green_card_num,temp_res_num,perm_res_num,refugee_num,organization,passwd_received,purpose,spons_agency_uid,position,poc_uid,special_reqs) values ('" + db_uid +"','" + inst + "','" + sub + "',sysdate,'" + msrc + "','" + fName +"','" + lName + "','" + mName + "','" + tit + "','" + c_ship + "','" + company +"','" + c_us + "','" + univ +"','" + cont + "','" + forei + "','" + asylum + "','" + greencard + "','" + temp + "','" + perm + "','" + refugee + "','" + org + "','" + pass + "','" + pur + "','" + spon + "','" + pos + "','" + poc + "','" + myreq + "')");

else 
	rcount1 = stmt.executeUpdate ("update users set institution = '" + inst + "',submitter = '" + sub + "',modified_date=sysdate,valid_user='" + msrc + "',first_nam='" + fName + "',last_nam='" + lName + "',middle_nam='" + mName + "',surtitle='" + tit + "',citizenship='" + c_ship + "',company_nam='" + company +"',us_or_foreign='" + c_us + "',univ_nam='" + univ +"',contractor='" + cont + "',foreign_national='" + forei + "',asylum_num='" + asylum + "',green_card_num='" + greencard + "',temp_res_num='" + temp + "',perm_res_num='" + perm + "',refugee_num='" + refugee + "',organization='" + org + "',passwd_received='" + pass + "',purpose='" + pur + "',spons_agency_uid='" + spon + "',position='" + pos + "',poc_uid='" + poc + "',special_reqs='" + myreq + "',modified_uid='" + me 
+ "' where oracle_uid = '" + u + "'");*/

//out.println("rcount1=" + rcount1);

/*int rcount2;
if (op == 0)
	rcount2 = stmt.executeUpdate ("insert into addresses values ('" + db_uid + "','" + addr + "','" + u_city + "','" + u_state + "','" + u_zip + "','" + u_country + "','" + ph + "','" + ext + "','" + alt + "','" + fax + "','" + email + "','" + bldg + "','" + pocn + "','" + alt_poc + "')");
else
	rcount2 = stmt.executeUpdate ("update addresses set address='" + addr + "',city='" + u_city + "',state='" + u_state + "',zip='" + u_zip + "',country='" + u_country + "',phone='" + ph + "',phone_ext='" + ext + "',alt_phone='" + alt + "',fax='" + fax + "',email='" + email + "',bldg_address='" + bldg + "',poc='" + pocn + "',alt_poc='" + alt_poc + "' where id = '" + u + "'");
*/
//out.println("rcount2=" + rcount2);
/*
int rcount3;
if ( op == 0)
	rcount3 = stmt.executeUpdate ("insert into db_users values ('" + db_uid + "','" + passwd1 + "'," + db_role + ")");
else
	rcount3 = stmt.executeUpdate ("update db_users set passwd='" + passwd1 + "',role=" + db_role + "where db_id = '" + u + "'");*/

//out.println("rcount3=" + rcount3);
/*
if ((rcount1 == 1) & (rcount2 == 1) & (rcount3 == 1))
    if ( op == 0 )
	out.println("Thank you, " + fName + " " + mName + " " + lName + ". You have registered as ASC Training user: " + db_uid + ". After you are approved, we'll inform you!");
    else
	out.println(uid + "'s information has been updated!");
else
   out.println("Something Wrong!---" + rcount1 +":" +  rcount2 + ":" + rcount3 + "uid:" + db_uid);*/
}
catch (ClassNotFoundException e) {
	out.println("Can not load JDBC driver: " + e.getMessage());
}
catch (SQLException e) {
	out.println(e.getMessage());
}
}
}
