/*
** This is top level of index
** Class: TopIndex
** Author: Yuping Zhu
** Date: 03-19-1999
*/

package ascdb.admin;
//import package oracle.html to generate HTML page
import oracle.html.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.conf;

public class TopIndex extends HttpServlet {
   public void doGet(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
	// Output HTML page header
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();
	conf dbconf = new conf(req);
	
	String uid = req.getParameter("me");
	// Create the HTML Page head
	HtmlHead hd = new HtmlHead("Training DB Top Index");
	
	// Create an HtmlBody Object
        HtmlBody bd = new HtmlBody();

        // Sets various attributes of HtmlBody
        bd.setBackgroundColor(Color.orange);

        // Creates an HtmlPage object using hd and bd
        HtmlPage hp = new HtmlPage(hd, bd);

//	bd.addItem(new SimpleItem("Training DB").setCenter().setBold().setFontColor(Color.black));
	bd.addItem(new Image(dbconf.ImageBase + "pet.gif","PET",IVAlign.TOP,false).setCenter());
	bd.addItem(SimpleItem.LineBreak);
//	bd.setFollowedLinkColor(Color.red);
bd.setUnfollowedLinkColor(Color.white);


	bd.addItem(new Link("ascdb.admin.CourseIndex?me=" + uid,"Courses").setBold().setFontSize(4))
	  .addItem(SimpleItem.LineBreak)
	  .addItem(new Link("ascdb.admin.ClassIndex?me=" + uid,"Classes").setBold().setFontSize(4))
	  .addItem(SimpleItem.LineBreak)
	  .addItem(new Link("ascdb.admin.UserIndex?me=" + uid, "Users").setBold().setFontSize(4))
	  .addItem(SimpleItem.LineBreak)
	  .addItem(new Link("ascdb.admin.EvaluateIndex?me=" + uid, "Evaluations").setBold().setFontSize(4))
	  .addItem(SimpleItem.LineBreak)
	  .addItem(new Link("ascdb.admin.LookupIndex?me=" + uid, "LookUp Tables").setBold().setFontSize(4))
	  .addItem(SimpleItem.LineBreak)
	  .addItem(new Link("ascdb.pub.Help?", new SimpleItem("Help"),"content").setBold().setFontSize(4));
/*
  	MenuList menulist = new MenuList();
	menulist.addItem(new SimpleItem("Menu Item 1"))
          	.addItem(new SimpleItem("Menu Item 2"));
	bd.addItem(menulist);
	
	DirectoryList drl = new DirectoryList();
  drl.addItem(new SimpleItem("Dir1"));
  drl.addItem(new SimpleItem("Dir2"));
  drl.addItem(new SimpleItem("Dir3"));
	bd.addItem(drl);

	Container dterms = new Container();
  dterms.addItem(new SimpleItem("DefTerm1.1"));
  dterms.addItem(new SimpleItem("DefTerm1.2"));
  DefinitionList dl = new DefinitionList();
 
  dl.addDef(dterms, new SimpleItem("Definition1"));

	bd.addItem(dl);



	DefinitionList dl = new DefinitionList();
	dl.addDef( new SimpleItem("Term1"),
             new SimpleItem("Definition1"));
  	Container dt2 = new Container();
  	dt2.addItem(new SmpleItem("Term2.1"));
  	dt2.addItem(new SimpleItem("Term2.2"));
  	dll.addDef( dt2, new SimpleItem("Definition2"));
  	bd.addItem(dll);*/

	out.println(hp);
   }
}