/*
** List all new users for verify
** Class: VerifyUser
** Author: Yuping Zhu
** Date: 11-04-1999
** Modified by Yuping Zhu on 03-09-2000
*/

package ascdb.admin;

import oracle.html.*;
import java.sql.*;
import java.io.*;

import javax.servlet.*;
import javax.servlet.http.*;

import ascdb.users.UserValidation;
import ascdb.conf;


public class VerifyUser extends HttpServlet
{
    private conf dbconf;
    private String me;
    private String op;
    private String OpType;
    private String TypeIn="";
 
    public void doGet(HttpServletRequest req, HttpServletResponse res)
           throws ServletException, IOException
    {
	res.setContentType("text/html");
	PrintWriter out = res.getWriter();
	OpType = req.getParameter("type");
	if (! OpType.equals("0"))
	    TypeIn = req.getParameter("nam");
        me = req.getParameter("uid");
	op = req.getParameter("op");
	
	try {
	    UserValidation UserV = new UserValidation();
	
	    if (UserV.Validation(req) != 7)
	    {
		out.println("You do not have this privillege!");
		BackMainHome();
		return;
	    }

	    dbconf = new conf(req);
	    out.println(SearchButton());
	    out.println(UserList());
	    BackHome();
	}
	catch (ClassNotFoundException e) {
	    out.println("Can not load JDBC Driver!");
	}
	catch (SQLException e) {
	    out.println(e.getMessage());
	}
    }
    
    private HtmlStringBuffer SearchButton()
    {
	HtmlStringBuffer hd = new HtmlStringBuffer();
	hd.appendln("<html><head><center>");
	hd.appendln("<title>Verify new TMD User</title>");
	hd.appendln("<body bgcolor=white>");
        hd.appendln("<form method=\"GET\" action=\"ascdb.admin.VerifyUser\">");
	hd.appendln("<font color=red size =+2>Input:  </font>");
	if (TypeIn.equals(""))
	   hd.appendln("<input type=text name=\"nam\" value=\"\" size=30>");
	else
	   hd.appendln("<input type=text name=\"nam\" value=\"" + TypeIn + "\" size=30>");
       	hd.appendln("<br><font size=+1>Search By: ");
        hd.appendln("<select name=\"type\">");
       
      	if (OpType.equals("0"))
	    hd.appendln("<option value=\"0\" selected>All new");
	else
	    hd.appendln("<option value=\"0\">All new");
	if (OpType.equals("3"))
	    hd.appendln("<option value=\"3\" selected>All");
	else
	    hd.appendln("<option value=\"3\">All");
	
      	if (OpType.equals("1"))
	    hd.appendln("<option value=\"1\" selected>Last Name");
	else
	    hd.appendln("<option value=\"1\">Last Name");
	
	if (OpType.equals("2"))
	    hd.appendln("<option value=\"2\" selected>First Name");
	else
	    hd.appendln("<option value=\"2\">First Name");
	hd.appendln("</select>");    
        hd.appendln("<input type=hidden name=\"op\" value=\"" + op + "\">");
	hd.appendln("<input type=hidden name=\"uid\" value=\"" + me + "\">");
        hd.appendln("<input type=submit name=submit value=\"Go!\">");
	hd.appendln("</font></form>");
	hd.appendln("<img src=\"" + dbconf.ImageBase + "/wavy.gif\"><p>");
        return hd;
    }
	
    private HtmlStringBuffer UserList()
            throws ClassNotFoundException, SQLException
    {
	// Load the Oracle JDBC driver
	Class.forName (dbconf.JdbcDriver);

	// Connect to the database
	Connection conn =
		DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
	
	// Create a Statement
	Statement stmt = conn.createStatement ();
	
	//Generate query String
	// change for verify new user nomatter student or instructor
	/*String pur = "Student";	
	if (op.equals("2"))
	pur = "Instructor";*/

	//	String QueryStr = " from users where approved_date IS NULL";
	String QueryStr = " from users";
	if (OpType.equals("0"))
	    QueryStr = QueryStr + " where approved_date IS NULL";
	if (OpType.equals("1"))
	    QueryStr = QueryStr + " where last_nam='" + TypeIn + "'";
	else if (OpType.equals("2"))
	    QueryStr = QueryStr + " where first_nam='" + TypeIn + "'";

      	//QueryStr = QueryStr + " order by last_nam asc";
        
        ResultSet count = stmt.executeQuery("select count(*)" + QueryStr);
	int tot = 0;
	if(count.next())
	    tot = count.getInt(1);

	HtmlStringBuffer UserTab = new HtmlStringBuffer();

	if (tot == 0)
	{
	    UserTab.appendln("No new Registrant need to be verified!");
	    return UserTab;
	}
	
	UserTab.appendln("<font size=+1>All you searched new registrant need to be verified!</font>");

	ResultSet rset = stmt.executeQuery("select oracle_uid,last_nam,first_nam,user_status" + QueryStr + " order by last_nam asc");
	
	UserTab.appendln("<table bgcolor = #00ffff cellspacing =2 cellpadding=5 frame=LHS rules=all><center>");
	UserTab.appendln("<tr><th>User ID</th><th>Last Name</th><th>First Name</th><th>User Status</th> </tr>");

	while (rset.next())
	    UserTab.appendln("<tdr><td><a href=\"ascdb.users.DoVerifyUser?uid=" + me + "&u=" + rset.getString(1) + "&op=" + op + "\">" + rset.getString(1) + "</a></td><td>" + rset.getString(2) + "</td><td>" + rset.getString(3) + "</td><td>" + rset.getString(4) + "</td></tr>");

	UserTab.appendln("</table></center>");
	return UserTab;
    }

    private HtmlStringBuffer BackHome()
    {
	HtmlStringBuffer Back = new HtmlStringBuffer();
	Back.appendln("<form method=\"POST\" action=\"ascdb.users.FrontPage\">");
	Back.appendln("<input type=hidden name=\"uid\" value=\"" + me + "\">");
	Back.appendln("<input type=submit name=\"submit\" value=\"Back To Menu\">");
	return Back;
    }

    private HtmlStringBuffer BackMainHome()
    {
	HtmlStringBuffer BackMain = new HtmlStringBuffer();
	BackMain.appendln("<form method=\"GET\" action=\"ascdb.users.WelcomePage\">");
	BackMain.appendln("<input type=submit name=\"submit\" value=\"Back Main Menu\">");
       return BackMain;
    }
}
	    
