/*
** Put verify information into DB
** Class: DoneVerifyClass
** Author: Yuping Zhu
** Date: 04-13-2000
*/

package ascdb.classes;

import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.conf;

public class DoneVerifyClass extends HttpServlet{
    public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException
    {
    // Output HTML page header
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();
    conf dbconf= new conf(req);
    String uid = req.getParameter("uid");
    String cid =req.getParameter("cid");
    String courseId = req.getParameter("csid");
    String op = req.getParameter("op");

    try {
	// Load the Oracle JDBC driver
   	Class.forName (dbconf.JdbcDriver);

	// Connect to the database
     	Connection conn =
          DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
	
	// Create statement
	Statement stmt = conn.createStatement ();

	String fg = "N";
	if (op.compareTo("0") == 0)
	    fg ="V";

	String classStr = "update classes set class_start_date=to_date('"
	    + req.getParameter("start_date") + "','mm/dd/yyyy'),class_size='"
	    + req.getParameter("size") + "',room='"
	    + req.getParameter("room") + "',city='"
	    + req.getParameter("city") + "',state='"
	    + req.getParameter("state") + "',building='"
	    + req.getParameter("building") + "',system_use='"
	    + req.getParameter("system") + "',student_materials='"
	    + req.getParameter("stuff") + "',tape='"
	    + req.getParameter("tape") + "',webhost='"
	    + req.getParameter("web") + "',class_type='" 
	    + fg + "'";
	
	if ((req.getParameter("copres")).compareTo("Y") == 0)
	    classStr = classStr + ",copresentor='"
		+ req.getParameter("copres") + "',copresentor_names='"
		+ req.getParameter("copresex") + "'";
 
	classStr = classStr + " where class_id='" + cid + "'";

	int count1 = stmt.executeUpdate(classStr);
	
	String courseStr = "update catalog set course_num ='"
	    + req.getParameter("num") + "',title='"
	    + req.getParameter("tit") + "',overview='"
	    + req.getParameter("overview") + "',duration='"
	    + req.getParameter("days") + "',agenda='"
	    + req.getParameter("agenda") + "',prerequisites='"
	    + req.getParameter("description") + "',class_size='"
	    + req.getParameter("size")
	    + "',catalog_type='N' where course_id='" + courseId + "'";

      	int count2 = stmt.executeUpdate(courseStr);

	// maybe need to update instructor's info.
      	if ((count1 == 1) && (count2 == 1))
	    //    if (count1 == 1)
	{
	    if (op.compareTo("0") == 0)
		out.println("Class " + cid + " has been verified!");
	    else
		if (op.compareTo("1") == 0)
		    out.println("Class " + cid + " has been posted!");
		else
		    out.println("Class " + cid + " has been changed!");
	    String BackAction = "ascdb.classes.ClassList";
	    if (op.compareTo("0") == 0)
		BackAction = "ascdb.admin.VerifyClass";

	    out.println("<form method=\"GET\" action=\"" + BackAction + "\">");
	    out.println("<input type=hidden name=\"uid\" value=\"" + uid + "\">");
	    if (op.compareTo("0") == 0)
		out.println("<input type=hidden name=\"op\" value=\"1\">");
	    else
		if (op.compareTo("1") == 0)
		    out.println("<input type=hidden name=\"op\" value=\"4\">");
	        else
		    out.println("<input type=hidden name=\"op\" value=\"5\">");
	    out.println("<input type=submit name=\"submit\" value=\"Back To Class List\">");
	    out.println("</form>");
	    out.println("<form method=\"POST\" action=\"ascdb.users.FrontPage\">");
	    out.println("<input type=hidden name=\"uid\" value=\"" + uid + "\">");
	    out.println("<input type=submit name=\"submit\" value=\"Back To Main Menu\">");
	    out.println("</form>");
	}
       
    }
    catch(ClassNotFoundException e) {
	out.println("Can not load JDBC driver: " + e.getMessage());
    }
    catch(Exception e) {
	out.println(e.getMessage());
    }
    }
}
	   
