/*
** Validate the user's userid/password, generate frame with menu
** Class: FrontPage
** Author: Yuping Zhu
** Date: 03-18-1999
*/
package ascdb.pub;

//import oracle.html.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.pub.UserCheck;

public class FrontPage extends HttpServlet {

    public void doPost(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
	// Output HTML page header
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();

   try{
  	// Check user's userid/passwd
        String uid = req.getParameter("uid");
	String passwd = req.getParameter("passwd");
//	out.println(uid + passwd);
	
	UserCheck user = new UserCheck(uid, passwd,req);
	int v_user = user.validUser();

//	out.println(user.userid + user.passwd + user.dbrole + user.fuserid + v_user);
	user.ToFuid();
	String str = user.fuserid;
	
//	out.println(str);
	
	if (v_user == 0)
	  {
	   out.println("You are not a valid user or wrong password!");
	   return;
	  }
	else if (v_user == -1)
	  {
	   out.println("You are not approved yet, please try later!");
	   return;
	  }

	// Create the HTML Page head
//	HtmlHead hd = new HtmlHead("Training DB Front Page");
	
  	// Create frames
/*	Frameset frameset = new Frameset();
	frameset.setCols("20%,80%");

	Frame frames[] = new Frame[2];

	frames[0] = new Frame("ascdb.admin.TopIndex?me=" + str,"index");
	frames[1] = new Frame("ascdb.pub.PublicPage?op=0&me=u","content");
	for (int i=0; i<2; i++) {
		frames[i].setMarginWidth(0);
		frames[i].setMarginHeight(0);
		frameset.addFrame(frames[i]);
	}

	// generate HTML page
	HtmlPage hp = new HtmlPage(hd,frameset);
	out.println(hp);
*/
	out.println("<HTML>");
	out.println("<FRAMESET  COLS=\"20%,80%\">");
	out.println("<FRAME SRC=\"ascdb.admin.TopIndex?me=" + str + "\" NAME = \"index\" SCROLLING=\"auto\" BORDER=0>");
	
	out.println("<FRAME SRC=\"ascdb.pub.PublicPage?op=0&me=u\" NAME = \"content\" SCROLLING=\"auto\" BORDER=0>");
	out.println("</FRAMESET>");
	out.println("</HTML>");
	}
	catch (Exception e) {
		out.println(e.getMessage());
	}
    }
  public void doGet(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {doPost(req,res);}
	
}

	
	
 