/*
** This is uer login page for Training System
** Class: LoginPage
** Author: Yuping Zhu
** Date: 03-16-1999
*/

package ascdb.pub;

import oracle.html.*;
import javax.servlet.*;
import javax.servlet.http.*;

import java.io.*;
import ascdb.conf;

public class LoginPage extends HttpServlet {

    public void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
	{
	
        // Output HTML page header
        res.setContentType("text/html");
	PrintWriter out = res.getWriter();
	conf dbconf= new conf(req);
	
 	// Creates an HtmlHead Object
	HtmlHead hd = new HtmlHead("Training System Welcome Page");
	
        // Create an HtmlBody Object
	HtmlBody bd = new HtmlBody();

	// Sets various attributes of HtmlBody
    	bd.setBackgroundColor("#fffff2");

	// Creates an HtmlPage object using hd and bd
	HtmlPage hp = new HtmlPage(hd, bd);

 	hp
	  .addItem(new Image(dbconf.ImageBase + "pet.gif").setCenter())
          .addItem(SimpleItem.Paragraph)
	  .addItem(new Image(dbconf.ImageBase + "wavy.gif").setCenter())
	  .addItem(new SimpleItem("This System is for authorized users only, you should have a Training System account to login").setCenter().setBold().setFontColor(Color.red).setItal())
	  .addItem(new Image(dbconf.ImageBase + "wavy.gif").setCenter())
	  .addItem(SimpleItem.Paragraph);
	
//	Font f = new Font(Color.olive,null,"+1");
//	bd.addItem(new SimpleItem(f.toHTML()));
	Form frm = new Form("POST","ascdb.users.FrontPage");
        frm
	   .addItem(new SimpleItem("User  ID: ").setBold().setFontColor(Color.olive))
           .addItem(new TextField("uid",30,20,""))
	   .addItem(SimpleItem.LineBreak)
	   .addItem(new SimpleItem("Password: ").setBold().setFontColor(Color.olive))
           .addItem(new PasswordField("passwd0",30,19,""))
//	   .addItem(new TextField("passwd",30,19,""))
           .addItem(SimpleItem.Paragraph)
	   .addItem(new Submit("submit", "Login System").setBold().setFontColor(Color.olive));
	
	bd.addItem(frm.setCenter());
	
	out.println(hp);

}
}
	
	
