drop sequence classes_seq;
create sequence classes_seq increment by 1;

drop sequence courses_seq;
create sequence courses_seq increment by 1;

drop sequence users_seq;
create sequence users_seq increment by 1;

drop sequence domain_seq;
create sequence domain_seq increment by 1;

drop sequence address_seq;
create sequence address_seq increment by 1;

drop trigger domain_tr;
create trigger domain_tr before insert on domain
	for each row
	declare n integer;
	begin
		select domain_seq.nextval into n from dual;
		:new.domain_id := n;
	end;
/
