drop package MAILS0;
/
create or replace package MAILS0 is

  mailbox_name constant varchar2(50) := 'Chemistry Mailing and Newsgroup';
  mailbox_path constant varchar2(50) := 'NNTP server: newstand.syr.edu';
  mailbox_logo constant varchar2(50) := '/images/mailbox.gif';
  inbox_path constant varchar2(50) := mailbox_path||'/inbox';
  inbox_logo constant varchar2(50) := mailbox_logo;
  owner_uid constant varchar2(10) := 'chem';
  cgi_bin1 constant varchar2(30) := '/cgi-bin/'||owner_uid||'/';
  cgi_bin constant varchar2(30) := '/cgi-bin/'||owner_uid||'/wow/';
  owner_name constant varchar2(20) := owner_uid;
  username constant varchar2(10) := owner_uid;
  password constant varchar2(20) := 'npac'||owner_uid;
  maxmsg constant number(8) := 1000000;
  my_url  constant varchar2(50) := '/'||owner_uid||'/index.html';
  root_url constant varchar2(50) := 'http://osprey8.npac.syr.edu:8080';
  default_folder folder.name%TYPE := 'chemistry';
  --parallel_servers constant integer := 4;
  procedure home;

  end;
/
show errors;
/
create or replace package body MAILS0 is

procedure home is
--  host1 varchar2(40) := 'http://merlin';
  --host1 varchar2(40) := 'http://128.230.3.';
  host varchar2(60);
  --instance_id integer := 9;
  dot varchar2(40) := '<IMG ALT="*" SRC="/images/dot.gif">';
begin
		--select instance.nextval into instance_id from dual;
		--host1 := host1||(mod(instance_id,parallel_servers)+9)||'.npac.syr.edu';
		--host1 := host1||(2*mod(instance_id,parallel_servers)+39);
		--host := host1||cgi_bin;
		host := root_url||cgi_bin;
		htp.p('<title>Chemistry Mailing and Newsgroup Database</title>');
		htp.p('<center><h1>Chemistry Mailing and Newsgroup Database</h1>');
		htp.p('<p><h2>'||dot||htf.url_top(host||'MAILS.index_subject',
			'Query By Keyword')||dot||'</h2>');
		htp.p('<p><h2>'||dot||
			htf.url_top(host||'MAILS.showheader',
			'Query By Mail Header')||dot||'</h2>');
		htp.p('<p><h2>'||dot||
			htf.url_top(host||'MAILS1.index_date',
			'Query By Date')||dot||'</h2>');
		htp.p('<p><h2>'||dot||
			htf.url_top(host||'MAILS.index_sender',
			'Query By Sender')||dot||'</h2>');
		htp.p('<p><h2>'||dot||
			htf.url_top(host||'MAILS4.index_url',
			'Query the URLs')||dot||'</h2>');

		htp.p('<p><h2>'||dot||
			htf.url_top(host||'MAILS.index_people',
			'Query the People')||dot||'</h2>');

		htp.p('<p><h2>'||dot||
			htf.url_top(host||'MAILS.showfolders',
			'Newsgroups Info')||dot||'</h2>');

		htp.p('<p><h2>'||dot||
			htf.url(host||'MAILS.showmailbox',
			'Archive Database Info')||dot||'</h2>');
		htp.p('<p><h2>'||dot||
			htf.url_top(host||cgi_bin1||'hypermail_home',
			'A Hypermail-like Interface')||dot||'</h2>');

		htp.p('<p><h2>'||dot||
			htf.url_top(host||cgi_bin1||'index_chat',
			'Your Feedback')||dot||'</h2>');

		htp.p('</center><hr>');

		htp.p('<address>This system is developed by '||
			htf.url_top('http://www.npac.syr.edu/homepages/gcheng/gcheng.html',
			'Gang Cheng'));
		htp.p(' at '||htf.url_top('http://www.npac.syr.edu/','Northeast Parallel Architectures Center'));
		htp.p(', Syracuse University. Send comment to '||
			htf.url('mailto:gcheng@npac.syr.edu','gcheng@npac.syr.edu')||'. Read ');
		htp.p(htf.url('/disclaim.html','NPAC Disclaimer')||'.</address></html>');
	end;
end;
/
show errors;
/
