if (!defined &__SYS_TPI_SOCKET_H__) {
    if (!defined &_SYS_SOCKET_H_) {
	eval 'sub _SYS_SOCKET_H_ {1;}';
	if (defined &__cplusplus) {
	}
	#require 'sys/bsd_types.ph';
	if (!defined &NC_TPI_CLTS) {
	    eval 'sub NC_TPI_CLTS {1;}';
	    eval 'sub NC_TPI_COTS {2;}';
	    eval 'sub NC_TPI_COTS_ORD {3;}';
	    eval 'sub NC_TPI_RAW {4;}';
	}
	eval 'sub SOCK_DGRAM { &NC_TPI_CLTS;}';
	eval 'sub SOCK_STREAM { &NC_TPI_COTS;}';
	eval 'sub SOCK_RAW { &NC_TPI_RAW;}';
	eval 'sub SOCK_RDM {5;}';
	eval 'sub SOCK_SEQPACKET {6;}';
	eval 'sub SO_DEBUG {0x0001;}';
	eval 'sub SO_ACCEPTCONN {0x0002;}';
	eval 'sub SO_REUSEADDR {0x0004;}';
	eval 'sub SO_KEEPALIVE {0x0008;}';
	eval 'sub SO_DONTROUTE {0x0010;}';
	eval 'sub SO_BROADCAST {0x0020;}';
	eval 'sub SO_USELOOPBACK {0x0040;}';
	eval 'sub SO_LINGER {0x0080;}';
	eval 'sub SO_OOBINLINE {0x0100;}';
	eval 'sub SO_REUSEPORT {0x0200;}';
	eval 'sub SO_ORDREL {0x0200;}';
	eval 'sub SO_IMASOCKET {0x0400;}';
	eval 'sub SO_CHAMELEON {0x1000;}';
	eval 'sub SO_PASSIFNAME {0x2000;}';
	eval 'sub SO_SNDBUF {0x1001;}';
	eval 'sub SO_RCVBUF {0x1002;}';
	eval 'sub SO_SNDLOWAT {0x1003;}';
	eval 'sub SO_RCVLOWAT {0x1004;}';
	eval 'sub SO_SNDTIMEO {0x1005;}';
	eval 'sub SO_RCVTIMEO {0x1006;}';
	eval 'sub SO_ERROR {0x1007;}';
	eval 'sub SO_TYPE {0x1008;}';
	eval 'sub SO_PROTOTYPE {0x1009;}';
	eval 'sub SOL_SOCKET {0xffff;}';
	eval 'sub AF_UNSPEC {0;}';
	eval 'sub AF_LOCAL {1;}';
	eval 'sub AF_UNIX { &AF_LOCAL;}';
	eval 'sub AF_INET {2;}';
	eval 'sub AF_IMPLINK {3;}';
	eval 'sub AF_PUP {4;}';
	eval 'sub AF_CHAOS {5;}';
	eval 'sub AF_NS {6;}';
	eval 'sub AF_ISO {7;}';
	eval 'sub AF_ECMA {8;}';
	eval 'sub AF_DATAKIT {9;}';
	eval 'sub AF_CCITT {10;}';
	eval 'sub AF_SNA {11;}';
	eval 'sub AF_DECnet {12;}';
	eval 'sub AF_DLI {13;}';
	eval 'sub AF_LAT {14;}';
	eval 'sub AF_HYLINK {15;}';
	eval 'sub AF_APPLETALK {16;}';
	eval 'sub AF_ROUTE {17;}';
	if (defined &__sgi) {
	    eval 'sub AF_RAW {18;}';
	}
	else {
	    eval 'sub AF_LINK {18;}';
	}
	eval 'sub pseudo_AF_XTP {19;}';
	eval 'sub AF_NIT {17;}';
	eval 'sub AF_802 {18;}';
	eval 'sub AF_OSI {19;}';
	eval 'sub AF_X25 {20;}';
	eval 'sub AF_OSINET {21;}';
	eval 'sub AF_GOSIP {22;}';
	eval 'sub AF_SDL {23;}';
	eval 'sub AF_INET6 {24;}';
	eval 'sub AF_LINK {25;}';
	eval 'sub AF_MAX {( &AF_LINK+1);}';
	if (defined &_HAVE_SA_LEN) {
	}
	else {
	}
	eval 'sub sa_len { &sa_union. &sa_generic. &sa_len2;}';
	eval 'sub sa_family { &sa_union. &sa_generic. &sa_family2;}';
	eval 'sub sa_data { &sa_union. &sa_generic. &sa_data2;}';
	if (!defined &_HAVE_SIN_LEN) {
	    eval 'sub _SIN_ADDR_SIZE {8;}';
	    eval 'sub _SIN_SA_DATA_SIZE {14;}';
	    eval 'sub _MAX_SA_LEN {20;}';
	    eval 'sub _FAKE_SA_LEN_SRC {
	        local($sa) = @_;
	        eval "((($sa))-> &sa_len ? (($sa))-> &sa_len : (($sa)-> &sa_family ==  &AF_INET ?  &_SIN_ADDR_SIZE : (($sa)-> &sa_family ==  &AF_LINK ?  &_MAX_SA_LEN : $sizeof{\'struct sockaddr\'})))";
	    }';
	    eval 'sub _FAKE_SA_LEN_DST {
	        local($sa) = @_;
	        eval "((($sa))-> &sa_len ? (($sa))-> &sa_len : (($sa)-> &sa_family ==  &AF_LINK ?  &_MAX_SA_LEN : $sizeof{\'struct sockaddr\'}))";
	    }';
	}
	if (defined ( &_KERNEL) ) {
	}
	eval 'sub OPTLEN {
	    local($x) = @_;
	    eval "(((($x) + $sizeof{\'int\'} - 1) / $sizeof{\'int\'}) * $sizeof{\'int\'})";
	}';
	eval 'sub OPTVAL {
	    local($opt) = @_;
	    eval "(($opt + 1))";
	}';
	eval 'sub PF_UNSPEC { &AF_UNSPEC;}';
	eval 'sub PF_LOCAL { &AF_LOCAL;}';
	eval 'sub PF_UNIX { &PF_LOCAL;}';
	eval 'sub PF_INET { &AF_INET;}';
	eval 'sub PF_IMPLINK { &AF_IMPLINK;}';
	eval 'sub PF_PUP { &AF_PUP;}';
	eval 'sub PF_CHAOS { &AF_CHAOS;}';
	eval 'sub PF_NS { &AF_NS;}';
	eval 'sub PF_ISO { &AF_ISO;}';
	eval 'sub PF_OSI { &AF_ISO;}';
	eval 'sub PF_ECMA { &AF_ECMA;}';
	eval 'sub PF_DATAKIT { &AF_DATAKIT;}';
	eval 'sub PF_CCITT { &AF_CCITT;}';
	eval 'sub PF_SNA { &AF_SNA;}';
	eval 'sub PF_DECnet { &AF_DECnet;}';
	eval 'sub PF_DLI { &AF_DLI;}';
	eval 'sub PF_LAT { &AF_LAT;}';
	eval 'sub PF_HYLINK { &AF_HYLINK;}';
	eval 'sub PF_APPLETALK { &AF_APPLETALK;}';
	eval 'sub PF_ROUTE { &AF_ROUTE;}';
	eval 'sub PF_LINK { &AF_LINK;}';
	eval 'sub PF_XTP { &pseudo_AF_XTP;}';
	eval 'sub PF_RAW { &AF_RAW;}';
	eval 'sub PF_NIT { &AF_NIT;}';
	eval 'sub PF_802 { &AF_802;}';
	eval 'sub PF_X25 { &AF_X25;}';
	eval 'sub PF_OSINET { &AF_OSINET;}';
	eval 'sub PF_GOSIP { &AF_GOSIP;}';
	eval 'sub PF_INET6 { &AF_INET6;}';
	eval 'sub PF_MAX { &AF_MAX;}';
	eval 'sub NET_RT_DUMP {1;}';
	eval 'sub NET_RT_FLAGS {2;}';
	eval 'sub NET_RT_IFLIST {3;}';
	eval 'sub IPCTL_FORWARDING {1;}';
	eval 'sub IPCTL_SENDREDIRECTS {2;}';
	eval 'sub UDPCTL_CHECKSUM {1;}';
	eval 'sub SOMAXCONN {1000;}';
	eval 'sub msg_control { &msg_accrights;}';
	eval 'sub msg_controllen { &msg_accrightslen;}';
	eval 'sub MSG_OOB {0x1;}';
	eval 'sub MSG_PEEK {0x2;}';
	eval 'sub MSG_DONTROUTE {0x4;}';
	eval 'sub MSG_EOR {0x8;}';
	eval 'sub MSG_TRUNC {0x10;}';
	eval 'sub MSG_CTRUNC {0x20;}';
	eval 'sub MSG_WAITALL {0x40;}';
	eval 'sub MSG_DONTWAIT {0x80;}';
	if (defined &XTP) {
	    eval 'sub MSG_BTAG {0x40;}';
	    eval 'sub MSG_ETAG {0x80;}';
	}
	eval 'sub MSG_MAXIOVLEN {16;}';
	eval 'sub _ALIGNBYTES {7;}';
	eval 'sub _ALIGN {
	    local($p) = @_;
	    eval "((($p) +  &_ALIGNBYTES) & ~ &_ALIGNBYTES)";
	}';
	eval 'sub CMSG_DATA {
	    local($cmsg) = @_;
	    eval "((($cmsg) + 1))";
	}';
	eval 'sub CMSG_NXTHDR {
	    local($mhdr, $cmsg) = @_;
	    eval "((( &caddr_t)($cmsg) + ($cmsg)-> &cmsg_len + $sizeof{\'struct cmsghdr\'} > ($mhdr)-> &msg_control + ($mhdr)-> &msg_controllen) ?  &NULL : (( &caddr_t)($cmsg) +  &_ALIGN(($cmsg)-> &cmsg_len)))";
	}';
	eval 'sub CMSG_FIRSTHDR {
	    local($mhdr) = @_;
	    eval "(($mhdr)-> &msg_control)";
	}';
	if (0 ) {
	    eval 'sub SCM_RIGHTS {0x01;}';
	}
	if (!defined( &_KERNEL)) {
	}
	if (defined &__cplusplus) {
	}
    }
}
1;
