#!/usr/local/bin/perl

push(@INC,"/oracle/usr/grid/cgi-bin/proc");

@tags = ("href","form","background","src","action","lowsrc","dynsrc");
  
open(oldf,"-");

chop($fullurl=<oldf>);
$/='<';		
while($_ = <oldf>) {
  print;
  $/='>';
  last unless $format_str=<oldf>;
  #print "##s## $format_str ##e##\n";
  if  ($format_str =~ /\s*\bSCRIPT\b\s+\bLANGUAGE=\s*\"?\s*JAVASCRIPT\s*\"?\s*>/i) 
  {  
   	print $format_str;
	last unless $format_str=<oldf>;
	while ($format_str !~ /<\/SCRIPT>/i) { 
	  print $format_str ; 
	  $format_str = <oldf>;            
	}       
	if ($format_str =~ /<\/SCRIPT>/i) { 
	  print $`;
  	  $end_str = $&;
	  chop $end_str;
	  print  $end_str;              
	  $format_str = $';        
	}    
  }
  while($format_str =~ /</)
  {         
      #print "\nbfore##$format_str##\n";
      last if ($format_str =~ /\s*\bHREF\s*=\s*\"?/i ||$format_str =~ /\s*\bIMG\s*=\s*\"?/i);
      $/='>';
      $format_str = $`;
      #print "\nafter##$format_str##\n";
      $format_str .= <oldf>;
  }
    chop $format_str;
    #print "==s== $format_str ==s==\n";
    $format_str=&normalize_form($format_str);
    #print "_s_ $format_str _e_\n";

    print $format_str,">";
    $/='<';
}
close(oldf);
	     
exit;


sub normalize_form {
    local($fs)=@_;
    return $fs unless $fs =~ /^\s*(a|img|body|frame|applet|area|input|form)\s+/i;

    foreach $tag (@tags) 
    {
	if ($fs =~ /(\b$tag\s*=\s*\"?)([^\"\s]+)/i) 
        {
	$left=$` . $1;
	$righ=$';
	$addr=$2;
	$addr=calculate_addr($fullurl,$addr);
	$fs=$left . $addr . $righ;
        #$fs=~s/'//g;
        }
    }
    if($fs =~ m!(frame.*\bsrc\s*=\s*\"?)([^\"\s]+)!i) {
	$left=$` . $1;
	$righ=$';
	$addr=$2;   
        $addr=calculate_addr($fullurl,$addr);
	$fs=$left . $tango_root . $addr . $righ;
    }
return $fs;
}
    
sub calculate_addr
{
    local($oldaddr, $newaddr)=@_;  
#print "<br>before=$newaddr<br>";
    return $newaddr unless ($newaddr !~ /http:/i); 
    local($prot,$host,$path)=('','','');                  
    local($oldprot,$oldhost,$oldpath);
    local($h,$po,$pa,$f,$e) = &split_url($oldaddr);
    
    $newaddr =~ tr?\"??d;                # removing quotes
    #$oldaddr =~ m!^(.*)://([^/]+)/([^\s\"]*)$!; #"
    
    ($oldprot,$oldhost,$oldpath)=("http","$h:$po","$pa$f$e");
    $prot = $1 if $newaddr =~ s!^([^/:]*):!!;
    $host = $1 if $newaddr =~ s!//([^/]*)/?!!;
    $path = $newaddr;
    $path=~s/^'(.*)'$/$1/;

    $prot = $oldprot if $prot eq "";
    $host =~ s!:80\s*$!!;
    if($host eq "")
    {
	$host = $oldhost;
	$oldpath =~ s!/?[^\/]*$!!;
	$path = $oldpath . '/' . $path if $path !~ m!^/!;
    }
    $path = $1 if $path =~ m!^/(.*)$!;
    $newaddr = "$prot://$host/$path";
#print "<br>after=$newaddr<br>";
    return $newaddr;
}

sub split_url {
    local($url)=@_;
    local($host,$port,$path,$file,$extra,$v);
    ($url,$extra)=$url=~m!^([^\?\#]*)(.*)$!;
    $v=$url=~m!^http:(//([^:/]*)(:(\d*))?)?((/([^/]+/)*)?([^/]*))?$!;
    return () unless $v;
    ($host,$port,$path,$file)=(($2?$2:"localhost"),($4?$4:80),$6,$8);
    ($host,$port,$path,$file,$extra);
}


