
/* Result Sets Interface */
#ifndef SQL_CRSR
#  define SQL_CRSR
  struct sql_cursor
  {
    unsigned int curocn;
    void *ptr1;
    void *ptr2;
    unsigned long magic;
  };
  typedef struct sql_cursor sql_cursor;
  typedef struct sql_cursor SQL_CURSOR;
#endif /* SQL_CRSR */

/* Thread Safety */
typedef void * sql_context;
typedef void * SQL_CONTEXT;

/* File name & Package Name */
struct sqlcxp
{
  unsigned short fillen;
           char  filnam[11];
};
static struct sqlcxp sqlfpn =
{
    10,
    "gth_rob.pc"
};


static unsigned long sqlctx = 77979;


static struct sqlexd {
   unsigned int   sqlvsn;
   unsigned int   arrsiz;
   unsigned int   iters;
   unsigned int   offset;
   unsigned short selerr;
   unsigned short sqlety;
   unsigned int   unused;
            short *cud;
   unsigned char  *sqlest;
            char  *stmt;
   unsigned char  **sqphsv;
   unsigned int   *sqphsl;
            short **sqpind;
   unsigned int   *sqparm;
   unsigned int   **sqparc;
   unsigned char  *sqhstv[3];
   unsigned int   sqhstl[3];
            short *sqindv[3];
   unsigned int   sqharm[3];
   unsigned int   *sqharc[3];
} sqlstm = {8,3};

/* Prototypes */
extern sqlcxt (/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlcx2t(/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlbuft(/*_ void **, char * _*/);
extern sqlgs2t(/*_ void **, char * _*/);
extern sqlorat(/*_ void **, unsigned long *, void * _*/);

/* Forms Interface */
static int IAPSUCC = 0;
static int IAPFAIL = 1403;
static int IAPFTL  = 535;
extern sqliem(/*_ char *, int * _*/);

typedef struct { unsigned short len; unsigned char arr[1]; } VARCHAR;
typedef struct { unsigned short len; unsigned char arr[1]; } varchar;

/* cud (compilation unit data) array */
static short sqlcud0[] =
{8,4112,
2,0,0,1,81,0,4,63,0,2,0,0,1,0,2,3,0,0,2,9,0,0,
24,0,0,2,58,0,3,207,0,2,2,0,1,0,1,3,0,0,1,9,0,0,
46,0,0,3,58,0,3,224,0,2,2,0,1,0,1,3,0,0,1,9,0,0,
68,0,0,4,0,0,29,228,0,0,0,0,1,0,
82,0,0,5,42,0,1,230,0,0,0,0,1,0,
96,0,0,6,58,0,5,231,0,2,2,0,1,0,1,3,0,0,1,3,0,0,
118,0,0,7,0,0,29,233,0,0,0,0,1,0,
132,0,0,8,41,0,1,237,0,0,0,0,1,0,
146,0,0,9,169,0,5,238,0,0,0,0,1,0,
160,0,0,10,0,0,29,243,0,0,0,0,1,0,
174,0,0,11,50,0,6,247,0,1,1,0,1,0,1,3,0,0,
192,0,0,12,0,0,29,249,0,0,0,0,1,0,
206,0,0,13,0,0,27,371,0,3,3,0,1,0,1,9,0,0,1,10,0,0,1,10,0,0,
};


#define OK 0

#include <sys/stat.h>

#include <stdio.h>
#include <string.h>
#include <netdb.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <ctype.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/mode.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/sem.h>
#include <sys/signal.h>
#include <netinet/in.h>
#include <stdio.h>
#include <string.h>
#include <netdb.h>
#include <ctype.h>
#include <time.h>
#include <sys/socket.h>
#ifdef RCSID
static char *RCSid='costamcostam';
#endif
#define TXRAPP
int shmid;
static long key=989690581l;
#define CR 13
#define NL 10
#define USR_PWD "search/search"

#define NPAC_ROBOT "NPACagent"

/* EXEC SQL INCLUDE sqlca;
 */ 
/*
 * $Header: sqlca.h,v 1.3 1994/12/12 19:27:27 jbasu Exp $ sqlca.h 
 */

/* Copyright (c) 1985,1986 by Oracle Corporation. */
 
/*
NAME
  SQLCA : SQL Communications Area.
FUNCTION
  Contains no code. Oracle fills in the SQLCA with status info
  during the execution of a SQL stmt.
NOTES
  **************************************************************
  ***                                                        ***
  *** This file is SOSD.  Porters must change the data types ***
  *** appropriately on their platform.  See notes/pcport.doc ***
  *** for more information.                                  ***
  ***                                                        ***
  **************************************************************

  If the symbol SQLCA_STORAGE_CLASS is defined, then the SQLCA
  will be defined to have this storage class. For example:
 
    #define SQLCA_STORAGE_CLASS extern
 
  will define the SQLCA as an extern.
 
  If the symbol SQLCA_INIT is defined, then the SQLCA will be
  statically initialized. Although this is not necessary in order
  to use the SQLCA, it is a good pgming practice not to have
  unitialized variables. However, some C compilers/OS's don't
  allow automatic variables to be init'd in this manner. Therefore,
  if you are INCLUDE'ing the SQLCA in a place where it would be
  an automatic AND your C compiler/OS doesn't allow this style
  of initialization, then SQLCA_INIT should be left undefined --
  all others can define SQLCA_INIT if they wish.

  If the symbol SQLCA_NONE is defined, then the SQLCA variable will
  not be defined at all.  The symbol SQLCA_NONE should not be defined
  in source modules that have embedded SQL.  However, source modules
  that have no embedded SQL, but need to manipulate a sqlca struct
  passed in as a parameter, can set the SQLCA_NONE symbol to avoid
  creation of an extraneous sqlca variable.
 
MODIFIED
    jbasu      12/12/94 -  Bug 217878: note this is an SOSD file
    losborne   08/11/92 -  No sqlca var if SQLCA_NONE macro set 
  Clare      12/06/84 - Ch SQLCA to not be an extern.
  Clare      10/21/85 - Add initialization.
  Bradbury   01/05/86 - Only initialize when SQLCA_INIT set
  Clare      06/12/86 - Add SQLCA_STORAGE_CLASS option.
*/
 
#ifndef SQLCA
#define SQLCA 1
 
struct   sqlca
         {
         /* ub1 */ char    sqlcaid[8];
         /* b4  */ long    sqlabc;
         /* b4  */ long    sqlcode;
         struct
           {
           /* ub2 */ unsigned short sqlerrml;
           /* ub1 */ char           sqlerrmc[70];
           } sqlerrm;
         /* ub1 */ char    sqlerrp[8];
         /* b4  */ long    sqlerrd[6];
         /* ub1 */ char    sqlwarn[8];
         /* ub1 */ char    sqlext[8];
         };

#ifndef SQLCA_NONE 
#ifdef   SQLCA_STORAGE_CLASS
SQLCA_STORAGE_CLASS struct sqlca sqlca
#else
         struct sqlca sqlca
#endif
 
#ifdef  SQLCA_INIT
         = {
         {'S', 'Q', 'L', 'C', 'A', ' ', ' ', ' '},
         sizeof(struct sqlca),
         0,
         { 0, {0}},
         {'N', 'O', 'T', ' ', 'S', 'E', 'T', ' '},
         {0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0}
         }
#endif
         ;
#endif
 
#endif
 
/* end SQLCA */



void *shared_memory;
long *last_update;
long *loader_pid;


/* This process is intended to be run only as a single instance */
/* EXEC SQL BEGIN DECLARE SECTION; */ 

    /* VARCHAR	host[60]; */ 
struct { unsigned short len; unsigned char arr[60]; } host;

    long	host_id;
/* EXEC SQL END DECLARE SECTION; */ 


int get_id()
{
  /* EXEC SQL WHENEVER SQLERROR GOTO sqlerror; */ 

  /* EXEC SQL WHENEVER NOTFOUND GOTO sqlerror; */ 

  /* EXEC SQL SELECT host_id,host INTO :host_id,:host FROM search_hosts
    WHERE flag=1 AND rownum=1; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 2;
  sqlstm.stmt = "select host_id ,host into :b0,:b1  from search_hosts where \
(flag=1 and rownum =1)";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )2;
  sqlstm.selerr = (unsigned short)0;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&host_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&host;
  sqlstm.sqhstl[1] = (unsigned int  )62;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 100) goto sqlerror;
  if (sqlca.sqlcode < 0) goto sqlerror;
}


  /* EXEC SQL WHENEVER SQLERROR CONTINUE; */ 

  /* EXEC SQL WHENEVER NOTFOUND CONTINUE; */ 

  host.arr[host.len]='\0';
  return 0;
 sqlerror:
  return -1;
}


struct sellist
{
  int fdsmask[1];
};

struct timeval timeout={500,0};

int send_request(int sock)
{
  struct sellist rsl,wsl,esl;
  char	qstring[255];
  rsl.fdsmask[0]=0;
  wsl.fdsmask[0]=1<<sock;
  esl.fdsmask[0]=1<<sock;
  
  if(select(sock+1,&rsl,&wsl,&esl, &timeout)<=0)
    return -1;
  sprintf(qstring,
  "GET /robot.txt HTTP/1.1\r\nAccept: */*\r\nUser-Agent: NPACagent \r\n\r\n");				/* make the request     */
  if(write(sock,qstring,strlen(qstring))!=strlen(qstring))
    return -1;
  return 0;
}


/*
#define error(str) \
{\
   fprintf(stderr,"%s\n",str); \
   if(close(sock)!=0) printf("ERROR CLOSING SOCK\n"); \
   return -1; \
}*/

error(sock,str) 
int sock;
char *str;
{
   fprintf(stderr,"%s\n",str); 
   if(close(sock)!=0) printf("ERROR CLOSING SOCK\n"); 
   return -1; 
}

char * get_line(int);

int load_doc(char* servername)
{
  char *tmp, *point, *line;
  char host[128],header[4096]="";
  int   sock,port=80,i,concerns=0;
  struct sockaddr_in server;
  struct hostent     *hp;
  enum rd_st {HEADER,BODY} rd_st=HEADER;

  strcpy(host,servername);
  if((tmp = strchr(host , ':'))!=NULL)
  {
    *tmp++=0;			/* read port here if given	    */
    port=atoi(tmp);		/* otherwise assume 80		    */
  }

  sock=socket(AF_INET,SOCK_STREAM,PF_NS);	/* create a socket  */
  if (sock>4) printf("Some sockets are not closed %d\n",sock);
  if (sock<0) printf("Couldn't create socket");  
  server.sin_family = AF_INET;			/* create server    */
/*  server.sin_len = sizeof(server);	*/	/* structure	    */
  hp = gethostbyname(host);
  fprintf(stdout,"hostname = %s\n",host);
  if (hp == NULL) return error(sock,"Couldn't get hostname");
  bcopy(hp->h_addr, &server.sin_addr, hp->h_length);
  server.sin_port = htons(port);
  if (connect(sock, &server, sizeof(server))!=0) /* connect to http      */
    return error(sock,"Couldn't connect");			/* server	        */

  if(send_request(sock)<0) return error(sock,"Couldn't send");
  while((line=get_line(sock))!=NULL)
  {
    if(rd_st == HEADER)
    {
      if(strlen(header)+strlen(line)>4095) return error(sock,"Wrong header");
      strcat(header,line);
      strcat(header,"\n");
      if(line[0]=='\0')
      {
	if(process_header(header)<0) return error(sock,"Header error");
	rd_st=BODY;
      }
    }
    else
    {
      char * tmp, * point=line;
      while(*point<=' ' && *point!=0) point++;
      if(*point=='#') continue;
      if((tmp=strchr(point,'#'))!=NULL) *tmp='\0';
      if(*point=='\0')
      {
	concerns=0;
	continue;
      }
      if(strncasecmp(point,"user-agent:",strlen("user-agent"))==0)
      {
	if((point=strchr(point,':'))==NULL) continue;
        while(*(++point)<=' ' && *point!='\0');
	if(strncasecmp(point,NPAC_ROBOT,strlen(NPAC_ROBOT))==0) concerns=1;
	if(point[0]=='*' && point[1]<=' ') concerns=1;
      }
      else if(strncasecmp(point,"disallow",strlen("disallow"))==0 && concerns)
      {
	if((point=strchr(point,':'))==NULL) continue;
	while(*(++point)<=' ' && *point!='\0');
	tmp=point;
	while(*tmp>' ' && *tmp!='\0') tmp++;
	*tmp='\0';
	if(strcmp(point,"")) add_line(point);
      }
    }
  }
      
  if(close(sock)!=0) printf("ERROR CLOSING SOCKET \n");
  return 0;
}


/* EXEC SQL BEGIN DECLARE SECTION; */ 

   int		rows_to_insert=0;
   long		ID[64];
   /* VARCHAR	path[64][256]; */ 
struct { unsigned short len; unsigned char arr[258]; } path[64];

/* EXEC SQL END DECLARE SECTION; */ 


int add_line(char* str)
{
  if(rows_to_insert==64)
  {
    rows_to_insert=0;
    /* EXEC SQL 
      INSERT INTO search_disallow (host_id,path)
	VALUES (:ID,:path); */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 2;
    sqlstm.stmt = "insert into search_disallow(host_id,path) values (:b0,:b1\
)";
    sqlstm.iters = (unsigned int  )64;
    sqlstm.offset = (unsigned int  )24;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)ID;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)path;
    sqlstm.sqhstl[1] = (unsigned int  )260;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  }
  ID[rows_to_insert]=host_id;
  path[rows_to_insert].len=
    sprintf(path[rows_to_insert].arr,"%s",str);
  rows_to_insert++;
}

int finish_adding()
{
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    long ltime;
  /* EXEC SQL END DECLARE SECTION; */ 

  if(rows_to_insert>0)
  {
  /* EXEC SQL FOR :rows_to_insert
    INSERT INTO search_disallow (host_id,path)
	VALUES (:ID,:path); */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 2;
  sqlstm.stmt = "insert into search_disallow(host_id,path) values (:b1,:b2)";
  sqlstm.iters = (unsigned int  )rows_to_insert;
  sqlstm.offset = (unsigned int  )46;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)ID;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)path;
  sqlstm.sqhstl[1] = (unsigned int  )260;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  }
  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 2;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )68;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  ltime=time(NULL);
  /* EXEC SQL LOCK TABLE search_hosts IN EXCLUSIVE MODE; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 2;
  sqlstm.stmt = "lock table search_hosts in exclusive mode ";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )82;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  /* EXEC SQL UPDATE search_hosts SET flag=0, time=:ltime WHERE host_id=:host_id; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 2;
  sqlstm.stmt = "update search_hosts  set flag=0,time=:b0 where host_id=:b1";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )96;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&ltime;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&host_id;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  *last_update=time(NULL);
  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 2;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )118;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}



/* debug by yuzhu *************************  */

  /* EXEC SQL LOCK TABLE search_urls IN EXCLUSIVE MODE; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 2;
  sqlstm.stmt = "lock table search_urls in exclusive mode ";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )132;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  /* EXEC SQL 
	UPDATE search_urls set flag=0 WHERE (host_id, flag) IN
		(SELECT DISTINCT a.host_id, a.flag
		 FROM search_urls a, search_hosts b WHERE
		 a.host_id=b.host_id AND a.flag='R' ); */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 2;
  sqlstm.stmt = "update search_urls  set flag=0 where (host_id,flag) in (sel\
ect distinct a.host_id ,a.flag  from search_urls a ,search_hosts b where (a.ho\
st_id=b.host_id and a.flag='R'))";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )146;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 2;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )160;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}



/* *********************** debug */ 
  
  /* EXEC SQL EXECUTE BEGIN search_gth.ins_unflag(:host_id); END;
  END-EXEC; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 2;
  sqlstm.stmt = "begin search_gth . ins_unflag ( :host_id ) ; END ;";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )174;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&host_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 2;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )192;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


}
  


char * get_line(int sock)
{
  struct sellist rsl,wsl,esl;
  static char buffer[520];
  static char line[255];
  int linep=0,endofline=0;
  static int retval=0;
  static int point=0;
  static int old_sock=0;

  if(retval==0 && sock==old_sock) return NULL;
  if(old_sock!=sock)
  {
    retval=0;
    point=0;
    old_sock=sock;
  }


  do
  {
    if(point>=retval)
    {
      point=0;
      rsl.fdsmask[0]=1<<sock;
      wsl.fdsmask[0]=0;
      esl.fdsmask[0]=1<<sock;
      if(select(sock+1,&rsl,NULL,&esl, &timeout)<=0)
      {
	printf("Can't read from socket");
	return NULL;
      }
      retval=read(sock,buffer,128);
      if(retval<0)
      {
	printf("Error reading socket");
	return NULL;
      }
    }
    if(endofline==0)
    {
      if (buffer[point]==CR)
	endofline=1;
      else if (buffer[point]==NL)
	endofline=2;
      else
	line[linep++]=buffer[point];
      point++;
    }
    else
    {
      if(buffer[point]==NL)
	point++;
      else endofline=2;
    };
  } while( retval!=0 && endofline!=2 );
  line[linep]='\0';
  return line;
}  

int process_header(char *header)
{
  int   i,head_len=strlen(header);
  char* line;

    
  for(i=0;i<head_len;i++)
    header[i]=tolower(header[i]);
  do
  {
    line=header;
    header=strchr(header,'\n');
    if(header) *header++='\0';

    if(strncmp("http",line,4)==0)
    {
      if((line=strchr(line,' '))==NULL) continue;
      return (atoi(line)==200?0:-1);
      continue;
    }
  }
  while(header);
  return -1;
}

void usr1handle(int x)
{
  signal(SIGUSR1,&usr1handle);
}

void inthandle(int x)
{
  printf("Closing\n");
  shmdt(shared_memory);
  shmctl(shmid,IPC_RMID,0);
  exit(0);
}

void main()
{
  int test;
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    /* VARCHAR usr_pwd[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } usr_pwd;

  /* EXEC SQL END DECLARE SECTION; */ 

  shmid=shmget(key,2*sizeof(long),IPC_CREAT | S_IRUSR | S_IWUSR );
  if(shmid<0)
    {
      printf("SHMGET ERROR\n");
      exit(0);
    }
  shared_memory=shmat(shmid,0,0);
  last_update=&((long*)shared_memory)[0];
  loader_pid=&((long*)shared_memory)[1];
  *loader_pid=getpid();
  signal(SIGINT,&inthandle);
  signal(SIGUSR1,SIG_IGN);
  usr_pwd.len=sprintf(usr_pwd.arr,"%s",USR_PWD);
  /* EXEC SQL CONNECT :usr_pwd; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 3;
  sqlstm.iters = (unsigned int  )10;
  sqlstm.offset = (unsigned int  )206;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&usr_pwd;
  sqlstm.sqhstl[0] = (unsigned int  )257;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  while(1)
  {
    rows_to_insert=0;
    if(get_id()!=0)
    {
      signal(SIGUSR1,&usr1handle);
      pause();
      printf("Catched Signal\n");
      signal(SIGUSR1,SIG_IGN);
      printf("###########After Catched Signal\n");
      continue;
    }
    printf("%d %s\n",host_id,host.arr);
    fflush(stdout);
    if(load_doc(host.arr)!=0);
    finish_adding();
  }
} 


bcopy(s1, s2, len)
register char *s1, *s2;
int len;
{
   int i;

    for (i=0; i<len; i++)
        *s2 ++ = *s1 ++;
}
