execute ctx_ddl.create_policy('SEARCH_POLICY','SEARCH.TEXT');

execute ctx_ddl.create_index('SEARCH_POLICY');

drop sequence try;
create sequence try nomaxvalue nocycle cache 20;

drop trigger tr;
create trigger tr before insert on search
        for each row 
        declare n integer;
        begin
                select try.nextval into n from dual;
                :new.fid := n;
        end;
        /
