drop table query_temp;

prompt Creating query result table QUERY_TEMP...

create table query_temp( 
  textkey varchar2(64),
  score   number,
  conid   number
);

drop sequence query_id;
prompt Creating conid sequence generator QUERY_ID...

create sequence query_id maxvalue 30 cycle cache 20;

drop view BODY_HITLIST;

prompt Creating hitlist view BODY_HITLIST...

create view body_hitlist as
select a.score, a.conid, b.fid, b.title,b.host1,b.path, b.fsize, b.time, b.subject,c.depth
	from query_temp a, search b, search_urls c
	where a.textkey = b.fid
	and (b.host_id = c.host_id and b.path=c.path);

drop table highlight_temp;
prompt Creating highlight result table HIGHLIGHT_TEMP...

create table highlight_temp ( 
  id       number,
  offset   number,
  length   number,
  strength number
);

create table hightab (
  query_id number,
  offset number,
  length number
);

 	
