
/* Result Sets Interface */
#ifndef SQL_CRSR
#  define SQL_CRSR
  struct sql_cursor
  {
    unsigned int curocn;
    void *ptr1;
    void *ptr2;
    unsigned long magic;
  };
  typedef struct sql_cursor sql_cursor;
  typedef struct sql_cursor SQL_CURSOR;
#endif /* SQL_CRSR */

/* Thread Safety */
typedef void * sql_context;
typedef void * SQL_CONTEXT;

/* File name & Package Name */
struct sqlcxp
{
  unsigned short fillen;
           char  filnam[11];
};
static struct sqlcxp sqlfpn =
{
    10,
    "gth_ins.pc"
};


static unsigned long sqlctx = 77811;


static struct sqlexd {
   unsigned int   sqlvsn;
   unsigned int   arrsiz;
   unsigned int   iters;
   unsigned int   offset;
   unsigned short selerr;
   unsigned short sqlety;
   unsigned int   unused;
            short *cud;
   unsigned char  *sqlest;
            char  *stmt;
   unsigned char  **sqphsv;
   unsigned int   *sqphsl;
            short **sqpind;
   unsigned int   *sqparm;
   unsigned int   **sqparc;
   unsigned char  *sqhstv[6];
   unsigned int   sqhstl[6];
            short *sqindv[6];
   unsigned int   sqharm[6];
   unsigned int   *sqharc[6];
} sqlstm = {8,6};

/* Prototypes */
extern sqlcxt (/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlcx2t(/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlbuft(/*_ void **, char * _*/);
extern sqlgs2t(/*_ void **, char * _*/);
extern sqlorat(/*_ void **, unsigned long *, void * _*/);

/* Forms Interface */
static int IAPSUCC = 0;
static int IAPFAIL = 1403;
static int IAPFTL  = 535;
extern sqliem(/*_ char *, int * _*/);

typedef struct { unsigned short len; unsigned char arr[1]; } VARCHAR;
typedef struct { unsigned short len; unsigned char arr[1]; } varchar;

/* cud (compilation unit data) array */
static short sqlcud0[] =
{8,4112,
2,0,0,1,38,0,1,144,0,0,0,0,1,0,
16,0,0,2,0,0,29,169,0,0,0,0,1,0,
30,0,0,3,77,0,4,313,0,4,1,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,1,9,0,0,
60,0,0,4,42,0,1,337,0,0,0,0,1,0,
74,0,0,5,53,0,4,344,0,1,0,0,1,0,2,3,0,0,
92,0,0,6,73,0,3,349,0,4,4,0,1,0,1,3,0,0,1,9,0,0,1,3,0,0,1,3,0,0,
122,0,0,7,42,0,1,364,0,0,0,0,1,0,
136,0,0,8,49,0,5,365,0,1,1,0,1,0,1,68,0,0,
154,0,0,9,31,0,1,402,0,0,0,0,1,0,
168,0,0,10,38,0,1,403,0,0,0,0,1,0,
182,0,0,11,114,0,3,405,0,5,5,0,1,0,1,68,0,0,1,9,0,0,1,9,0,0,1,9,0,0,1,3,0,0,
216,0,0,12,175,0,2,413,0,0,0,0,1,0,
230,0,0,13,170,0,2,422,0,0,0,0,1,0,
244,0,0,14,204,0,2,432,0,0,0,0,1,0,
258,0,0,15,172,0,3,440,0,0,0,0,1,0,
272,0,0,16,0,0,29,445,0,0,0,0,1,0,
286,0,0,17,110,0,3,499,0,6,6,0,1,0,1,68,0,0,1,9,0,0,1,9,0,0,1,9,0,0,1,3,0,0,1,
3,0,0,
324,0,0,18,99,0,6,505,0,6,6,0,1,0,2,3,0,0,1,68,0,0,1,9,0,0,1,9,0,0,1,9,0,0,1,3,
0,0,
362,0,0,19,0,0,27,564,0,3,3,0,1,0,1,9,0,0,1,10,0,0,1,10,0,0,
388,0,0,20,0,0,30,573,0,0,0,0,1,0,
402,0,0,21,77,0,4,646,0,4,1,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,1,9,0,0,
};


#ifdef RCSID
static char *RCSid='costamcostam';
#endif
#define TXRAPP
#define OK 0

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif


#include <stdio.h>
#include <string.h>
#include <netdb.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <ctype.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/mode.h>
#include <sys/msg.h>
#include <sys/sem.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#define USR_PWD "search/search"

/* EXEC SQL INCLUDE sqlca;
 */ 
/*
 * $Header: sqlca.h,v 1.3 1994/12/12 19:27:27 jbasu Exp $ sqlca.h 
 */

/* Copyright (c) 1985,1986 by Oracle Corporation. */
 
/*
NAME
  SQLCA : SQL Communications Area.
FUNCTION
  Contains no code. Oracle fills in the SQLCA with status info
  during the execution of a SQL stmt.
NOTES
  **************************************************************
  ***                                                        ***
  *** This file is SOSD.  Porters must change the data types ***
  *** appropriately on their platform.  See notes/pcport.doc ***
  *** for more information.                                  ***
  ***                                                        ***
  **************************************************************

  If the symbol SQLCA_STORAGE_CLASS is defined, then the SQLCA
  will be defined to have this storage class. For example:
 
    #define SQLCA_STORAGE_CLASS extern
 
  will define the SQLCA as an extern.
 
  If the symbol SQLCA_INIT is defined, then the SQLCA will be
  statically initialized. Although this is not necessary in order
  to use the SQLCA, it is a good pgming practice not to have
  unitialized variables. However, some C compilers/OS's don't
  allow automatic variables to be init'd in this manner. Therefore,
  if you are INCLUDE'ing the SQLCA in a place where it would be
  an automatic AND your C compiler/OS doesn't allow this style
  of initialization, then SQLCA_INIT should be left undefined --
  all others can define SQLCA_INIT if they wish.

  If the symbol SQLCA_NONE is defined, then the SQLCA variable will
  not be defined at all.  The symbol SQLCA_NONE should not be defined
  in source modules that have embedded SQL.  However, source modules
  that have no embedded SQL, but need to manipulate a sqlca struct
  passed in as a parameter, can set the SQLCA_NONE symbol to avoid
  creation of an extraneous sqlca variable.
 
MODIFIED
    jbasu      12/12/94 -  Bug 217878: note this is an SOSD file
    losborne   08/11/92 -  No sqlca var if SQLCA_NONE macro set 
  Clare      12/06/84 - Ch SQLCA to not be an extern.
  Clare      10/21/85 - Add initialization.
  Bradbury   01/05/86 - Only initialize when SQLCA_INIT set
  Clare      06/12/86 - Add SQLCA_STORAGE_CLASS option.
*/
 
#ifndef SQLCA
#define SQLCA 1
 
struct   sqlca
         {
         /* ub1 */ char    sqlcaid[8];
         /* b4  */ long    sqlabc;
         /* b4  */ long    sqlcode;
         struct
           {
           /* ub2 */ unsigned short sqlerrml;
           /* ub1 */ char           sqlerrmc[70];
           } sqlerrm;
         /* ub1 */ char    sqlerrp[8];
         /* b4  */ long    sqlerrd[6];
         /* ub1 */ char    sqlwarn[8];
         /* ub1 */ char    sqlext[8];
         };

#ifndef SQLCA_NONE 
#ifdef   SQLCA_STORAGE_CLASS
SQLCA_STORAGE_CLASS struct sqlca sqlca
#else
         struct sqlca sqlca
#endif
 
#ifdef  SQLCA_INIT
         = {
         {'S', 'Q', 'L', 'C', 'A', ' ', ' ', ' '},
         sizeof(struct sqlca),
         0,
         { 0, {0}},
         {'N', 'O', 'T', ' ', 'S', 'E', 'T', ' '},
         {0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0}
         }
#endif
         ;
#endif
 
#endif
 
/* end SQLCA */


/* key used for IPC initialization  */
static long key=989690581l;
#define URL      2
#define NEXT     3
#define ADD_ADDR 4

#define UPDATE_PERIOD 60*60*24*14
#define CACHE_SIZE 100
#define HASH_SIZE 227
/*#define BUF_SIZE 5000*/
#define BUF_SIZE 500

/* structure for keeping host information */
typedef struct hosttype
{
  long host_id; /* identifier of physical host  */
  long time;    /* time of last robot.txt retrieving */
  int  flag;	/* host status (checked for robot_txt or not */
  char name[128]; /* name of the host */
} hosttype;

static long last_refresh_time=0; /* time of the last cache refresh */
void *shared_memory; 
long *last_update;/* pointer to the refresh field in shared memory */
long *loader_pid; /* pointer to the pid of the gth_rob process in shared mem*/

void shut_down(); 
void inthandle(int);
void start_get_robot_txt();
int refresh_required();
int calculate_hash(char*);
int process_url(int,char*,char*,char*);
int chk_invalid(int depth,char *prot,char *host,char *path);
int chk_hostid(char *host,long *ID);
void advance(int);
int cache_refresh();
hosttype *cache_get(char*);
void cache_add(hosttype*);
int cache_init();
hosttype *get_ID(char*);
int add_host(hosttype*);
int set_block(unsigned long);
int norm_add(long,int,char*,char*,char*);
int wait_add(long,int,char*,char*,char*,int);
int initialize();
void update_url(int);

int shmid;	/* shared memory identifier */
int msgid;	/* message queue identifier */
int semid;	/* semaphore identifier	    */
int still_going=1; /* 0 if request to shut down occured */


main()
{
  struct
  {
    long type;
    int  depth;
    int  host;
    int  path;
/*    char msg[255];*/
	char protname[10];
	char hostname[60];
	char pathname[255];
  } mb; /* message structure */
  initialize();
  while(still_going)
  {
    struct sembuf sb={1,1,0};
    int len,ret;
    ret = semop(semid,&sb,1); /* increase semaphore to allow further writing */
printf("semret=%d\n");
    if((len=msgrcv(msgid, &mb, sizeof(mb), ADD_ADDR, 0))<=0) continue;
printf("prot=%s host=%s path=%s \n", mb.protname,mb.hostname,mb.pathname);   
/*    process_url(mb.depth,mb.msg,mb.msg+mb.host,mb.msg+mb.path);*/
    process_url(mb.depth,mb.protname,mb.hostname,mb.pathname);
printf("11111111111111111\n");
    update_url(0); /* write to the database if already 2000 or queue empty */
printf("222222222222222222\n");
  }
  update_url(1); /* write to database unconditionally */
  printf("Normal END\n");
  shut_down();
}
#define HOST_FOUND 0
#define HOST_NOT_FOUND 1
#define HOST_FOUND_WAIT 2

/* Procedure for processing the url */
/* Checks if the urs is valid, then gets the server id */
/* If the server is known adds url to the buffer otherwise */
/* adds url to the queue with wait flag set	    */
int process_url(int depth,char *prot,char* host, char* path)
{
  long ID;   /* server ID */
  int  return_code;
int ret;
  
  if( chk_invalid(depth,prot,host,path) ) /* first , the simplest test */
    {					  /* does not require database */
      printf("V");
      return 1;
    }
  /* EXEC SQL LOCK TABLE search_hosts IN SHARE MODE; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 0;
  sqlstm.stmt = "lock table search_hosts in share mode ";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )2;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  /* Locking table to prevent simultaneous operation by gth_ins and gth_rob */
  if(refresh_required()!=0) /*checks if gth_rob checked some new servers */
  {
    cache_refresh();        /*and if so refreshing the cache */
  }
  switch( ret = chk_hostid(host,&ID) ) /* gets ID of the host */
  {
  case HOST_FOUND:
    norm_add(ID,depth,prot,host,path); /* adds entry to the buffer */
    return_code=0;
    break;
  case HOST_FOUND_WAIT:
    wait_add(ID,depth,prot,host,path,TRUE); /* adds entry to the queue with checking */
    return_code=0;
    break;
  case HOST_NOT_FOUND:
    wait_add(ID,depth,prot,host,path,FALSE); /* adds entry to the queue without checking */
    return_code=1;
    break;
  default :
    return_code=-1;
    break;
  }
printf("return_code = %d\n",ret);
  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 0;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )16;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}

  /* releasing the lock */
  if(return_code==1)/* if a completely new server encountered start inform gth_rob process */
  {
    start_get_robot_txt();
    return_code=0;
  }
  fflush(stdout);
  return return_code;
}

/* Tests the simple conditions on the url */
/* like extension, path, domain and depth level */
/* I propose to make this loaded from a configuration file in the future */
int chk_invalid(int depth,char *prot,char *host,char *path)
{
  char* ext;
  int   retval=1;

  ext=strrchr(path,'.'); /*determining the file extension*/
  if(path[strlen(path)-1]=='/') retval=0;
  if(ext==NULL) retval=0;
  if(ext!=NULL && strcasecmp(ext,".html")==0) retval=0;
  if(ext!=NULL && strcasecmp(ext,".htm")==0) retval=0;

/*  if (strstr(host,".syr.edu")==NULL) retval=1; */


/* if ((strstr(host,"npac.syr.edu")==NULL) ||
	(strstr(host,"nova.npac.syr.edu:8110")!=NULL)) retval=1; */

	if (strstr(host,"www.npac.syr.edu")==NULL || strstr(path,"wwwstats")!=NULL)  retval=1;


/*	if (strstr(path,"/thinkquest/")==NULL)  retval=1;  */

  
/*  if(depth>5) retval=1; */
  return retval;
}

/* Checking if the server is already known to the system */
int chk_hostid(char *host,long *ID)
{
  hosttype* hst;
  if((hst=get_ID(host))==NULL) /*tries to get host iforamtion of a server ( from cache or database )*/
    { 
      struct hostent *ht;      /*structure for gethostbyname */
      char	      ipname[30],hostname[128],*tmp,*ip_name;
      hosttype	      hostinfo;
      int	      portnum,i;
u_long addr;

      strcpy(hostname,host);
      if((tmp=strchr(hostname,':'))!=NULL) /* determines server name and port number */
      {
	*(tmp++)='\0';
	portnum=atoi(tmp);
      }
      else
      {	
	portnum=80;
      }
      ht=gethostbyname(hostname);	    /* gets server information */
      if(ht==NULL) return -1;		    /* if host unknown returns error */
      /* checks IP-s */
      for(i=0;hst==NULL && ht->h_addr_list[i]!=NULL;i++)
      {
	char *tmp;
	tmp = inet_ntoa(*((struct in_addr *)(ht->h_addr_list[i])));
	sprintf(hostname,"%s:%d",tmp,portnum);
	hst=get_ID(hostname);
      }
      /* checks main name */
      if(hst==NULL)
      {
/*	ht=gethostbyaddr(ht->h_addr_list[0],strlen(ht->h_addr_list[0]),AF_INET);*/
	
	ip_name = inet_ntoa(*((struct in_addr *)(ht->h_addr_list[0])));

         if ((int)(addr = inet_addr(ip_name)) == -1) {
             printf("IP-address must be of the form a.b.c.d\n");
             exit (2);
         }

        ht=gethostbyaddr((char *)&addr,sizeof(addr),AF_INET);
	

	if(ht==NULL) return -1;
	sprintf(hostname,"%s:%d",ht->h_name,portnum);
	hst=get_ID(hostname);
      }
      /* checks aliases */
      for(i=0;hst==NULL && ht->h_aliases[i]!=NULL;i++)
      {
	sprintf(hostname,"%s:%d",ht->h_aliases[i],portnum);
	hst=get_ID(hostname);
      }      
      strcpy(hostinfo.name,host);
      /* if the host is still unknown, it creates a new ID, and adds it to cache and DB */
      if(hst==NULL)
      {
	hosttype     hinfo;
	hostinfo.host_id=0;
	hostinfo.flag=1;
	add_host(&hostinfo);
	cache_add(&hostinfo);
	memcpy(&hinfo,&hostinfo,sizeof(hosttype));
	sprintf(hinfo.name,"%s:%d",ht->h_name,portnum);
	if(strcmp(hinfo.name,hostinfo.name)!=0) add_host(&hinfo);
	*ID=hostinfo.host_id;
	return HOST_NOT_FOUND;
      }
      hostinfo.host_id=hst->host_id; /* if host known the info information is retrieved */
      hostinfo.flag=hst->flag;	     /* and the host is added to cache			*/
      add_host(&hostinfo);
      cache_add(&hostinfo);
      hst=&hostinfo;
    }
  *ID=hst->host_id;
  if(hst->flag==1) return HOST_FOUND_WAIT;
  if(hst->time<time(NULL)-UPDATE_PERIOD) /* tests if robot.txt file should be collected again */
  {
    set_block(*ID);		     /* if so sets the flag in search_hosts table for given ID */
    return 1;
  }
  return HOST_FOUND;
}

/* gets the server information for a given host name or returns null if information not available */
hosttype *get_ID(char* name)
{
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

  /* VARCHAR  host[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } host;

  long	   id;
  long	   time;
  int	   flag;
  /* EXEC SQL END DECLARE SECTION; */ 

  
  hosttype *hst;
  if((hst=cache_get(name))!=NULL) return hst;  /* if available in cache use it */
  host.len=sprintf(host.arr,"%s",name);        /* otherwise try to get from the DB */
  {
    static hosttype hst;
    /* EXEC SQL WHENEVER NOTFOUND GOTO notfound; */ 
  
    /* EXEC SQL SELECT host_id,flag,time INTO :id, :flag, :time
      FROM search_hosts WHERE host=:host; */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 4;
    sqlstm.stmt = "select host_id ,flag ,time into :b0,:b1,:b2  from search_\
hosts where host=:b3";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )30;
    sqlstm.selerr = (unsigned short)0;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&id;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)&flag;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)&time;
    sqlstm.sqhstl[2] = (unsigned int  )4;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqhstv[3] = (unsigned char  *)&host;
    sqlstm.sqhstl[3] = (unsigned int  )257;
    sqlstm.sqindv[3] = (         short *)0;
    sqlstm.sqharm[3] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode == 100) goto notfound;
}


    hst.host_id=id;				/* after getting it add it to cache */
    hst.flag=flag;
    hst.time=time;
    strcpy(hst.name,name);
    cache_add(&hst);
    return &hst;
  }
 notfound:
  return NULL;
  /* EXEC SQL WHENEVER NOTFOUND CONTINUE; */ 

}

/* adds new host to the database */
int add_host(hosttype *hst)
{
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

  /* VARCHAR  host[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } host;

  long	   id;
  long	   time;
  int	   flag;
  /* EXEC SQL END DECLARE SECTION; */ 

  /* EXEC SQL WHENEVER SQLERROR GOTO sqlerr; */ 

  /* EXEC SQL LOCK TABLE search_hosts IN EXCLUSIVE MODE; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 4;
  sqlstm.stmt = "lock table search_hosts in exclusive mode ";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )60;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) goto sqlerr;
}


  time=hst->time;
  id=hst->host_id;
  flag=hst->flag;
  host.len=sprintf(host.arr,"%s",hst->name);
  if(id==0) /* get a new host id if id not specified */
  {
    /* EXEC SQL SELECT search_hosts_seq.nextval INTO :id FROM dual; */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 4;
    sqlstm.stmt = "select search_hosts_seq.nextval  into :b0  from dual ";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )74;
    sqlstm.selerr = (unsigned short)0;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&id;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode < 0) goto sqlerr;
}


    hst->host_id=id;
  }
  printf("\nhost added=%s\n",host.arr);
  
  /* EXEC SQL INSERT INTO search_hosts (host_id,host,time,flag)
    VALUES (:id, :host, :time, :flag ); */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 4;
  sqlstm.stmt = "insert into search_hosts(host_id,host,time,flag) values (:b\
0,:b1,:b2,:b3)";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )92;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&host;
  sqlstm.sqhstl[1] = (unsigned int  )257;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqhstv[2] = (unsigned char  *)&time;
  sqlstm.sqhstl[2] = (unsigned int  )4;
  sqlstm.sqindv[2] = (         short *)0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqhstv[3] = (unsigned char  *)&flag;
  sqlstm.sqhstl[3] = (unsigned int  )4;
  sqlstm.sqindv[3] = (         short *)0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) goto sqlerr;
}


  return 0;
 sqlerr:
  printf("\n(*) %s\n",sqlca.sqlerrm.sqlerrmc);
  return -1;
  /* EXEC SQL WHENEVER SQLERROR CONTINUE; */ 

}

/* marks host in search_hosts table for reloading robot.txt file */
int set_block(unsigned long ID)
{
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

  unsigned long h_id=ID;
  /* EXEC SQL END DECLARE SECTION; */ 

  /* EXEC SQL LOCK TABLE search_hosts IN EXCLUSIVE MODE; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 4;
  sqlstm.stmt = "lock table search_hosts in exclusive mode ";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )122;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  /* EXEC SQL UPDATE search_hosts SET flag=1 WHERE HOST_ID=:h_id; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 4;
  sqlstm.stmt = "update search_hosts  set flag=1 where HOST_ID=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )136;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&h_id;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


}

/* buffer for block add to search_urls */
/* EXEC SQL BEGIN DECLARE SECTION; */ 

unsigned long	id[500];
/* VARCHAR		protocol[500][30]; */ 
struct { unsigned short len; unsigned char arr[30]; } protocol[500];

/* VARCHAR		hostname[500][255]; */ 
struct { unsigned short len; unsigned char arr[258]; } hostname[500];

/* VARCHAR		pathname[500][255]; */ 
struct { unsigned short len; unsigned char arr[258]; } pathname[500];

int		depth[500];
int		num_iters;
/* EXEC SQL END DECLARE SECTION; */ 

/* number of items in the buffer */
static int	count=0;

/* insert buffer to search_urls if count>BUF_SIZE, if queue empty or if flag */
void update_url(int flag)
{
int i;
  /* checks the number of msgs in queue and if zero waits 1s and checks again*/
  struct msqid_ds msg_buffer;
  msgctl(msgid,IPC_STAT,&msg_buffer); 
  if(msg_buffer.msg_qnum==0)
  {
    sleep(1);
    msgctl(msgid,IPC_STAT,&msg_buffer);
  }
  if(count>=BUF_SIZE || msg_buffer.msg_qnum==0 || flag)
  {
    num_iters=count;

/* debug ********* by yuzhu */
/*printf("num_iters = %d\n",num_iters);
  pathname[16].len=sprintf(pathname[16].arr,"/general/awards.htmll");
for (i=0; i<num_iters; i++) printf("pathname : %s  hostname : %s\n",pathname[i].arr,hostname[i].arr);*/
/*	********** Debug */

    /* EXEC SQL TRUNCATE TABLE search_urls_temp; */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 4;
    sqlstm.stmt = "truncate TABLE search_urls_temp";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )154;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


    /* EXEC SQL LOCK TABLE search_hosts IN SHARE MODE; */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 4;
    sqlstm.stmt = "lock table search_hosts in share mode ";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )168;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


    /* inserts buffer into temporary table */
    /* EXEC SQL FOR :num_iters
      INSERT INTO search_urls_temp
	(host_id, prot, host, path, flag, priority, depth, fid) VALUES
	(:id,:protocol,:hostname,:pathname,'0',50,:depth,0); */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 5;
    sqlstm.stmt = "insert into search_urls_temp(host_id,prot,host,path,flag,\
priority,depth,fid) values (:b1,:b2,:b3,:b4,'0',50,:b5,0)";
    sqlstm.iters = (unsigned int  )num_iters;
    sqlstm.offset = (unsigned int  )182;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)id;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)protocol;
    sqlstm.sqhstl[1] = (unsigned int  )32;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)hostname;
    sqlstm.sqhstl[2] = (unsigned int  )260;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqhstv[3] = (unsigned char  *)pathname;
    sqlstm.sqhstl[3] = (unsigned int  )260;
    sqlstm.sqindv[3] = (         short *)0;
    sqlstm.sqharm[3] = (unsigned int  )0;
    sqlstm.sqhstv[4] = (unsigned char  *)depth;
    sqlstm.sqhstl[4] = (unsigned int  )4;
    sqlstm.sqindv[4] = (         short *)0;
    sqlstm.sqharm[4] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


    printf("ins*\n");   
    fflush(stdout);

     /* deletes duplicates between search_urls_temp and search_urls */
    /* EXEC SQL
      DELETE FROM search_urls_temp WHERE (host_id,path) IN
	(SELECT DISTINCT a.host_id,a.path
	 FROM search_urls_temp a,search_urls b WHERE
	 a.host_id=b.host_id AND a.path=b.path); */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 5;
    sqlstm.stmt = "delete from search_urls_temp  where (host_id,path) in (se\
lect distinct a.host_id ,a.path  from search_urls_temp a ,search_urls b where \
(a.host_id=b.host_id and a.path=b.path))";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )216;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


    printf("urls*\n");
    fflush(stdout);
 
   /* deletes duplicates between search_urls_temp and search */
    /* EXEC SQL
      DELETE FROM search_urls_temp WHERE (host_id,path) IN
	(SELECT DISTINCT a.host_id,a.path
	 FROM search_urls_temp a,search b WHERE
	 a.host_id=b.host_id AND a.path=b.path); */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 5;
    sqlstm.stmt = "delete from search_urls_temp  where (host_id,path) in (se\
lect distinct a.host_id ,a.path  from search_urls_temp a ,search b where (a.ho\
st_id=b.host_id and a.path=b.path))";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )230;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


    printf("search*\n");
    fflush(stdout);


   /* deletes urls violating robot exclusion */
    /* EXEC SQL
      DELETE FROM search_urls_temp WHERE (host_id,path) IN
        (SELECT DISTINCT a.host_id,a.path FROM
        search_urls_temp a, search_disallow b WHERE
        a.host_id=b.host_id AND a.path=SUBSTR(b.path,1,LENGTH(a.path))); */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 5;
    sqlstm.stmt = "delete from search_urls_temp  where (host_id,path) in (se\
lect distinct a.host_id ,a.path  from search_urls_temp a ,search_disallow b wh\
ere (a.host_id=b.host_id and a.path=SUBSTR(b.path,1,LENGTH(a.path))))";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )244;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


    printf("disall*\n");
    fflush(stdout);
    /* transfers rows to search_urls */
    /* EXEC SQL
      INSERT INTO search_urls
        (select max(host_id),max(prot),max(host),max(path),max(flag),
         max(priority),max(depth),max(fid) from search_urls_temp 
         group by host_id,path); */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 5;
    sqlstm.stmt = "insert into search_urls (select max(host_id) ,max(prot) ,\
max(host) ,max(path) ,max(flag) ,max(priority) ,max(depth) ,max(fid)  from sea\
rch_urls_temp  group by host_id,path)";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )258;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


    /* EXEC SQL COMMIT; */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 5;
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )272;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


    printf("\n%d rows processed\n",count);
    count=0; /* resets the number of buffers in queue */
  }
}

/* Check if the host_id and path has already existed in the buffer */
duplicate_check(long ID, char *path)
{
	int i;
	for (i=0;i<count;i++)
		if (id[i]==ID && strcmp(pathname[i].arr,path)==0) return 0;
	return 1;
}

/* Adds an etry to the urls buffer */
int norm_add(long ID,int lev,char *prot,char *host,char *path)
{
 if (duplicate_check(ID,path)) {
  id[count]=ID;
  depth[count]=lev;
  protocol[count].len=sprintf(protocol[count].arr,"%s",prot);
  hostname[count].len=sprintf(hostname[count].arr,"%s",host);
  pathname[count].len=sprintf(pathname[count].arr,"%s",path);
  count++;
 }
  return 0;
}

/* Adds an entry to the search_urls table */
/* test value specifies if this host appeared for the first time and any checking is not necessary */
/* or if some checking should be performed */
int wait_add(long ID,int lev,char *prot,char *host,char *path,int test)
{
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

  unsigned long id;
  /* VARCHAR       protocol[30]; */ 
struct { unsigned short len; unsigned char arr[30]; } protocol;

  /* VARCHAR	hostname[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } hostname;

  /* VARCHAR	pathname[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } pathname;

  long		priority;
  int		depth;
  int		checking;
  int		retval=0;
  /* EXEC SQL END DECLARE SECTION; */ 

  id=ID;
  depth=lev;
  protocol.len=sprintf(protocol.arr,"%s",prot);
  hostname.len=sprintf(hostname.arr,"%s",host);
  pathname.len=sprintf(pathname.arr,"%s",path);
  checking=test;
  priority=50;
printf("test = %d\n",test);
  if(test==0) /* insert without checking */
  {    
    /* EXEC SQL INSERT INTO search_urls (host_id,fid,prot,host,path,flag,priority,depth)
      VALUES (:id,0,:protocol,:hostname,:pathname,'R',:priority,:depth); */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 6;
    sqlstm.stmt = "insert into search_urls(host_id,fid,prot,host,path,flag,p\
riority,depth) values (:b0,0,:b1,:b2,:b3,'R',:b4,:b5)";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )286;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&id;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)&protocol;
    sqlstm.sqhstl[1] = (unsigned int  )32;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)&hostname;
    sqlstm.sqhstl[2] = (unsigned int  )257;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqhstv[3] = (unsigned char  *)&pathname;
    sqlstm.sqhstl[3] = (unsigned int  )257;
    sqlstm.sqindv[3] = (         short *)0;
    sqlstm.sqharm[3] = (unsigned int  )0;
    sqlstm.sqhstv[4] = (unsigned char  *)&priority;
    sqlstm.sqhstl[4] = (unsigned int  )4;
    sqlstm.sqindv[4] = (         short *)0;
    sqlstm.sqharm[4] = (unsigned int  )0;
    sqlstm.sqhstv[5] = (unsigned char  *)&depth;
    sqlstm.sqhstl[5] = (unsigned int  )4;
    sqlstm.sqindv[5] = (         short *)0;
    sqlstm.sqharm[5] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


    retval=4;
  }
  else /* insert with checking using pl/sql search_gth.ins_wait */
  {
    /* EXEC SQL EXECUTE
      BEGIN
	:retval := search_gth.ins_wait(:id,:protocol,:hostname,:pathname,:depth);
      END;
    END-EXEC; */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 6;
    sqlstm.stmt = "begin :retval := search_gth . ins_wait ( :id , :protocol \
, :hostname , :pathname , :depth ) ; END ;";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )324;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&retval;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)&id;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)&protocol;
    sqlstm.sqhstl[2] = (unsigned int  )32;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqhstv[3] = (unsigned char  *)&hostname;
    sqlstm.sqhstl[3] = (unsigned int  )257;
    sqlstm.sqindv[3] = (         short *)0;
    sqlstm.sqharm[3] = (unsigned int  )0;
    sqlstm.sqhstv[4] = (unsigned char  *)&pathname;
    sqlstm.sqhstl[4] = (unsigned int  )257;
    sqlstm.sqindv[4] = (         short *)0;
    sqlstm.sqharm[4] = (unsigned int  )0;
    sqlstm.sqhstv[5] = (unsigned char  *)&depth;
    sqlstm.sqhstl[5] = (unsigned int  )4;
    sqlstm.sqindv[5] = (         short *)0;
    sqlstm.sqharm[5] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}

    
  }
  return retval;
}

/* signals the gth_rob process that a new server was discovered */
void start_get_robot_txt()
{
  static int pid=0;
  kill(*loader_pid,SIGUSR1);
}

/* tests if cache refresh is required */
/* if the gth_rob collected some robot.txt file after last cache update */
/* the cache should be refreshed */
/* shared memory is used here */
int refresh_required()
{
  if(*last_update!=last_refresh_time)
    {
      printf("\nREFRESH\n");
      last_refresh_time=*last_update;
      return 1;
    }
  return 0;
}

/* set of initialization commands */
int initialize()
{
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    /* VARCHAR user_pwd[100]; */ 
struct { unsigned short len; unsigned char arr[100]; } user_pwd;

  /* EXEC SQL END DECLARE SECTION; */ 

  if((msgid=msgget(key+1,0)) <=0)	/* attaching to message queue */
  {
    printf("couldn't open semaphores or messages");
    exit(0);
  }
  shmid=shmget(key,2*sizeof(long),0 ); /* attaching to shared memory */
  if(shmid<0)
    {
      printf("SHMGET ERROR\n");
      exit(0);
    }
  semid=semget(key,2,0);		/* attachig to semaphore */
  if(semid<0)
  {
    printf("SEMGET ERROR\n");
    exit(0);
  }
  shared_memory=shmat(shmid,0,SHM_RDONLY);
  last_update=&((long*)shared_memory)[0];
  loader_pid=&((long*)shared_memory)[1];
  cache_init();
  user_pwd.len=sprintf(user_pwd.arr,"%s",USR_PWD);
  /* EXEC SQL CONNECT :user_pwd; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 6;
  sqlstm.iters = (unsigned int  )10;
  sqlstm.offset = (unsigned int  )362;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&user_pwd;
  sqlstm.sqhstl[0] = (unsigned int  )102;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  signal(SIGINT,&inthandle);		/* catching sigint signal */
}

/* procedures used for shutting down */
/* detaching from shared memory and finishing with oracle */
void shut_down()
{
  shmdt(shared_memory);
  /* EXEC SQL COMMIT WORK RELEASE; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 6;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )388;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  printf("\nshutting down\n");
  exit(0);
}

/* at the first interrupt only still_going value is reset */
/* at the second one exit is performed */
void inthandle(int x)
{
  printf("Shutting down\n");
  if(still_going!=0)
    still_going=0;
  else
  {
    printf("Second Interrupt\n");
    shut_down();
  }
  signal(SIGINT,&inthandle);
}

/******************************************************************/
/* Cache procedures */
/******************************************************************/

/* element of cache table */
struct cache_elem
{
  hosttype elem;
  int	   hash_val;
  int	   pos;
} cache_val[CACHE_SIZE];
int hash_tab[HASH_SIZE+CACHE_SIZE+5][2];
int positions[CACHE_SIZE];

int top=-1,bottom=-1;

/* a function for calculating the hash value for a given server name */
int calculate_hash(char* string)
{
  int i,sum=0;
  for(i=strlen(string);i>=0;i--) sum=sum+string[i];
  return (sum*137)%HASH_SIZE;
}

/* advance an element in the posiotions table */
void advance(int pos)
{
  int tmp,newpos;
  if(pos==top) return;
  newpos=(pos+1) % CACHE_SIZE;
  cache_val[positions[pos]].pos=newpos;
  cache_val[positions[newpos]].pos=pos;
  tmp=positions[pos];
  positions[pos]=positions[newpos];
  positions[newpos]=tmp;
}
    
int cache_refresh()
{
  int i;
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

  /* VARCHAR  hostname[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } hostname;

  long	   id;
  long	   ltime;
  int	   flag;
  /* EXEC SQL END DECLARE SECTION; */ 

  /* EXEC SQL WHENEVER SQLERROR GOTO sqlerr; */ 


  for(i=0;i<CACHE_SIZE;i++)
  {
    hosttype *hst=&cache_val[i].elem;
    if(cache_val[i].hash_val==-1) continue;
    hostname.len=sprintf(hostname.arr,"%s",hst->name);
    /* EXEC SQL SELECT host_id,flag,time INTO :id, :flag, :ltime 
      FROM search_hosts
	WHERE host = :hostname ; */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 6;
    sqlstm.stmt = "select host_id ,flag ,time into :b0,:b1,:b2  from search_\
hosts where host=:b3";
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )402;
    sqlstm.selerr = (unsigned short)0;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char  *)&id;
    sqlstm.sqhstl[0] = (unsigned int  )4;
    sqlstm.sqindv[0] = (         short *)0;
    sqlstm.sqharm[0] = (unsigned int  )0;
    sqlstm.sqhstv[1] = (unsigned char  *)&flag;
    sqlstm.sqhstl[1] = (unsigned int  )4;
    sqlstm.sqindv[1] = (         short *)0;
    sqlstm.sqharm[1] = (unsigned int  )0;
    sqlstm.sqhstv[2] = (unsigned char  *)&ltime;
    sqlstm.sqhstl[2] = (unsigned int  )4;
    sqlstm.sqindv[2] = (         short *)0;
    sqlstm.sqharm[2] = (unsigned int  )0;
    sqlstm.sqhstv[3] = (unsigned char  *)&hostname;
    sqlstm.sqhstl[3] = (unsigned int  )257;
    sqlstm.sqindv[3] = (         short *)0;
    sqlstm.sqharm[3] = (unsigned int  )0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode < 0) goto sqlerr;
}


    hst->host_id=id;
    hst->flag=flag;
    hst->time=ltime;
  }
  return 0;
 sqlerr:
  return -1;
  /* EXEC SQL WHENEVER SQLERROR CONTINUE; */ 

}

hosttype *cache_get(char *name)
{
  int elem_point;
  int hash_val=calculate_hash(name);
  while(hash_val!=-1 && (elem_point=hash_tab[hash_val][0])>=0)
    {
      if(strcmp(cache_val[elem_point].elem.name,name)==0)
      {
	advance(cache_val[elem_point].pos);
	return &cache_val[elem_point].elem;
      }
      hash_val=hash_tab[hash_val][1];
    }
  printf("_");
  return NULL;
}

void cache_add(hosttype *hst)
{
  int index,hash_val,hash_val_last;
  top= (top+1) % CACHE_SIZE;
  index=positions[top];
  printf("-");
  if( top == bottom )
  {
    int tmp;
    bottom=(bottom+1) % CACHE_SIZE;
    hash_val=cache_val[index].hash_val;
    while(hash_val!=-1 && (hash_tab[hash_val][0])!=index)
      hash_val=hash_tab[hash_val][1];
    if(hash_val==-1)
    {
      printf("This error shouldn't occure\n");
      shut_down();
    }
    tmp=hash_tab[hash_val][1];
    if(tmp>=0)
    {
      hash_tab[hash_val][0]=hash_tab[tmp][0];
      hash_tab[hash_val][1]=hash_tab[tmp][1];
    }
    else
      tmp=hash_val;
    hash_tab[tmp][0]=-1;
    hash_tab[tmp][1]=-1;
  }
  strcpy(cache_val[index].elem.name,hst->name);
  cache_val[index].elem.flag=hst->flag;
  cache_val[index].elem.time=hst->time;
  cache_val[index].elem.host_id=hst->host_id;
  hash_val=calculate_hash(hst->name);
  cache_val[index].hash_val=hash_val;
  if(hash_tab[hash_val][0]==-1)
  {
    hash_tab[hash_val][0]=index;
    hash_tab[hash_val][1]=-1;
  }
  else
  {
    int new_hash_val=HASH_SIZE;
    while(hash_tab[hash_val][1]!=-1) hash_val=hash_tab[hash_val][1];
    while(hash_tab[new_hash_val][0]!=-1) new_hash_val++;
    hash_tab[hash_val][1]=new_hash_val;
    hash_tab[new_hash_val][0]=index;
    hash_tab[new_hash_val][1]=-1;
  }
  if(bottom==-1) bottom=top;
}

int cache_init()
{
  int i;
  hosttype hst={0,0,0,""};
  for(i=0;i<CACHE_SIZE;i++)
  {
    memcpy(&cache_val[i].elem,&hst,sizeof(hst));
    cache_val[i].pos=i;
    cache_val[i].hash_val=-1;
    positions[i]=i;
  }
  for(i=0;i<HASH_SIZE+CACHE_SIZE+1;i++)
  {
    hash_tab[i][0]=-1;
    hash_tab[i][1]=-1;
  }
}

