// Purpose: Test to use XML SQL Utility to generate XML file
//         It uses JDBC to fetch data from DB table
// Class: DbtoXML
// Author: Yuping Zhu
// Date: 07-16-1999


import java.sql.*;
import java.math.*;
import oracle.xml.sql.query.*;
import oracle.jdbc.*;
import oracle.jdbc.driver.*;


public class DbtoXml {

 public static void main(String args[]) throws SQLException
 {
   DriverManager.registerDriver
        (new oracle.jdbc.driver.OracleDriver());

   Connection conn = (Connection)
    DriverManager.getConnection("jdbc:oracle:oci8:scott/tiger@");

   Statement stmt = conn.createStatement();
   ResultSet rset = stmt.executeQuery("select * from emp");

   OracleXMLQuery qry =  new OracleXMLQuery(conn,rset);
   String xmlString = qry.getXMLString(true);

  System.out.println(" OUPUT IS "+xmlString); 
 }
} 
