// Purpose: Test insert XML into DB table
//          It uses XML SQL utility for Java calss OracleXMLSave to insert
// Class: XMLToDB
// Author: Yuping Zhu
// Date: 07-20-1999

import java.net.URL;
import java.sql.*;
import oracle.jdbc.*;
import oracle.jdbc.driver.*;
import oracle.xml.sql.dml.*;

public class XMLToDB {
  public static void main(String args[]) throws SQLException
    {
    try {
	DriverManager.registerDriver
	    (new oracle.jdbc.driver.OracleDriver());
	Connection conn = (Connection)
	    DriverManager.getConnection("jdbc:oracle:oci8:ioexml/xml@");
    
	OracleXMLSave xsave = new OracleXMLSave(conn, "emp");
    
	// Generate a URL
	URL url = xsave.createURL("empl.xml");

	// insert a XML document into DB table
	int rownum = xsave.insertXML(url);
	System.out.println("Totally insert rows: " + rownum);
        }
    catch (SQLException e) 
	{
	    System.out.println(e.getMessage());
	}
    }
}
