package ioe;

import java.io.*;

// import the packages for JDBC
import java.sql.*;
import oracle.sql.*;
import oracle.jdbc.driver.*;

// import the packages for servlet
import javax.servlet.*;
import javax.servlet.http.*;

public class MyDoc extends HttpServlet {
    public void doGet (HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
    // set the content type of the response
    res.setContentType("text/html");

     PrintWriter out = res.getWriter();
     
      try {
	// Load the Oracle JDBC driver: 
	Class.forName ("oracle.jdbc.driver.OracleDriver");
	
	// Connect to the database: 
	Connection conn =
	    DriverManager.getConnection ("jdbc:oracle:thin:@mira.npac.syr.edu:1521:mira", "ioexml", "xml");

	Connection conn1 =
	    DriverManager.getConnection ("jdbc:oracle:thin:@mira.npac.syr.edu:1521:mira", "ioexml", "xml");

	// Create a Statement: 
	Statement stmt = conn.createStatement ();

	CallableStatement cs = conn1.prepareCall
	    ("begin ctxsys.ctx_doc.filter(?,?,?,?); end;");
	
       	BLOB doc_blob = null;
	ResultSet rset = stmt.executeQuery("select title,doc,id from docs");

       	while(rset.next())
	    {
       	       	doc_blob = ((OracleResultSet)rset).getBLOB(2);
	       	out.println("Title is : " + rset.getString(1));
	  	out.println("The length of doc is : " + Long.toString(doc_blob.length()));
		out.println("<br>");
      		
	    }
	stmt.close();
	conn.close();
        
        cs.setString(1,"docindex");
		cs.setString(2,"doc-006");
		cs.setString(3,"filtertab");
		cs.setString(4,"0");
		//cs.setBoolean(5,true);
	       	cs.executeUpdate();
	Statement stmt1 = conn1.createStatement ();
	ResultSet rset1 = stmt1.executeQuery("select document from filtertab where query_id=0");
	CLOB html_doc = null;
	int num_char = 0;
 	if (rset1.next())
	    html_doc = ((OracleResultSet)rset1).getCLOB(1);
	Reader doc_stream = html_doc.getCharacterStream();
	char[] doc_buffer = new char[10];
	while ((num_char = doc_stream.read(doc_buffer)) != -1)
	    out.print(doc_buffer);
	conn1.close();
    }
    catch (SQLException e) {
    out.println(e.getMessage());
    }
    catch (ClassNotFoundException e) {
	out.println("Can not load the JDBC Driver!");
	}
    }
}
