package ioe;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import MultipartRequest;

public class UploadTest extends HttpServlet {

  public void doPost(HttpServletRequest req, HttpServletResponse res)
                           throws ServletException, IOException {
    try {
      res.setContentType("text/html");
      PrintWriter out = res.getWriter();

      // Rudely write to server root, impose artificial 1 Meg limit
      MultipartRequest multi =
        new MultipartRequest(req, "/localb/oracle/usr/ioe/temp", 1024 * 1024);

      out.println("<html>");
      out.println("<head><title>MultipartUpload</title></head>");
      out.println("<body>");
      out.println("<h1>MultipartUpload</h1>");
      
      out.println("<h3>Params:</h3>");
      out.println("<pre>");
      Enumeration params = multi.getParameterNames();
      while (params.hasMoreElements()) {
        String name = (String)params.nextElement();
        String value = multi.getParameter(name);
        out.println(name + " = " + value);
      }
      out.println("</pre>");
      
      out.println("<h3>Files:</h3>");
      out.println("<pre>");
      Enumeration files = multi.getFileNames();
      while (files.hasMoreElements()) {
        String name = (String)files.nextElement();
        String filename = multi.getFilesystemName(name);
        String type = multi.getContentType(name);
        File f = multi.getFile(name);
        out.println("name: " + name);
        out.println("filename: " + filename);
        out.println("type: " + type);
        if (f != null) {
          out.println("f.toString(): " + f.toString());
          out.println("f.getName(): " + f.getName());
          out.println("f.exists(): " + f.exists());
          out.println("f.length(): " + f.length());
          out.println();
        }
        out.println("</pre>");
	out.println("<form action=\"/servlets/ioe.LoadFileToDB\" method=\"GET\">");
        out.println("<input TYPE=hidden name=\"fname\" value=\"" + f.toString() + "\">");
	//out.println("<input TYPE=hidden name=\"fname\" value=\"tttt\">");
      out.println("<input TYPE=submit Value=\"confirm\">");
      out.println("</form>");

	}     
    }
    catch (Exception e) {
      PrintWriter out = res.getWriter();
      out.println("<pre>");
      e.printStackTrace(out);
      out.println("</pre>");
    }
  }
}
