drop package sccs1;
/
create or replace package sccs1 is

procedure bom_search_index;
procedure bom_search;
procedure bom_search(op integer,fid varchar2, stat integer);
procedure search(typein varchar2,op integer,fid varchar2,stat integer);
procedure all_bom_prod(stat integer);
procedure more_prod(total number, seed integer,stat integer);

procedure search_button(op integer,fid varchar2, stat integer);
procedure by_id(fid varchar2,p varchar2,stat integer) ;
procedure more_id(total number, seed integer, p varchar2, fid varchar2,
		stat integer);
procedure keyword(p varchar2,fid varchar2,stat integer);
procedure more_key(total number, seed integer, p varchar2, fid varchar2,
		stat integer);
procedure author(p varchar2,fid varchar2,stat integer);
procedure more_author(total number, seed integer, p varchar2, fid varchar2,
		stat integer);
procedure day(str varchar2,result out date,tag in out char) ;
procedure date_search(stat integer);
procedure parse_date(typein varchar2) ;
procedure by_date(typein varchar2,stat integer);
procedure more_date(total number, seed integer, day1 date, day2 date,
		stat integer);
procedure notyet;

end;
/
show errors;

create or replace package body sccs1 is


cgi_bin constant varchar2(60) := sccs.cgi_bin;
username constant varchar2(10) := sccs.username;
password constant varchar2(10) := sccs.password;
client varchar2(30) := sccs.client;
time_out number(8,5) := sccs.time_out;
USER_II constant integer := sccs.USER_II;
USER_III constant integer := sccs.USER_III;
ROOT constant integer := sccs.ROOT;
help_page constant varchar2(100) := sccs.help_page;
h_caption varchar2(600);
total number(8);

img_wavy constant varchar2(60) := sccs.img_wavy;
img_ringyel constant varchar2(60) := sccs.img_ringyel;
background1 constant varchar2(60) := sccs.background1;

two bom%ROWTYPE;
TYPE wordstype IS TABLE	OF varchar2(50) INDEX BY BINARY_INTEGER;
word_tab wordstype;
w_count BINARY_INTEGER;
date_tag char(1);

function td(name varchar2) return varchar2 is
begin
	return ('<td>'||name||'</td>');
end;

function th(name varchar2) return varchar2 is
begin
	return ('<th>'||name||'</th>');
end;

function tr(name varchar2) return varchar2 is
begin
	return ('<tr>'||name||'</tr>');
end;






procedure bom_search_index is
begin
/*	htp.p('<center><h2>SCCS Document Search Page</h2></center>');
	htp.p('<body background="http://osprey8.npac.syr.edu:1963/sccs/bluestone.jpg">');
htp.p('<font size=+1>');
	htp.p('<ul><li>'||htf_npac.url(cgi_bin||'sccs.bom_search','Retrieval of SCCS Production Documents'));
    htp.p('<ul><li>locate/search SCCS production document and associated attributes with
indexes, including most recent and previous revisions.
    <li>list all SCCS production document in the DB.
    <li>search certain SCCS production document which satisfy one or more
user-entered conditions/attributes, such as search by a PCA, by a part
number, effective date, revision date, etc.
        </ul>');

htp.p('<p><li>'||htf_npac.url_top(cgi_bin||'sccs.bom_admin_index','Retrieval of SCCS Pending Documents')||'(restricted access)');
        htp.p('<ul>
        <li>locate/search SCCS pending document and associated attributes with indexes.
        <li>list all SCCS pending document in the DB.
        <li>search certain SCCS pending document which satisfy one or more
user-entered conditions/attributes, such as search by a PCA, by a part
number, effective date, etc.
	<li>Other administration tasks, including load/delete/modify/move a pending document.</ul></ul></font>');
	wow.sig;*/
	bom_search(6,0,0);
end;

procedure bom_search is
begin 
	 bom_search(6,0,1);
end;

procedure search_button(op integer,fid varchar2, stat integer) is
cursor cfolder(tat integer) is 
	select distinct type from bom 
	where status = tat  order by type;
cat varchar2(100);
total number(8);

begin
	htp.bodyOpen(background1);
	--htp.p('<body background="http://osprey8.npac.syr.edu:1963/sccs/bluestone.jpg">');
--	htp.p('<img src="http://osprey8.npac.syr.edu:1963/sccs/rgb_xyz.gif">');
	htp.p('<CENTER>');
	htp.p('<table border=0 align=center><tr><td colspan="2">');
	htp.formOpen(cgi_bin||'sccs1.search');	
	htp.p(htf_npac.url_top('http://www.npac.syr.edu/','<img src="http://indeo.npac.syr.edu:81/sccs/search.gif" border=0 align="middle">'));
	htp.p('<input name="typein" size="40" value=""> ');
	htp.p('<input type="submit" value="Search"> ');
	htp.p(help_page);
	--htp.p('<a href="http://osprey8.npac.syr.edu:1963/sccs/help.html"><img src="http://osprey8.npac.syr.edu:1963/sccs/button-help.gif" width=48></a>');
	htp.p('</td></tr><tr align=center><td><font size="2">By: ');
	htp.formSelectOpen('op');
	if (op = 0) then
		htp.p('<option value="0" selected>Keyword(in title and abstract)');	
	else
		htp.p('<option value="0">Keyword(in title and abstract)');
	end if;	
	if (op = 1) then
		htp.p('<option value="1" selected>SCCS ID');
	else
		htp.p('<option value="1">SCCS ID');
	end if;
	if ( op = 6) then
		htp.p('<option value="6" selected>List All');	
	else
		htp.p('<option value="6">List All');	
	end if;
	if ( op = 2) then
		htp.p('<option value="2" selected>Publication Date');
	else
		htp.p('<option value="2">Publication Date');
	end if;

	if ( op = 3) then
		htp.p('<option value="3" selected>Author Name');
	else
		htp.p('<option value="3">Author Name');
	end if;
	htp.p('<input type="hidden" name="stat" value="'||stat||'">');
	htp.p(htf.formSelectClose);	
	htp.p('</font></td>');
	htp.p('<td><font size="2">Category:');
	select count(*) into total from bom where status=stat;
	if (total > 20) then
		htp.p('<select name="fid" size="2">');
	else
		htp.p('<select name="fid">');
	end if;
	if (fid = '0') then
		htp.p('<option value="0" selected>All');
	else
		htp.p('<option value="0">All');
	end if;
	for bom in cfolder(stat) loop
		if (bom.type = 1) then
			cat := 'Technical Report';
		elsif (bom.type = 2) then
			cat := 'Conference Paper';
		elsif (bom.type = 3) then
			cat := 'Journal Paper';
		elsif (bom.type = 4) then
			cat := 'Internal Proposal';
		else
			cat := 'Unknown';
		end if;
		if (fid = bom.type) then
	   		htp.p('<option value="'||bom.type||'" selected>'||cat);
		else
	   		htp.p('<option value="'||bom.type||'">'||cat);
		end if;
	end loop;
	htp.p(htf.formSelectClose);
	htp.p('</font></td></tr>');
	htp.p(htf.formClose);
	htp.p('</table></CENTER>');

end;

procedure bom_search(op integer,fid varchar2, stat integer) is
	begin
		search_button(op,fid, stat);
		all_bom_prod(stat);
	end;

procedure search(typein varchar2,op integer,fid varchar2, stat integer) is
begin
	if ((op = 6 ) and fid='0') then
	   if (stat = 1) then
		bom_search;
	   else
		bom_search_index;
	   end if;
		return;
	end if;
	if (op=6) then
		by_id(fid,NULL,stat);
		return;
	end if;
	if (op=1) then
		by_id(fid,lower(typein), stat);
		return;
	end if;

	if (op=0) then
		keyword(lower(typein),fid,stat);
		return;
	end if;
	if (op=2) then
		by_date(typein, stat);
		return;
	end if;
	if (op=3) then
		author(lower(typein),fid, stat);
		return;
	end if;
	notyet;

	wow.sig;
end;


procedure keyword(p varchar2,fid varchar2,stat integer) is
cursor cuser(p varchar2,tat integer) is select * from bom where status=tat
	and (lower(title||abs) like '%'||p||'%') order by id desc;
num integer := 0;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin
	search_button(0,fid,stat);
	htp.p('<hr width=80%>');

	open cuser(p,stat);
	h_caption := ' containing keyword '||htf.bold(p);
	if (stat = 1) then
		htp.p('<center><font size=+1>SCCS Production Documents');
	else 
		htp.p('<center><font size=+1>SCCS Pending Documents');
	end if;
	htp.p(h_caption||'</font></center>'); 	
	htp.p('<hr><DL>');	
	loop
	   fetch cuser into two;
	   exit when cuser%NOTFOUND;
	   num := num + 1;
	end loop;
	if ( num =0 ) then
	    htp.p('<center>');
	   -- htp.p('<img src="http://osprey8.npac.syr.edu:1963/sccs/ringyel.gif">');
	    htp.img(img_ringyel);
	    htp.p('<p>The document '||h_caption||' dose not exist!</cneter>');
	    return; 
	end if;

	total := num;
--	total := cuser%ROWCOUNT;
	close cuser;
	if (total > 0 ) then  
		next := 11;
		if ( next<=total) then
                    if ((next+10)<=total) then
                        next_str := (next+9);
                    else
                        next_str := total;
                    end if;
                    next_str := next||'-'||next_str;
                    curr_str := next - 1;
                else
                    curr_str := total;
                end if;
		htp.p('<center><table border=0><tr>');
		htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
		htp.p('<td>Current: '||'1 -'||curr_str||' ');
		if (next_str IS NOT NULL) then
		    htp.p(' <b>|</b> <td align=right>');
		    htp.p(htf_npac.url(cgi_bin||'sccs1.more_key?total='||total||
			'&seed='||next||'&p='||p||'&fid='||fid||'&stat='||
			stat,'Next '||next_str));
		end if;
		htp.p('</table></center><dl>');
		open cuser(p,stat);
		num := 0;
		loop
		   fetch cuser into two;
		   exit when cuser%NOTFOUND;
		   num := num + 1;
		   htp.p('<p><dt><b>SCCS-'||two.id||'</b>:');
		   if (two.url IS NOT NULL) then
			htp.p('<i>'||htf_npac.url(two.url,two.title)||'</i>');
		   else 
			htp.p('<i>'||two.title||'</i>');
		   end if;
		   htp.p('<dd>'||two.author);
		   htp.p('; <i>'||to_char(two.pub_date,'mm-dd-yy')||'</i>');
		   if (two.abs IS NOT NULL) then
			htp.p('<br>');
			htp.p(two.abs);
		   end if;
		   if ( num = 10 ) then
			exit;
		    end if;
	    	end loop;		

	htp.p('</DL>');
	--htp.p('Total: '||htf.bold(cuser%ROWCOUNT));
	--htp.p('<img src="http://osprey8.npac.syr.edu:1963/sccs/wavy.gif">');
	htp.img(img_wavy);
		htp.p('<center>');
		htp.p(' p.');
       		n := ceil(total/10);
        	if (n > 20) then n := 20; end if;
		for i in 1..n loop
		   iseed := (i-1)*10 + 1;
		   if (iseed = 0 ) then
			htp.p(' '||i);
		   else
			htp.p(' '||htf_npac.url(cgi_bin||'sccs1.more_key?total='||
				total||'&seed='||iseed||'&p='||p||'&fid='||
				fid||'&stat='||stat,i));
		   end if;
		end loop;
		if (next_str IS NOT NULL) then
		   htp.p('['||htf_npac.url(cgi_bin||'sccs1.more_key?total='||total||
			'&seed='||next||'&p='||p||'&fid='||fid||
			'&stat='||stat,'Next')||']');
		end if;
		htp.p('</center>');
	else
		htp.p('No SCCS Production Document Found');
	end if;
	close cuser;
	wow.sig;
end;

procedure more_key(total number, seed integer, p varchar2, fid varchar2,
		stat integer) is
cursor cuser(p varchar2,tat integer) is select * from bom where status=tat
	and (lower(title||abs) like '%'||p||'%') order by id desc;
num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin
	search_button(0,fid,stat);
	htp.p('<hr width=80%>');

--	open cuser(p);
	h_caption := ' containing keyword '||htf.bold(p);
	htp.p('<center><font size=+1>SCCS Production Documents');
	htp.p(h_caption||'</font></center>'); 	
	htp.p('<hr><DL>');	
	next := seed + 10;
	if (next<=total) then
                if ((next+10)<=total) then
                        next_str := (next+9);
                else
                        next_str := total;
                end if;
                next_str := next||'-'||next_str;
                curr_str := next - 1;
        else
                curr_str := total;
        end if;
        prev := seed - 10;
        if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
        elsif (seed > 1) then
                        prev := 1;
                        prev_str := '1-'|| 10;
        end if;
	htp.p('<center><table border=0><tr>');
        htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
        htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
                htp.p(' <b>|</b> <td align=right>');
		htp.p(htf_npac.url(cgi_bin||'sccs1.more_key?total='||total||
			'&seed='||next||'&p='||p||'&fid='||fid||
			'&stat='||stat,'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
                htp.p(' <b>|</b><td align=right>');
		htp.p(htf_npac.url(cgi_bin||'sccs1.more_key?total='||total||
			'&seed='||prev||'&p='||p||'&fid='||fid||'&stat='||stat,
			'Prev '||prev_str));
	end if;
	htp.p('</table></center><dl>');
	open cuser(p,stat);
	num := 0;
	loop
		fetch cuser into two;
		exit when cuser%NOTFOUND;
		num := num + 1;
		if (num >= seed) then
			htp.p('<p><dt><b>SCCS-'||two.id||'</b>:');
			if (two.url IS NOT NULL) then
				htp.p('<i>'||htf_npac.url(two.url,two.title)||'</i>');
			else 
				htp.p('<i>'||two.title||'</i>');
			end if;
			htp.p('<dd>'||two.author);
			htp.p('; <i>'||to_char(two.pub_date,'mm-dd-yy')||'</i>');
			if (two.abs IS NOT NULL) then
				htp.p('<br>');
				htp.p(two.abs);
				htp.p('</h3>');
			end if;
		end if;
		if ( num >= (seed + 9) ) then
		    	exit;
		end if;
	end loop;		
	close cuser;
	htp.p('</DL>');
	--htp.p('<img src="http://osprey8.npac.syr.edu:1963/sccs/wavy.gif">');
	htp.img(img_wavy);
	htp.p('<center>');
	htp.p(' p.');
       	n := ceil(total/10);
        if (n > 20) then n := 20; end if;
	for i in 1..n loop
	   iseed := (i-1)*10 + 1;
	   if (iseed = 0 ) then
		htp.p(' '||i);
	   else
		htp.p(' '||htf_npac.url(cgi_bin||'sccs1.more_key?total='||
			total||'&seed='||iseed||'&p='||p||'&fid='||fid
			||'&stat='||stat,i));
	   end if;
	end loop;
	if (next_str IS NOT NULL) then
		htp.p('['||htf_npac.url(cgi_bin||'sccs1.more_key?total='||total||
			'&seed='||next||'&p='||p||'&fid='||fid
			||'&stat='||stat,'Next')||']');
	end if;
	htp.p('</center>');
	wow.sig;
end;	


procedure author(p varchar2,fid varchar2,stat integer) is
cursor cuser(p varchar2,tat integer) is select * from bom where status=tat
	and (lower(author) like '%'||p||'%') order by id desc;
num integer := 0;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin
	search_button(3,fid,stat);
	htp.p('<hr width=80%>');
	open cuser(p,stat);
	h_caption := ' authored by *'||htf.bold(p)||'*';
	htp.p('<center><font size=+1>SCCS Production Documents');
	htp.p(h_caption||'</font></center>'); 	
	htp.p('<hr><DL>');
	loop
	   fetch cuser into two;
	   exit when cuser%NOTFOUND;
	   num := num + 1;
	end loop;
	if ( num =0 ) then
	    htp.p('<center>');
	    --htp.p('<img src="http://osprey8.npac.syr.edu:1963/sccs/ringyel.gif">');
	    htp.img(img_ringyel);
	    htp.p('<p>The document '||h_caption||' dose not exist!</cneter>'); 
	    return;
	end if;
	total := num;
--	total := cuser%ROWCOUNT;
	close cuser;
	if (total > 0 ) then  
		next := 11;
		if ( next<=total) then
                    if ((next+10)<=total) then
                        next_str := (next+9);
                    else
                        next_str := total;
                    end if;
                    next_str := next||'-'||next_str;
                    curr_str := next - 1;
                else
                    curr_str := total;
                end if;
		htp.p('<center><table border=0><tr>');
		htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
		htp.p('<td>Current: '||'1 -'||curr_str||' ');
		if (next_str IS NOT NULL) then
		    htp.p(' <b>|</b> <td align=right>');
		    htp.p(htf_npac.url(cgi_bin||'sccs1.more_author?total='||total||
			'&seed='||next||'&p='||p||'&fid='||fid||'&stat='||stat,
			'Next '||next_str));
		end if;
		htp.p('</table></center><dl>');
		open cuser(p,stat);
		num := 0;
		loop
		   fetch cuser into two;
		   exit when cuser%NOTFOUND;
		   num := num + 1;
		   htp.p('<p><dt><b>SCCS-'||two.id||'</b>:');
		   if (two.url IS NOT NULL) then
			htp.p('<i>'||htf_npac.url(two.url,two.title)||'</i>');
		   else 
			htp.p('<i>'||two.title||'</i>');
		   end if;
		   htp.p('<dd>'||two.author);
		   htp.p('; <i>'||to_char(two.pub_date,'mm-dd-yy')||'</i>');
		   if (two.abs IS NOT NULL) then
			htp.p('<br>');
			htp.p(two.abs);
		   end if;
		   if ( num = 10 ) then
			exit;
		    end if;
	    	end loop;			

	htp.p('</DL>');
	--htp.p('<img src="http://osprey8.npac.syr.edu:1963/sccs/wavy.gif">');
	htp.img(img_wavy);
		htp.p('<center>');
		htp.p(' p.');
       		n := ceil(total/10);
        	if (n > 20) then n := 20; end if;
		for i in 1..n loop
		   iseed := (i-1)*10 + 1;
		   if (iseed = 0 ) then
			htp.p(' '||i);
		   else
			htp.p(' '||htf_npac.url(cgi_bin||'sccs1.more_author?total='
				||total||'&seed='||iseed||'&p='||p||'&fid='||
				fid||'&stat='||stat,i));
		   end if;
		end loop;
		if (next_str IS NOT NULL) then
		   htp.p('['||htf_npac.url(cgi_bin||'sccs1.more_author?total='||
			total||'&seed='||next||'&p='||p||'&fid='||fid
			||'&stat='||stat,'Next')||']');
		end if;
		htp.p('</center>');
	else
		htp.p('No SCCS Production Document Found');
	end if;
	close cuser;
	wow.sig;
end;

procedure more_author(total number, seed integer, p varchar2, fid varchar2,
		stat integer) is
cursor cuser(p varchar2,tat integer) is select * from bom where status=tat
	and (lower(author) like '%'||p||'%') order by id desc;
num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin
	search_button(3,fid,stat);
	htp.p('<hr width=80%>');

--	open cuser(p);
	h_caption := ' containing keyword '||htf.bold(p);
	htp.p('<center><font size=+1>SCCS Production Documents');
	htp.p(h_caption||'</font></center>'); 	
	htp.p('<hr><DL>');	
	next := seed + 10;
	if (next<=total) then
                if ((next+10)<=total) then
                        next_str := (next+9);
                else
                        next_str := total;
                end if;
                next_str := next||'-'||next_str;
                curr_str := next - 1;
        else
                curr_str := total;
        end if;
        prev := seed - 10;
        if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
        elsif (seed > 1) then
                        prev := 1;
                        prev_str := '1-'|| 10;
        end if;
	htp.p('<center><table border=0><tr>');
        htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
        htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
                htp.p(' <b>|</b> <td align=right>');
		htp.p(htf_npac.url(cgi_bin||'sccs1.more_author?total='||total||
			'&seed='||next||'&p='||p||'&fid='||fid
			||'&stat='||stat,'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
                htp.p(' <b>|</b><td align=right>');
		htp.p(htf_npac.url(cgi_bin||'sccs1.more_author?total='||total||
			'&seed='||prev||'&p='||p||'&fid='||fid||'&stat='||stat,
			'Prev '||prev_str));
	end if;
	htp.p('</table></center><dl>');
	open cuser(p,stat);
	num := 0;
	loop
		fetch cuser into two;
		exit when cuser%NOTFOUND;
		num := num + 1;
		if (num >= seed) then
			htp.p('<p><dt><b>SCCS-'||two.id||'</b>:');
			if (two.url IS NOT NULL) then
				htp.p('<i>'||htf_npac.url(two.url,two.title)||'</i>');
			else 
				htp.p('<i>'||two.title||'</i>');
			end if;
			htp.p('<dd>'||two.author);
			htp.p('; <i>'||to_char(two.pub_date,'mm-dd-yy')||'</i>');
			if (two.abs IS NOT NULL) then
				htp.p('<br>');
				htp.p(two.abs);
				htp.p('</h3>');
			end if;
		end if;
		if ( num >= (seed + 9) ) then
		    	exit;
		end if;
	end loop;		
	close cuser;
	htp.p('</DL>');
	--htp.p('<img src="http://osprey8.npac.syr.edu:1963/sccs/wavy.gif">');
	htp.img(img_wavy);
	htp.p('<center>');
	htp.p(' p.');
       	n := ceil(total/10);
        if (n > 20) then n := 20; end if;
	for i in 1..n loop
	   iseed := (i-1)*10 + 1;
	   if (iseed = 0 ) then
		htp.p(' '||i);
	   else
		htp.p(' '||htf_npac.url(cgi_bin||'sccs1.more_author?total='||
			total||'&seed='||iseed||'&p='||p||'&fid='||fid
			||'&stat='||stat,i));
	   end if;
	end loop;
	if (next_str IS NOT NULL) then
		htp.p('['||htf_npac.url(cgi_bin||'sccs1.more_author?total='||total||
			'&seed='||next||'&p='||p||'&fid='||fid||
			'&stat='||stat,'Next')||']');
	end if;
	htp.p('</center>');
	wow.sig;
end;

procedure by_id(fid varchar2, stat integer) is
begin by_id(fid,NULL,stat); end;

procedure by_id(fid varchar2,p varchar2, stat integer) is
cursor cuser(docid varchar2, tat integer) is select * from bom where status=tat
--	and (id=docid) order by id desc;
	and (lower(id) like '%'||docid||'%') order by id desc;
num integer := 0;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin
	search_button(1,fid,stat);
	if p IS NULL then
		if (fid = '0') then
			all_bom_prod(stat);
			return;
		end if;
	end if;
	open cuser(p,stat);
	h_caption := 'with SCCS ID ='||htf.bold(p);

	htp.p('<hr width=80%>');
	htp.p('<center>');
	htp.p('<caption>SCCS Documents '||h_caption||'</caption></center>');
	htp.p('<hr><DL>');
	loop
	   fetch cuser into two;
	   exit when cuser%NOTFOUND;
	   num := num + 1;
	end loop;
	if ( num =0 ) then
	    htp.p('<center>');
	    --htp.p('<img src="http://osprey8.npac.syr.edu:1963/sccs/ringyel.gif">');
	    htp.img(img_ringyel);
	    htp.p('<p>The document '||h_caption||' does not exist!</cneter>');
	    return; 
	end if;

	total := num;
	close cuser;
	if (total > 0 ) then  
		next := 11;
		if ( next<=total) then
                    if ((next+10)<=total) then
                        next_str := (next+9);
                    else
                        next_str := total;
                    end if;
                    next_str := next||'-'||next_str;
                    curr_str := next - 1;
                else
                    curr_str := total;
                end if;
		htp.p('<center><table border=0><tr>');
		htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
		htp.p('<td>Current: '||'1 -'||curr_str||' ');
		if (next_str IS NOT NULL) then
		    htp.p(' <b>|</b> <td align=right>');
		    htp.p(htf_npac.url(cgi_bin||'sccs1.more_id?total='||total||
			'&seed='||next||'&p='||p||'&fid='||fid||'&stat='||stat,
			'Next '||next_str));
		end if;
		htp.p('</table></center><dl>');
		open cuser(p,stat);
		num := 0;
		loop
		   fetch cuser into two;
		   exit when cuser%NOTFOUND;
		   num := num + 1;
		   htp.p('<p><dt><b>SCCS-'||two.id||'</b>:');
		   if (two.url IS NOT NULL) then
			htp.p('<i>'||htf_npac.url(two.url,two.title)||'</i>');
		   else 
			htp.p('<i>'||two.title||'</i>');
		   end if;
		   htp.p('<dd>'||two.author);
		   htp.p('; <i>'||to_char(two.pub_date,'mm-dd-yy')||'</i>');
		   if (two.abs IS NOT NULL) then
			htp.p('<br>');
			htp.p(two.abs);
		   end if;
		   if ( num = 10 ) then
			exit;
		    end if;
	    	end loop;			

	htp.p('</DL>');
	--htp.p('<img src="http://osprey8.npac.syr.edu:1963/sccs/wavy.gif">');
	htp.img(img_wavy);
		htp.p('<center>');
		htp.p(' p.');
       		n := ceil(total/10);
        	if (n > 20) then n := 20; end if;
		for i in 1..n loop
		   iseed := (i-1)*10 + 1;
		   if (iseed = 0 ) then
			htp.p(' '||i);
		   else
			htp.p(' '||htf_npac.url(cgi_bin||'sccs1.more_id?total='||
				total||'&seed='||iseed||'&p='||p||'&fid='||
				fid||'&stat='||stat,i));
		   end if;
		end loop;
		if (next_str IS NOT NULL) then
		   htp.p('['||htf_npac.url(cgi_bin||'sccs1.more_id?total='||total||
			'&seed='||next||'&p='||p||'&fid='||fid
			||'&stat='||stat,'Next')||']');
		end if;
		htp.p('</center>');
	else
		htp.p('No SCCS Production Document Found');
	end if;
	close cuser;
	wow.sig;
end;

procedure more_id(total number, seed integer, p varchar2, fid varchar2,
		stat integer) is
cursor cuser(p varchar2,tat integer) is select * from bom where status=tat
	and (lower(id) like '%'||p||'%') order by id desc;
num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin
	search_button(1,fid, stat);
	htp.p('<hr width=80%>');

	h_caption := ' with SCCS ID =  '||htf.bold(p);
	htp.p('<center><font size=+1>SCCS Production Documents');
	htp.p(h_caption||'</font></center>'); 	
	htp.p('<hr><DL>');	
	next := seed + 10;
	if (next<=total) then
                if ((next+10)<=total) then
                        next_str := (next+9);
                else
                        next_str := total;
                end if;
                next_str := next||'-'||next_str;
                curr_str := next - 1;
        else
                curr_str := total;
        end if;
        prev := seed - 10;
        if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
        elsif (seed > 1) then
                        prev := 1;
                        prev_str := '1-'|| 10;
        end if;
	htp.p('<center><table border=0><tr>');
        htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
        htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
                htp.p(' <b>|</b> <td align=right>');
		htp.p(htf_npac.url(cgi_bin||'sccs1.more_id?total='||total||
			'&seed='||next||'&p='||p||'&fid='||fid||
			'&stat='||stat,'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
                htp.p(' <b>|</b><td align=right>');
		htp.p(htf_npac.url(cgi_bin||'sccs1.more_id?total='||total||
			'&seed='||prev||'&p='||p||'&fid='||fid||'&stat='||stat,
			'Prev '||prev_str));
	end if;
	htp.p('</table></center><dl>');
	open cuser(p,stat);
	num := 0;
	loop
		fetch cuser into two;
		exit when cuser%NOTFOUND;
		num := num + 1;
		if (num >= seed) then
			htp.p('<p><dt><b>SCCS-'||two.id||'</b>:');
			if (two.url IS NOT NULL) then
				htp.p('<i>'||htf_npac.url(two.url,two.title)||'</i>');
			else 
				htp.p('<i>'||two.title||'</i>');
			end if;
			htp.p('<dd>'||two.author);
			htp.p('; <i>'||to_char(two.pub_date,'mm-dd-yy')||'</i>');
			if (two.abs IS NOT NULL) then
				htp.p('<br>');
				htp.p(two.abs);
				htp.p('</h3>');
			end if;
		end if;
		if ( num >= (seed + 9) ) then
		    	exit;
		end if;
	end loop;		
	close cuser;
	htp.p('</DL>');
	--htp.p('<img src="http://osprey8.npac.syr.edu:1963/sccs/wavy.gif">');
	htp.img(img_wavy);
	htp.p('<center>');
	htp.p(' p.');
       	n := ceil(total/10);
        if (n > 20) then n := 20; end if;
	for i in 1..n loop
	   iseed := (i-1)*10 + 1;
	   if (iseed = 0 ) then
		htp.p(' '||i);
	   else
		htp.p(' '||htf_npac.url(cgi_bin||'sccs1.more_id?total='||
			total||'&seed='||iseed||'&p='||p||'&fid='||fid
			||'&stat='||stat,i));
	   end if;
	end loop;
	if (next_str IS NOT NULL) then
		htp.p('['||htf_npac.url(cgi_bin||'sccs1.more_id?total='||total||
			'&seed='||next||'&p='||p||'&fid='||fid||
			'&stat='||stat,'Next')||']');
	end if;
	htp.p('</center>');
	wow.sig;
end;




procedure all_bom_prod(stat integer) is
cursor cuser(tat integer) is select * from bom where status=tat 
	order by id desc;
h_time varchar2(50) := '<br>';
h_desc varchar2(2000);
h_status varchar2(30):= 'Production';
num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin
	htp.p('<hr width=80%>');
	select count(*) into total from bom where  status=stat;
	if (total > 0 ) then  
		htp.p('<center><h3>List of NPAC SCCS Documents</h3></center>');
		htp.p('<hr><DL>');
		next := 11;
		if ( next<=total) then
                    if ((next+10)<=total) then
                        next_str := (next+9);
                    else
                        next_str := total;
                    end if;
                    next_str := next||'-'||next_str;
                    curr_str := next - 1;
                else
                    curr_str := total;
                end if;
		htp.p('<center><table border=0><tr>');
		htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
		htp.p('<td>Current: '||'1 -'||curr_str||' ');
		if (next_str IS NOT NULL) then
		    htp.p(' <b>|</b> <td align=right>');
		    htp.p(htf_npac.url(cgi_bin||'sccs1.more_prod?total='||total||
			'&seed='||next||'&stat='||stat,'Next '||next_str));
		end if;
		htp.p('</table></center><dl>');
		open cuser(stat);
		num := 0;
		loop
			fetch cuser into two;
			exit when cuser%NOTFOUND;
			num := num + 1;
			htp.p('<p><dt><b>SCCS-'||two.id||'</b>:');
			if (two.url IS NOT NULL) then
				htp.p('<i>'||htf_npac.url(two.url,two.title)||'</i>');
			else 
				htp.p('<i>'||two.title||'</i>');
			end if;
			htp.p('<dd>'||two.author);
			htp.p('; <i>'||to_char(two.pub_date,'mm-dd-yy')||'</i>');
			if (two.abs IS NOT NULL) then
				htp.p('<br>');
				htp.p(two.abs);
			end if;
		 	if ( num = 10 ) then
			    	exit;
			end if;
		end loop;		
		close cuser;
		htp.p('</DL>');
		--htp.p('<img src="http://osprey8.npac.syr.edu:1963/sccs/wavy.gif">');
		htp.img(img_wavy);
		htp.p('<center>');
		htp.p(' p.');
       		n := ceil(total/10);
        	if (n > 20) then n := 20; end if;
		for i in 1..n loop
		   iseed := (i-1)*10 + 1;
		   if (iseed = 0 ) then
			htp.p(' '||i);
		   else
			htp.p(' '||htf_npac.url(cgi_bin||'sccs1.more_prod?total='||
				total||'&seed='||iseed||'&stat='||stat,i));
		   end if;
		end loop;
		if (next_str IS NOT NULL) then
		   htp.p('['||htf_npac.url(cgi_bin||'sccs1.more_prod?total='||total
			||'&seed='||next||'&stat='||stat,'Next')||']');
		end if;
		htp.p('</center>');
	else
		htp.p('No SCCS Production document yet.');
	end if;
end;	

procedure more_prod(total number, seed integer,stat integer) is
cursor cuser(tat integer) is select * from bom where status=tat 
	order by id desc;
h_time varchar2(50) := '<br>';
h_desc varchar2(2000);
h_status varchar2(30):= 'Production';
num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;
	
begin
	search_button(6,0,stat);
	htp.p('<hr width=80%>');
	htp.p('<center><h3>List of NPAC SCCS Documents</h3></center>');
	htp.p('<hr><DL>');
	next := seed + 10;
	if (next<=total) then
                if ((next+10)<=total) then
                        next_str := (next+9);
                else
                        next_str := total;
                end if;
                next_str := next||'-'||next_str;
                curr_str := next - 1;
        else
                curr_str := total;
        end if;
        prev := seed - 10;
        if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
        elsif (seed > 1) then
                        prev := 1;
                        prev_str := '1-'|| 10;
        end if;
	htp.p('<center><table border=0><tr>');
        htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
        htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
                htp.p(' <b>|</b> <td align=right>');
		htp.p(htf_npac.url(cgi_bin||'sccs1.more_prod?total='||total||
			'&seed='||next||'&stat='||stat,'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
                htp.p(' <b>|</b><td align=right>');
		htp.p(htf_npac.url(cgi_bin||'sccs1.more_prod?total='||total||
			'&seed='||prev||'&stat='||stat,'Prev '||prev_str));
	end if;
	htp.p('</table></center><dl>');
	open cuser(stat);
	num := 0;
	loop
		fetch cuser into two;
		exit when cuser%NOTFOUND;
		num := num + 1;
		if (num >= seed) then
			htp.p('<p><dt><b>SCCS-'||two.id||'</b>:');
			if (two.url IS NOT NULL) then
				htp.p('<i>'||htf_npac.url(two.url,two.title)||'</i>');
			else 
				htp.p('<i>'||two.title||'</i>');
			end if;
			htp.p('<dd>'||two.author);
			htp.p('; <i>'||to_char(two.pub_date,'mm-dd-yy')||'</i>');
			if (two.abs IS NOT NULL) then
				htp.p('<br>');
				htp.p(two.abs);
				htp.p('</h3>');
			end if;
		end if;
		if ( num >= (seed + 9) ) then
		    	exit;
		end if;
	end loop;		
	close cuser;
	htp.p('</DL>');
	--htp.p('<img src="http://osprey8.npac.syr.edu:1963/sccs/wavy.gif">');
	htp.img(img_wavy);
	htp.p('<center>');
	htp.p(' p.');
       	n := ceil(total/10);
        if (n > 20) then n := 20; end if;
	for i in 1..n loop
	   iseed := (i-1)*10 + 1;
	   if (iseed = 0 ) then
		htp.p(' '||i);
	   else
		htp.p(' '||htf_npac.url(cgi_bin||'sccs1.more_prod?total='||
			total||'&seed='||iseed||'&stat='||stat,i));
	   end if;
	end loop;
	if (next_str IS NOT NULL) then
		htp.p('['||htf_npac.url(cgi_bin||'sccs1.more_prod?total='||total||
			'&seed='||next||'&stat='||stat,'Next')||']');
	end if;
	htp.p('</center>');
end;	

procedure notyet is
begin
	search_button(6,0,1);
	htp.p('<hr><center>Sorry, this function has not implemented yet in the demo. Stay tuned!');
end;



procedure by_date(typein varchar2,stat integer) is

begin
	parse_date(typein);
	if (w_count = 0) then
		bom_search;
	else
		search_button(2,0,stat);
		htp.p('<HR WIDTH="60%" ALIGN="CENTER">');
		date_search(stat);
	end if;
end;


procedure parse_date(typein varchar2) is
words varchar2(300);
i integer := 1;
j integer;
n integer;
begin
	w_count := 0;
	words := typein;
	while ((words IS NOT NULL) and (substr(words,1,1) = ' ')) loop
			words := substr(words,2);
	end loop;
	if (words IS NULL) then
		return;
	end if;
	n := length(words);
	-- 47 = '/'; 48-57 = '0'-'9'
	while (i<=n and (ascii(substr(words,i,1)) between 47 and 57)) loop
		i := i + 1;
	end loop;
	if (i = 1) then
		words := substr(words,2); 	
		while ((words IS NOT NULL) and not (ascii(substr(words,1,1)) between 47 and 57)) loop
			words := substr(words,2);
		end loop;
		-- when i>n w_count=0 is used to indicate the null typein
		if (words IS NOT NULL) then
			date_tag := '<'; -- before one date
			n := length(words);
			i := 1;
			while (i<=n and (ascii(substr(words,i,1)) between 47 and 57)) loop
				i := i + 1;
			end loop;
			w_count := w_count + 1;
			word_tab(w_count) := substr(words,1,i-1);
		end if;
	elsif (i > n) then
		date_tag := 'o';	-- one date item only
		w_count := w_count + 1;
		word_tab(w_count) := words;
	else
		w_count := w_count + 1;
		word_tab(w_count) := substr(words,1,i-1);
		words := substr(words,i);
		n := length(words);
		i := 1;
		while (i<=n and not (ascii(substr(words,i,1)) between 47 and 57)) loop
			i := i + 1;
		end loop;		
		if (i > n) then
			date_tag := '>';	-- after one date
		else
			date_tag := 'b';	-- between two date items	
			words := substr(words,i);
			n := length(words);
			i := 1;
			while (i<=n and (ascii(substr(words,i,1)) between 47 and 57)) loop
				i := i + 1;
			end loop;
			w_count := w_count + 1;
			word_tab(w_count) := substr(words,1,i-1);
		end if;
	end if;
end;

procedure date_search(stat integer) is

cursor cdate(date1 date,date2 date,tat integer) is
	select * from bom where status = tat and
	(pub_date between date1 and date2)
	order by id desc;
day1 date;
day2 date;
tag char(1);
num integer := 0;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

words varchar2(100);
begin
	day(word_tab(1),day1,tag);
	if (day1 = NULL) then return; end if;
	if (date_tag = 'b') then
		day(word_tab(2),day2,tag);
		if (day2 = NULL) then return; end if;
		if (tag = 'y') then
			day2 := to_date('3112'||to_char(day2,'yy'),'ddmmyy');
		elsif (tag = 'm') then
			day2 := to_date(to_char(last_day(day2),'dd')||to_char(day2,'mmyy'),'ddmmyy');
		end if;
		words := 'Between <b>'||to_char(day1,'mm/dd/yy')||'</b> And <b>'||
			to_char(day2,'mm/dd/yy')||'</b>';
	elsif (date_tag = 'o') then
		if (tag = 'y') then
			day2 := to_date('3112'||to_char(day1,'yy'),'ddmmyy');
			words := 'in <b>'||to_char(day1,'yyyy')||'</b>';
		elsif (tag = 'm') then
			day2 := to_date(to_char(last_day(day1),'dd')||to_char(day1,'mmyy'),'ddmmyy');
			words := 'in <b>'||to_char(day1,'Month yy')||'</b>';
		else
			day2 := day1 + 1;
			words := 'on <b>'||to_char(day1,'mm/dd/yy')||'</b>';
		end if;
	elsif (date_tag = '>') then
	--	day2 := to_date('2050','yyyy');
		day2 := to_date(to_char(sysdate,'ddmmyyyy'),'ddmmyyyy');
		words := 'After <b>'||to_char(day1,'mm/dd/yy')||'</b>';
	else
		day2 := day1;
		day1 := to_date('01011985','ddmmyyyy');
		words := 'Before <b>'||to_char(day2,'mm/dd/yy')||'</b>';
	end if;

	open cdate(day1,day2,stat);

	h_caption := 'publicated  between '||htf.bold(day1)||' and '||
			htf.bold(day2);

	htp.p('<center>');
--	htp.p('day1='||day1||'day2='||day2||'</center>');
	htp.p('<caption>SCCS Documents '||h_caption||'</caption></center>');
	htp.p('<hr><DL>');
	loop
	   fetch cdate into two;
	   exit when cdate%NOTFOUND;
	   num := num + 1;
	end loop;
	if ( num =0 ) then
	    htp.p('<center>');
	    --htp.p('<img src="http://osprey8.npac.syr.edu:1963/sccs/ringyel.gif">');
	    htp.img(img_ringyel);
	    htp.p('<p>The document '||h_caption||' dose not exist!</cneter>');
	    return; 
	end if;

	total := num;
--	total := cdate%ROWCOUNT;
	close cdate;

	if (total > 0 ) then  
		next := 11;
		if ( next<=total) then
                    if ((next+10)<=total) then
                        next_str := (next+9);
                    else
                        next_str := total;
                    end if;
                    next_str := next||'-'||next_str;
                    curr_str := next - 1;
                else
                    curr_str := total;
                end if;
		htp.p('<center><table border=0><tr>');
		htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
		htp.p('<td>Current: '||'1 -'||curr_str||' ');
		if (next_str IS NOT NULL) then
		    htp.p(' <b>|</b> <td align=right>');
		    htp.p(htf_npac.url(cgi_bin||'sccs1.more_date?total='||total||
			'&seed='||next||'&day1='||day1||'&day2='||day2||
			'&stat='||stat,'Next '||next_str));
		end if;
		htp.p('</table></center><dl>');
		open cdate(day1,day2,stat);
		num := 0;
		loop
		   fetch cdate into two;
		   exit when cdate%NOTFOUND;
		   num := num + 1;
		   htp.p('<p><dt><b>SCCS-'||two.id||'</b>:');
		   if (two.url IS NOT NULL) then
			htp.p('<i>'||htf_npac.url(two.url,two.title)||'</i>');
		   else 
			htp.p('<i>'||two.title||'</i>');
		   end if;
		   htp.p('<dd>'||two.author);
		   htp.p('; <i>'||to_char(two.pub_date,'mm-dd-yy')||'</i>');
		   if (two.abs IS NOT NULL) then
			htp.p('<br>');
			htp.p(two.abs);
		   end if;
		   if ( num = 10 ) then
			exit;
		    end if;
	    	end loop;			

	htp.p('</DL>');
	--htp.p('<img src="http://osprey8.npac.syr.edu:1963/sccs/wavy.gif">');
	htp.img(img_wavy);
		htp.p('<center>');
		htp.p(' p.');
       		n := ceil(total/10);
        	if (n > 20) then n := 20; end if;
		for i in 1..n loop
		   iseed := (i-1)*10 + 1;
		   if (iseed = 0 ) then
			htp.p(' '||i);
		   else
			htp.p(' '||htf_npac.url(cgi_bin||'sccs1.more_date?total='||
				total||'&seed='||iseed||'&day1='||day1||
				'&day2='||day2||'&stat='||stat,i));
		   end if;
		end loop;
		if (next_str IS NOT NULL) then
		   htp.p('['||htf_npac.url(cgi_bin||'sccs1.more_date?total='||total
			||'&seed='||next||'&day1='||day1||
			'&day2='||day2||'&stat='||stat,'Next')||']');
		end if;
		htp.p('</center>');
	else
		htp.p('No SCCS Production Document Found');
	end if;
	close cdate;
	wow.sig;		
end;


procedure more_date(total number,seed integer,day1 date, day2 date,
		stat integer) is
cursor cdate(date1 date,date2 date,tat integer) is
	select * from bom where status = tat and
	(pub_date between date1 and date2)
	order by id desc;

num integer;
n integer;
iseed integer;
next number(8);
prev number(8);
next_str varchar2(20):=NULL;
prev_str varchar2(20):=NULL;
curr_str varchar2(20):=NULL;

begin
	search_button(2,0,stat);
	h_caption := 'publicated  between '||htf.bold(day1)||' and '||
			htf.bold(day2);
	htp.p('<hr width=80%>');
	htp.p('<center>');
	htp.p('<caption>SCCS Documents '||h_caption||'</caption></center>');
	htp.p('<hr><DL>');

	next := seed + 10;
	if (next<=total) then
                if ((next+10)<=total) then
                        next_str := (next+9);
                else
                        next_str := total;
                end if;
                next_str := next||'-'||next_str;
                curr_str := next - 1;
        else
                curr_str := total;
        end if;
        prev := seed - 10;
        if (prev >= 1) then
                prev_str := prev||'-'||(seed-1);
        elsif (seed > 1) then
                        prev := 1;
                        prev_str := '1-'|| 10;
        end if;
	htp.p('<center><table border=0><tr>');
        htp.p('<td align=left>Total: <b>'||total||'</b> <b>|</b> <td>');
        htp.p('<td>Current: '||seed||'-'||curr_str||' ');
	if (next_str IS NOT NULL) then
                htp.p(' <b>|</b> <td align=right>');
		htp.p(htf_npac.url(cgi_bin||'sccs1.more_date?total='||total||
			'&seed='||next||'&day1='||day1||
			'&day2='||day2||'&stat='||stat,'Next '||next_str));
	end if;
	if (prev_str IS NOT NULL) then
                htp.p(' <b>|</b><td align=right>');
		htp.p(htf_npac.url(cgi_bin||'sccs1.more_date?total='||total||
			'&seed='||prev||'&day1='||day1||
			'&day2='||day2||'&stat='||stat,'Prev '||prev_str));
	end if;
	htp.p('</table></center><dl>');
	open cdate(day1,day2,stat);
	num := 0;
	loop
		fetch cdate into two;
		exit when cdate%NOTFOUND;
		num := num + 1;
		if (num >= seed) then
			htp.p('<p><dt><b>SCCS-'||two.id||'</b>:');
			if (two.url IS NOT NULL) then
				htp.p('<i>'||htf_npac.url(two.url,two.title)||'</i>');
			else 
				htp.p('<i>'||two.title||'</i>');
			end if;
			htp.p('<dd>'||two.author);
			htp.p('; <i>'||to_char(two.pub_date,'mm-dd-yy')||'</i>');
			if (two.abs IS NOT NULL) then
				htp.p('<br>');
				htp.p(two.abs);
				htp.p('</h3>');
			end if;
		end if;
		if ( num >= (seed + 9) ) then
		    	exit;
		end if;
	end loop;		
	close cdate;
	htp.p('</DL>');
	--htp.p('<img src="http://osprey8.npac.syr.edu:1963/sccs/wavy.gif">');
	htp.img(img_wavy);
	htp.p('<center>');
	htp.p(' p.');
       	n := ceil(total/10);
        if (n > 20) then n := 20; end if;
	for i in 1..n loop
	   iseed := (i-1)*10 + 1;
	   if (iseed = 0 ) then
		htp.p(' '||i);
	   else
		htp.p(' '||htf_npac.url(cgi_bin||'sccs1.more_date?total='||
			total||'&seed='||iseed||'&day1='||day1||
			'&day2='||day2||'&stat='||stat,i));
	   end if;
	end loop;
	if (next_str IS NOT NULL) then
		htp.p('['||htf_npac.url(cgi_bin||'sccs1.more_date?total='||total||
			'&seed='||next||'&day1='||day1||
			'&day2='||day2||'&stat='||stat,'Next')||']');
	end if;
	htp.p('</center>');
	wow.sig;
end;




procedure day(str varchar2,result out date,tag in out char) is
i integer := 1;
one varchar2(8) := null;
two varchar2(8) := null;
three varchar2(8) := null;
n integer;
j integer := 1;
string varchar2(100);
begin
	string := str;
	while ( string IS NOT NULL and (substr(string,1,1) = '/')) loop
		string := substr(string,2);
	end loop;
	n := length(string);
	while ((i <= n) and (substr(string,i,1) != '/')) loop
		i := i + 1;
	end loop;
	one := substr(string,1,i-1);
	if (i > n) then
		tag := 'y';
	else
		string := substr(string,i+1);
		n := length(string);
		i := 1;
		while (i <= n and (substr(string,i,1) != '/')) loop
			i := i + 1;
		end loop;
		two := substr(string,1,i-1);
		if (i > n) then
			tag := 'm';
		else
			string := substr(string,i+1);
			n := length(string);
			i := 1;
			while (i <= n and (substr(string,i,1) != '/')) loop
				i := i + 1;
			end loop;
			three := substr(string,1,i-1);
			tag := 'd';
		end if;
	end if;		

	-- check the validated date format
	if (tag = 'y') then
		i := length(one);
		one := substr(one,-2,2);
		result := to_date('0101'||one,'ddmmyy');
	else
		one := lpad(one,2,'0');
		if ((to_number(one) < 1) or (to_number(one) > 12)) then
			htp.p('<center>Date format <b>error</b>2: <b>'||str||'</b></center><p>');
			result := NULL;
		else
		 	if (tag = 'm') then
				two := substr(two,-2,2);
				result := to_date(one||two,'FXFMmmyy');
			else
				two := lpad(two,2,'0');
				if (to_number(two) > to_char(last_day(to_date(one,'mm')),'dd')) then
					htp.p('<center>Date format <b>error</b>2: <b>'||str||'</b></center><p>');
					result := NULL;
					return;
				end if;
				i := length(three);
				if (i <= 4) then
					three := substr(three,-2,2);
					result := to_date(one||two||three,'FXFMmmddyy');
				end if;
			end if;
		end if;
	end if;
end;
	
end sccs1;
/
show errors;
/