
drop table users;
create table users (
	userid varchar2(50) constraint pk_uid primary key,
	password varchar2(20) constraint nn_passwd NOT NULL,
	email varchar2(100) default null,
	name varchar2(50),
	group_id number(4) default 1,
	host varchar2(20) default null,
	creation_time date default sysdate,
	url varchar2(100) default NULL,
	tel varchar2(20) default NULL,
        office varchar2(50) default NULL,
	login rowid default null,
	time date default sysdate,
	timeout number(8,5) default 0.0,
        h_id varchar2(50) default NULL
	);

--insert into users(userid,password,email,name,group_id,url)
--	values('root','demo','gcheng@npac.syr.edu','Gang Cheng','5','http://greatwall.npac.syr.edu:1963');
--insert into users(userid,password,email,name,group_id,url)
--	values('user2','user2','user2@npac.syr.edu','BoM user 2 (Prod.)','1',NULL);
--insert into users(userid,password,email,name,group_id,url)
--	values('user3','user3','user3@npac.syr.edu','BoM user 3 (Prod.)','2',NULL);
--insert into users(userid,password,email,name,group_id,url)
--	values('user4','users4','user4@npac.syr.edu','BoM user 4 (Pend.)','3',NULL);
--insert into users(userid,password,email,name,group_id,url)
--	values('user5','user5','user5@npac.syr.edu','BoM user 5 (Pend.)','4',NULL);
--commit;

@users

drop table visitor;
CREATE TABLE visitor (
       	 	visit_time date default sysdate,
        	remote_host varchar2(70),
        	remote_addr varchar2(20),
		page varchar2(60),
	        userid varchar2(50) default null
);

drop table domain;
create table domain (
        code varchar2(4) constraint pk_code primary key,
        name varchar2(50),
	urls number(8) default 0
);

drop table printer;
create table printer (
	name varchar2(30) constraint pk_pname primary key,
	location varchar2(200),
	type varchar2(60)
);

drop table image;
create table image (
	url varchar2(200) constraint pk_iurl primary key,
	path varchar2(200) default null
);


drop table projects;
create table projects (
	proj_abbrev varchar2(500),
	proj_name varchar2(2000),
	su_account varchar2(250),
	sponsor varchar2(2000),
	user_id varchar2(200)
)
	


drop table bom;
create table bom (
        id varchar2(200) constraint pk_id primary key,
	author varchar2(2000),
	title varchar2(2000),
	abs varchar2(2000),
	type integer default 1,
	r_level char(1) default 'a',
	status integer default 0,
        sub_date date default sysdate,
	pub_date date default sysdate,
        effective_date date default sysdate,
	url varchar2(300) default null,
 	psurl varchar2(300) default null,
	pdfurl varchar2(300) default null,
	rawurl varchar2(300) default null,
	furl varchar2(300) default null,
        userid varchar2(50),
	contact_person varchar2(50),
	contact_email varchar2(60),
	institution varchar2(50),
	approved_for_www varchar2(6),
	short_code varchar2(24),
	tr_note	varchar2(250),
	project_abbrev varchar2(2000)
);

