drop package bomupdate;
create or replace package bomupdate is

procedure insert_abs;
procedure insert_ps(id1 varchar2);
--procedure insert_ps(id1 varchar2, id2 varchar2);
end;
/
show errors;
/

create or replace package body bomupdate is


procedure insert_abs is

cursor cur is 
	select * from tmptab order by id asc;
result_rec tmptab%ROWTYPE;
newurl varchar2(2000);

begin

    open cur;
    loop
       fetch cur into result_rec;
	if cur%NOTFOUND then exit; end if;
	newurl := replace(result_rec.url,'/techreports','http://www.npac.syr.edu/techreports');
     	update bom set abs=result_rec.abs where id=result_rec.id;
	update bom set url=newurl where id=result_rec.id;
    end loop;
    close cur;
    commit;
end;

procedure insert_ps(id1 varchar2) is

newurl varchar2(100);
tmp  varchar2(10);
realurl varchar2(100) := 'http://www.npac.syr.edu/techreports/ps/';

begin
	newurl := id1;
	if (length(newurl) = 1) then
		newurl := '0000';
	else
		tmp := substr(newurl,(length(newurl) - 1),1);
		if (length(newurl) = 2) then
			newurl := '0';
		else
			newurl := substr(newurl,1,(length(newurl) - 2));
		end if;
		if (to_number(tmp) < 5) then
			newurl := concat(newurl,'00');
		else
			newurl := concat(newurl,'50');
		end if;
		newurl := lpad(newurl,4,'0');
	end if;	
	realurl := concat(realurl,newurl);
	realurl := concat(realurl,'/sccs-');
	realurl := concat(realurl,lpad(id1,4,'0'));
	realurl := concat(realurl,'.ps.Z');
	update bom 
		set psurl=realurl
		where id = id1;
	commit; 

end ;

end bomupdate;
/
show errors;
/
