/**
 * @author  Srinivasa Rangan
 * @version 1.0
 *
 * Development Environment        :  JDeveloper 2.0
 * Name of the Application        :  ConnectionParams.java
 * Creation/Modification History  :
 *
 *    srangan.in       15-Feb-1998      Created
 *
 * Overview of Application        :
 *
 * Contains static variables which define the connection parameters
 * for the database to which the samples connect.
 *
 * Please substitute the parameters with the values for your database.
 *
 */

 public class ConnectionParams {

   // The machine on which the database resides
   public final static String s_hostName     = "mira.npac.syr.edu";

   // The TNS listener port
   public final static String s_portNumber   = "1521";

   // The database name (SID)
   public final static String s_databaseSID = "mira";

   // The database User ID
   public final static String s_userName = "travel";

   // The database user password
   public final static String s_password     = "travel";

 }


