drop table users;
create table users (
	userid varchar2(50) constraint pk_uid primary key,
        password varchar2(20) constraint nn_passwd NOT NULL,
        email varchar2(100) default null,
        name varchar2(50),
	url varchar2(100) default NULL,
        tel varchar2(20) default NULL,
        office varchar2(50) default NULL,
        login rowid default null,
        time date default sysdate,
 	creation_time date default sysdate,
	write_pri varchar2(255) default NULL,
	read_pri varchar2(255) default NULL,
	group_id number(4) default 0,
	role_grp number(4) default 0,
	h_id varchar2(50) default NULL
	);

drop table texts;
drop table docs;
create table docs (
	id number(8) constraint pk_id primary key,	 
	author varchar2(2000),
	title varchar2(2000),
	reviewer varchar2(60) default NULL,
	expdate date,
	reviewdate date,
        pub_date date,
	type integer default 1,
	group_no integer default 0,
	group_name varchar2(60) default NULL,
	path varchar2(255) default NULL,
        no_refs number(5),
	no_html number(5),
	no_imgs number(5),
	fsize number(6),
	submit_by varchar2(50),
	subject varchar2(255)
	);



create table texts (
	id number(8) constraint pk_kid primary key,
	type integer default 1,
	ldate date default sysdate,
	text	long
);

