
/* Result Sets Interface */
#ifndef SQL_CRSR
#  define SQL_CRSR
  struct sql_cursor
  {
    unsigned int curocn;
    void *ptr1;
    void *ptr2;
    unsigned long magic;
  };
  typedef struct sql_cursor sql_cursor;
  typedef struct sql_cursor SQL_CURSOR;
#endif /* SQL_CRSR */

/* Thread Safety */
typedef void * sql_context;
typedef void * SQL_CONTEXT;

/* File name & Package Name */
struct sqlcxp
{
  unsigned short fillen;
           char  filnam[8];
};
static struct sqlcxp sqlfpn =
{
    7,
    "view.pc"
};


static unsigned long sqlctx = 10051;


static struct sqlexd {
   unsigned int   sqlvsn;
   unsigned int   arrsiz;
   unsigned int   iters;
   unsigned int   offset;
   unsigned short selerr;
   unsigned short sqlety;
   unsigned int   unused;
            short *cud;
   unsigned char  *sqlest;
            char  *stmt;
   unsigned char  **sqphsv;
   unsigned int   *sqphsl;
            short **sqpind;
   unsigned int   *sqparm;
   unsigned int   **sqparc;
   unsigned char  *sqhstv[3];
   unsigned int   sqhstl[3];
            short *sqindv[3];
   unsigned int   sqharm[3];
   unsigned int   *sqharc[3];
} sqlstm = {8,3};

/* Prototypes */
extern sqlcxt (/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlcx2t(/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlbuft(/*_ void **, char * _*/);
extern sqlgs2t(/*_ void **, char * _*/);
extern sqlorat(/*_ void **, unsigned long *, void * _*/);

/* Forms Interface */
static int IAPSUCC = 0;
static int IAPFAIL = 1403;
static int IAPFTL  = 535;
extern sqliem(/*_ char *, int * _*/);

 static char *sq0005 = 
"select offset ,length  from highlight_temp where id=:b0 order by offset desc\
            ";
typedef struct { unsigned short len; unsigned char arr[1]; } VARCHAR;
typedef struct { unsigned short len; unsigned char arr[1]; } varchar;

/* cud (compilation unit data) array */
static short sqlcud0[] =
{8,4112,
2,0,0,1,0,0,27,85,0,3,3,0,1,0,1,1,0,0,1,1,0,0,1,10,0,0,
28,0,0,2,55,0,4,94,0,3,1,0,1,0,2,9,0,0,2,3,0,0,1,3,0,0,
54,0,0,3,45,0,4,98,0,2,1,0,1,0,2,9,0,0,1,3,0,0,
76,0,0,4,127,0,6,120,0,3,3,0,1,0,1,3,0,0,1,1,0,0,1,3,0,0,
102,0,0,5,88,0,9,131,0,1,1,0,1,0,1,3,0,0,
120,0,0,5,0,0,13,138,0,2,0,0,1,0,2,3,0,0,2,3,0,0,
142,0,0,5,0,0,15,146,0,0,0,0,1,0,
156,0,0,6,0,0,30,178,0,0,0,0,1,0,
};


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sqlca.h>


#define left "<B><font color=#ff0000>"
#define right "</font></B>"
#define MAXSIZE 65532

char* parse(char* txt,long off,int len);
char* replace(char *src, char old, char *new); 

typedef struct {
    char name[128];
    char val[128];
} entry;

  /* EXEC SQL BEGIN DECLARE SECTION; */ 

	char username[20];
	char password[20];
  	char  keyword[255] = {'\0'};
  	long  fid = 0;
  	int cid;
        long offset;
	int length;
	/* VARCHAR text[MAXSIZE]; */ 
struct { unsigned short len; unsigned char arr[65532]; } text;

        /* VARCHAR path[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } path;

        /* VARCHAR host1[60]; */ 
struct { unsigned short len; unsigned char arr[60]; } host1;

        long fsize;
	char real_url[250];
  /* EXEC SQL END DECLARE SECTION; */ 



int main(int argc, char* argv[])
{
  entry entries[100];
  register int x,m=0;
  char *cl;
  char *tmp;
  char* fullurl;
  char prot[]="http://";
  int bigone = 0;


/* Define a host structure for the output values of
   a SELECT statement.  */

/*printf("Content-type: text/html%c%c",10,10);*/

  if(getenv("ORACLE_HOME")==NULL) putenv("ORACLE_HOME=/oracle/app/oracle/product/7.3.2");
 if(getenv("ORACLE_SID")==NULL) putenv("ORACLE_SID=osprey7"); 

  
  /* parse URL */
  cl = getenv("QUERY_STRING");
  if(cl == NULL) {
      printf("No query information to decode.\n");
        exit(1);
  }

    for(x=0;cl[0] != '\0';x++) {
        m=x;
        getword(entries[x].val,cl,'&');
        plustospace(entries[x].val);
        unescape_url(entries[x].val);
        getword(entries[x].name,entries[x].val,'=');
    }

   for(x=0; x <= m; x++)
	if (strcmp(entries[x].name,"keyword") == 0) 
		strcpy(keyword,entries[x].val);
	else if (strcmp(entries[x].name,"f_id") == 0) 
		fid = atol(entries[x].val);
	else if (strcmp(entries[x].name,"cid") == 0)
		 cid = atoi(entries[x].val);
	else if (strcmp(entries[x].name,"r_url") == 0)
		strcpy(real_url,entries[x].val);

/* Connect to ORACLE. */

    strcpy(username, "wsms");
    strcpy(password, "wsms"); 

   /* EXEC SQL CONNECT :username IDENTIFIED BY :password; */ 

{
   struct sqlexd sqlstm;

   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 3;
   sqlstm.iters = (unsigned int  )10;
   sqlstm.offset = (unsigned int  )2;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)username;
   sqlstm.sqhstl[0] = (unsigned int  )20;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)password;
   sqlstm.sqhstl[1] = (unsigned int  )20;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}

 
    /*printf("\nConnected to ORACLE as user: %s\n\n", username);*/



/* ====     EXEC SQL SELECT TEXT,HOST1,PATH,FSIZE
		into :text,:host1,path,:fsize from
		search where fid=:fid;====*/

	/* EXEC SQL SELECT PATH,FSIZE
		into :path,:fsize
		FROM docs
		WHERE id=:fid; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 3;
 sqlstm.stmt = "select PATH ,FSIZE into :b0,:b1  from docs where id=:b2";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )28;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&path;
 sqlstm.sqhstl[0] = (unsigned int  )257;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&fsize;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&fid;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	/* EXEC SQL SELECT TEXT
		into :text
		FROM texts
		WHERE id=:fid; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 3;
 sqlstm.stmt = "select TEXT into :b0  from texts where id=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )54;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&text;
 sqlstm.sqhstl[0] = (unsigned int  )65534;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&fid;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}



	if (fsize > MAXSIZE) {
		text.len = MAXSIZE;
		bigone =1;
	}
	
	text.arr[text.len] = '\0';
        path.arr[path.len] = '\0';

    /* for highlight */
    if (keyword[0] != '\0') { 
     /* change ~ to & back */
    	for (x=0; keyword[x]; x++) 
		if (keyword[x] == '~') keyword[x] = '&';

 	/*EXEC SQL WHENEVER SQLERROR GOTO sqlerr;
  	EXEC SQL WHENEVER NOTFOUND GOTO sqlerr; */

    	/* EXEC SQL EXECUTE 
            BEGIN
		ctx_query.highlight('SEARCH_POLICY',
			:fid,:keyword,:cid,null,null,'highlight_temp',
			null,null);
	    END;
        END-EXEC; */ 

{
     struct sqlexd sqlstm;

     sqlstm.sqlvsn = 8;
     sqlstm.arrsiz = 3;
     sqlstm.stmt = "begin ctx_query . highlight ( 'SEARCH_POLICY' , :fid , :\
keyword , :cid , null , null , 'highlight_temp' , null , null ) ; END ;";
     sqlstm.iters = (unsigned int  )1;
     sqlstm.offset = (unsigned int  )76;
     sqlstm.cud = sqlcud0;
     sqlstm.sqlest = (unsigned char  *)&sqlca;
     sqlstm.sqlety = (unsigned short)0;
     sqlstm.sqhstv[0] = (unsigned char  *)&fid;
     sqlstm.sqhstl[0] = (unsigned int  )4;
     sqlstm.sqindv[0] = (         short *)0;
     sqlstm.sqharm[0] = (unsigned int  )0;
     sqlstm.sqhstv[1] = (unsigned char  *)keyword;
     sqlstm.sqhstl[1] = (unsigned int  )255;
     sqlstm.sqindv[1] = (         short *)0;
     sqlstm.sqharm[1] = (unsigned int  )0;
     sqlstm.sqhstv[2] = (unsigned char  *)&cid;
     sqlstm.sqhstl[2] = (unsigned int  )4;
     sqlstm.sqindv[2] = (         short *)0;
     sqlstm.sqharm[2] = (unsigned int  )0;
     sqlstm.sqphsv = sqlstm.sqhstv;
     sqlstm.sqphsl = sqlstm.sqhstl;
     sqlstm.sqpind = sqlstm.sqindv;
     sqlstm.sqparm = sqlstm.sqharm;
     sqlstm.sqparc = sqlstm.sqharc;
     sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


        
        /* EXEC SQL DECLARE ar CURSOR FOR
		select offset, length from highlight_temp
			where id=:cid order by offset desc; */ 

	/* EXEC SQL OPEN ar; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 3;
 sqlstm.stmt = sq0005;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )102;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&cid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	tmp = (char *) malloc(text.len+1);
	strncpy(tmp,text.arr,text.len);         
        tmp[text.len] = '\0';

	for (;;) {
		/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

		/* EXEC SQL FETCH ar INTO :offset, :length; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 3;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )120;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&offset;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&length;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 100) break;
}


		/* parse it carefully */
		if (offset < MAXSIZE)
			tmp = parse(tmp,offset,length); 
	}

	/*strcpy(text.arr,tmp);
	text.len = strlen(tmp);*/
        /* EXEC SQL CLOSE ar; */ 

{
        struct sqlexd sqlstm;

        sqlstm.sqlvsn = 8;
        sqlstm.arrsiz = 3;
        sqlstm.iters = (unsigned int  )1;
        sqlstm.offset = (unsigned int  )142;
        sqlstm.cud = sqlcud0;
        sqlstm.sqlest = (unsigned char  *)&sqlca;
        sqlstm.sqlety = (unsigned short)0;
        sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


    }

/* Transfer to real URL */

 
/*===	fullurl=(char*) malloc(strlen(prot)+path.len+host1.len+1);
        strcpy(fullurl,prot);
        strcat(fullurl,host1.arr);
        strcat(fullurl,path.arr);
        fullurl[strlen(prot)+path.len+host1.len] = '\0';
        printf("%s\n",fullurl);
	printf("%s\n",tmp);

	if (bigone == 1) {
		printf("<p><center><blink>%s Additional text is omitted. Check <a href=\"%s\">the original Web page</a> for full text !%s</blink></center></html>\n",left,fullurl,right);
	}

      free(fullurl);===*/

      printf("%s\n",real_url);
      printf("%s\n",tmp);
      if (bigone == 1) {
		printf("<p><center><blink>%s Additional text is omitted. Check <a href=\"%s\">the original Web page</a> for full text !%s</blink></center></html>\n",left,path,right);
	}

      

 sqlerr:       
  	/*printf("SQL error !!\n");*/

/* Disconnect from the database. */
    /* EXEC SQL COMMIT WORK RELEASE; */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 3;
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )156;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}

 
    exit(0);
}
char* parse(char* txt,long off,int len) {
	char* word = (char*) malloc(len+1);
	char* str1 = (char*) malloc(strlen(txt)+strlen(left)+strlen(right)+1);
	char* str2 = txt+off+len-1;
	strncpy(word,txt+off-1,len);
	str1[off-1]='\0';
	word[len] = '\0';
	strncpy(str1,txt,off-1); 
	strcat(str1,left);
	strcat(str1,word);
	strcat(str1,right);
	strcat(str1,str2);
	free(word);
	free(txt);
	return str1;
}

