# Entering loc_precomp.mk


# Entering /local/SRCHOME/knl/buildtools/prefix.mk

# Entering /local/SRCHOME/knl/buildtools/rules.mk
 
# Exiting /local/SRCHOME/knl/buildtools/rules.mk
# Entering /local/SRCHOME/knl/buildtools/defs.mk

AR=ar

ARCREATE=$(AR) cr$(ARLOCAL)

ARDELETE= $(AR) d$(ARLOCAL)

AREXTRACT = $(AR) x 

ARREPLACE = $(AR) r 

COPY=cp

LDFLAGS =-o $@ $(PRODUCT_LIBHOME) -L$(LIBHOME) 

LIBHOME=$(ORACLE_HOME)/lib

BINHOME=$(ORACLE_HOME)/bin

LDCCOM= $(CC) $(GFLAG) $(CCFLAGS) $(LDFLAGS)

MOVE=mv

REMOVE=rm -f 

SHELL=/bin/sh

TOUCH=touch

CD = cd

LN = ln

CAT = cat

ECHO = echo

CHMOD = chmod

RM = rm

CP = cp

MV = mv

I_SYM=-I

SILENT=@

CFLAGS= $(GFLAG) $(OPTIMIZE) $(CDEBUG) $(CCFLAGS) $(QACCFLAGS) $(PFLAGS) $(SHARED_CFLAG) $(ENV_FLAGS)

PFLAGS= $(INCLUDE) $(SPFLAGS) $(LPFLAGS)

TTLIBS=$(NETLIBS) $(LLIBORA) $(NETLIBS) $(LLIBORA) $(LIBPLSHACK) \
	$(LLIBEPC) $(CORELIBS) $(LDLIBS)
DEVTTLIBS=$(TTLIBS)

TTLIBD=$(NETLIBD) $(LIBORA) $(LIBSQLNET) $(LIBORA) \
	$(CORELIBD) $(LIBEPC)


CLIBS=$(LOCALLIBS) $(EXOSLIBS) $(LIBBSD) $(OTHERLIBS) $(SECLIBS) $(M6LIBS)

LDLIBS=$(SPLIBS) $(CLIBS) $(MATHLIB)

SPLIBS=

MATHLIB=-lm

LOCALLIBS=

# Exiting /local/SRCHOME/knl/buildtools/defs.mk
# Entering /local/SRCHOME/knl/buildtools/platform.mk


PLATFORM = solaris

LLTHREAD=-lthread

SMPWCF=smpwcf.s
OPENWINHOME=/usr/openwin

BUILD_VIEW=sdview
SDVIEW_SETUP=sdview_setup
VIEWDIR=view


SYSDNILIB= /opt/SUNWconn/dni/lib/libdni.a
SYSLU62LIB= /opt/SUNWconn/lib/libappc_api.a
LKLIBS=-lstublm
LIBSTUBLKMGR= $(LIBHOME)/libstublm.a
GUILIBHOME=/usr/openwin/lib
MOTIFHOME=/usr/dt
XLIBS=-L$(GUILIBHOME) -R$(GUILIBHOME) $(GUILIBHOME)/libXaw.so.4 -lXt -lXmu -lXext -lX11 -lm
MOTIFLIBS=-L$(MOTIFHOME)/lib -lXm -lgen -L$(GUILIBHOME) -R$(GUILIBHOME) -lXt -lX11 -lw -lm
MOTIFINCLUDE=$(I_SYM)$(MOTIFHOME)/include $(I_SYM)$(MOTIFHOME)/include/Xm \
	     $(I_SYM)$(OPENWINHOME)/include $(I_SYM)$(OPENWINHOME)/include/X11
SYSTEMLIBS = $(LKLIBS) -lsocket -lnsl -lm -ldl $(LLAIO) -lposix4 $(SYSDNILIB) $(SYSLU62LIB)
PLLIBS = -lc

PL_FLAGS =

OTHERLIBS = `cat $(ORACLE_HOME)/rdbms/lib/sysliblist` $(LLAIO)

ROFLAGS=-c -xMerge
CCFLAGS= -Xc -xstrconst -xcg92 -xF -mr -K PIC -DSLXMX_ENABLE -DSLTS_ENABLE -D_REENTRANT


CFLAGS2= $(GFLAG) $(OPTIMIZE2) $(CDEBUG) $(CCFLAGS) $(QACCFLAGS) $(PFLAGS) $(SHARED_CFLAG)

CPP=/usr/ccs/lib/cpp

OPTIMIZE2=-xO2
OPTIMIZE4=-xO4
OPTIMIZE=$(OPTIMIZE4)

SPFLAGS=

ARLOCAL=

ASFLAGS=-P


COMPO2=$(subst -xO4,-xO2,$(COMPO))
MAKE_LIB_OBJ_O2=$(COMPO2) ; $(ARCHIVE_OBJ) ; $(REM_OBJ)

COMPXA=$(subst -Xc,-Xa,$(COMPO))
MAKE_LIB_OBJ_XA=$(COMPXA) ; $(ARCHIVE_OBJ) ; $(REM_OBJ)

COMPXA2=$(subst -xO4,-xO2,$(COMPXA))
MAKE_LIB_OBJ_XA2=$(COMPXA2) ; $(ARCHIVE_OBJ) ; $(REM_OBJ)

COMPXANO=$(subst -xO4,,$(COMPXA))
MAKE_LIB_OBJ_XANO=$(COMPXANO) ; $(ARCHIVE_OBJ) ; $(REM_OBJ)

COMPNO=$(subst -xO4,,$(COMPO))
MAKE_LIB_OBJ_NO=$(COMPNO) ; $(ARCHIVE_OBJ) ; $(REM_OBJ)

COMPXANO=$(subst -xO4,,$(COMPXA))
MAKE_LIB_OBJ_XANO=$(COMPXANO) ; $(ARCHIVE_OBJ) ; $(REM_OBJ)

COMPRO2=$(subst -xO4,-xO2,$(COMPRO))
MAKE_LIB_OBJ_RO2=$(COMPRO2) ; $(ARCHIVE_OBJ) ; $(REM_OBJ)

COMPRONO=$(subst -xO4,-xO2,$(COMPRO))
MAKE_LIB_OBJ_RONO=$(COMPRONO) ; $(ARCHIVE_OBJ) ; $(REM_OBJ)

COMPDNO=$(CC) -c -g -Usun -Xc -mr -K PIC $(PFLAGS) $(SHARED_CFLAG) $(ENV_FLAGS) -DDEBUG $<
MAKE_LIB_OBJ_DNO=$(COMPDNO) ; $(ARCHIVE_OBJ) ; $(REM_OBJ)

COMPXADNO=$(CC) -c -g -Usun -Xa -mr -K PIC $(PFLAGS) $(SHARED_CFLAG) $(ENV_FLAGS) -DDEBUG $<
MAKE_LIB_OBJ_XA_DNO=$(COMPXADNO) ; $(ARCHIVE_OBJ) ; $(REM_OBJ)


ASROFLAGS=$(ASFLAGS)
ASRO= $(AS) $(ASROFLAGS) $(MAKERO) $<

ASPFLAGS = -P $(PFLAGS)

CC=cc

COMPRO= $(CC) $(ROFLAGS) $(CFLAGS) $(MAKERO) $<

COMPRONO= $(CC) $(ROFLAGS) $(CDEBUG) $(CCFLAGS) $(PFLAGS) $(MAKERONO)

LD=ld

LDPFLAGS= -o $@ -p $(PRODUCT_LIBHOME) -L$(LIBHOME) -L/opt/SUNWcluster/lib -R/opt/SUNWcluster/lib
LDGPFLAGS= -o $@ -pg $(PRODUCT_LIBHOME) -L$(LIBHOME) -L/opt/SUNWcluster/lib -R/opt/SUNWcluster/lib
LDFLAGS= -o $@ $(PRODUCT_LIBHOME) -L$(LIBHOME) -L/opt/SUNWcluster/lib -R/opt/SUNWcluster/lib

LCOMPO= $(CC) -c $(CFLAGS) $? ; mv `basename $@` $@

LCOMPD= $(CC) -c $(CFLAGS) -DDEBUG $? ; mv `basename $@` $@

LCOMPS= $(CC) -S $(CFLAGS) $? ; mv `basename $@` $@

LCOMPNO= $(CC) -c $(PFLAGS) $(CCFLAGS) $? ; mv `basename $@` $@

SO=a

SPFLAGS=

EXOSLIBS=
LIBBSD=
SECLIBS=
M6LIBS=

PERL = perl

MKCUST_TARGET = mkcustinclude

USE_GENROFIX=yes

BUGDB_PORT=453

LINK=ld -dy $(COMPOBJS)

CUS_PLFRM=$(ORACLE_HOME)/buildtools/cus_plfrm.mk
# Exiting /local/SRCHOME/knl/buildtools/platform.mk
# Exiting /local/SRCHOME/knl/buildtools/prefix.mk
# Entering /local/SRCHOME/knl/oracore3/oracore3.mk

COREHOME= $(ORACLE_HOME)/oracore3

LIBCORE= $(LIBHOME)/libcore3.$(SO)
LIBCV6= $(LIBHOME)/libc3v6.$(SO)
LLIBCORE= -lcore3
LLIBCV6= -lc3v6


COREPUBLIC=$(I_SYM)$(COREHOME)/public $(I_SYM)$(COREHOME)/public/unix \
		$(I_SYM)$(COREHOME)/public/$(PLATFORM)
COREINCLUDE=$(I_SYM)$(COREHOME)/include $(COREPUBLIC)

CORELIBD=$(LIBNLSRTL) $(LIBCV6) $(LIBCORE) $(LIBNLSRTL) $(LIBCORE) $(LIBNLSRTL)
CORELIBS=$(LLIBNLSRTL) $(LLIBCV6) $(LLIBCORE) $(LLIBNLSRTL) $(LLIBCORE) $(LLIBNLSRTL)

# Exiting /local/SRCHOME/knl/oracore3/oracore3.mk
# Entering /local/SRCHOME/knl/nlsrtl3/nlsrtl3.mk


NLSRTLHOME= $(ORACLE_HOME)/nlsrtl3

ORA_NLS = $(ORACLE_HOME)/ocommon/nls/admin/data

NLSRTLLIB= -lnlsrtl3
LIBNLSRTL= $(LIBHOME)/libnlsrtl3.$(SO)
SHAREDLIBNLSRTL = $(LIBHOME)/libnlsrtl3.so.3.2
ARCSHAREDLIBNLSRTL = $(LIBHOME)/libnlsrtl3.sa.3.2
LLIBNLSRTL=-lnlsrtl3
NLSRTLPUBLIC = $(I_SYM)$(NLSRTLHOME)/public
NLSRTLINCLUDE = $(I_SYM)$(NLSRTLHOME)/include $(NLSRTLPUBLIC)

# Exiting /local/SRCHOME/knl/nlsrtl3/nlsrtl3.mk
# Entering /local/SRCHOME/knl/rdbms/rdbms.mk

RDBMSHOME=$(ORACLE_HOME)/rdbms
RDBMS_ROOT=$(RDBMSHOME)
RDBMSPUBLIC=$(I_SYM)$(RDBMSHOME)/public $(I_SYM)$(RDBMSHOME)/include

SYSLIBLIST = $(RDBMS_ROOT)/lib/sysliblist

LIBCLIENT=$(ORACLE_HOME)/lib/libclient.a
LLIBCLIENT=-lclient

LIBSERVER=$(ORACLE_HOME)/lib/libserver.a
LLIBSERVER=-lserver

LIBGENERIC=$(ORACLE_HOME)/lib/libgeneric.a
LLIBGENERIC=-lgeneric

LIBCOMMON=$(ORACLE_HOME)/lib/libcommon.a
LLIBCOMMON=-lcommon

LIBXA=$(ORACLE_HOME)/lib/libxa.a
LLIBXA=-lxa

LIBIMP=$(RDBMSHOME)/lib/libimp.a
LLIBIMP=-limp

LIBEXP=$(RDBMSHOME)/lib/libexp.a
LLIBEXP=-lexp

LIBORA=$(LIBCLIENT) $(LIBCOMMON) $(LIBGENERIC)
LLIBORA=$(LLIBCLIENT) $(LLIBCOMMON) $(LLIBGENERIC)

# Exiting /local/SRCHOME/knl/rdbms/rdbms.mk
# Entering /local/SRCHOME/knl/plsql/plsql.mk

PLSHOME=$(ORACLE_HOME)/plsql
PLSQL_ROOT=$(PLSHOME)



LLIBAPPS = -lapps
LLIBCOG = -lcog
LLIBCOX = -lcox
LLIBIDL = -lidl
LLIBKNLDE = -lknlde
LLIBPKG = -lpkg
LLIBPLS = -lpls
LLIBSEM = -lsem
LLIBSYN = -lsyn

LIBAPPS = $(LIBHOME)/libapps.a
LIBCOG = $(LIBHOME)/libcog.a
LIBCOX = $(LIBHOME)/libcox.a
LIBIDL = $(LIBHOME)/libidl.a
LIBKNLDE = $(LIBHOME)/libknlde.a
LIBPKG = $(LIBHOME)/libpkg.a
LIBPLS = $(LIBHOME)/libpls.a
LIBSEM = $(LIBHOME)/libsem.a
LIBSYN = $(LIBHOME)/libsyn.a


PLSQLLIBS=$(LIBAPPS) $(LIBCOG) $(LIBCOX) $(LIBIDL) $(LIBKNLDE) \
        $(LIBPKG) $(LIBPLS) $(LIBSEM) $(LIBSYN)

LLIBPLSQL=$(LLIBAPPS) $(LLIBCOG) $(LLIBCOX) $(LLIBIDL) $(LLIBKNLDE) \
        $(LLIBPKG) $(LLIBPLS) $(LLIBSEM) $(LLIBSYN)

# Exiting /local/SRCHOME/knl/plsql/plsql.mk
# Entering /local/SRCHOME/knl/network/network.mk

# Entering /local/SRCHOME/knl/network/platform.mk

NETLIBHOME=$(NETHOME)/lib
SITESRC=/net/bog/sitesrc

OSN_USE_FTT=-DOSN_USE_FTT

NTCONTAB=ntcontab.s
NNFGT=nnfgt.s
GENNT=assemble
ASFLAGS_SHIP=-P -o

TNCR_SRC=tncr.c
TNCRTARG=tncr.i
TNCR_OUT=tncr.i
TNCR_TEST=tncr.tsc
TNCRFLT_SRC=tncrflt.c
TNCRFLTTARG=tncrflt.i
TNCRFLT_OUT=tncrflt.i
TNCRFLT_TEST=tncrflt.tsc

LIBNTTCP= $(NETLIBHOME)/libnttcp.a
TCP=ntt
TCPINS=tcppa
NTTCPFLAG=-DNTUSETCP



LIBNTIS= $(NETLIBHOME)/libntis.a
LIBNTTLI = $(NETLIBHOME)/libnttli.a
ISPX=yes
SPXINS=spxpa
TLISPXDMN=ntisbsdm
TLISPXCTL=ntspxctl
GTLI=nttli
NTSPXFLAG=-DNTUSEISPX
NWINCLUDE=$(I_SYM)/opt/SUNWipx/include/netipx


LIBNTID= $(NETLIBHOME)/libntid.a
LIBNTTLI = $(NETLIBHOME)/libnttli.a
IDNT=yes
GTLI=nttli
DNTINS=dntpa
NTDNTFLAG=-DNTUSEIDNT
DNTINCLUDE=$(I_SYM)/opt/SUNWconn/dni/include

LIBNTLU62=$(NETLIBHOME)/libntlu62.a
LU62=ntl
LU62INS=lu62pa
NTLLSNR=ntllsnr
NTLLSNR_CFILES=ntllsnr.c
NTNTLFLAG=-DNTUSENTL
LU62INCLUDE=$(I_SYM)/opt/SUNWappc






SNMPLIB=libpeer.a
LIBNMSP=$(ORACLE_HOME)/network/lib/libnmsp.a
SNMPAGENTLIB=$(ORACLE_HOME)/network/lib/$(SNMPLIB)
PEER=yes
PEER_CONF=setup.peer.conf
TSNMPLSNR= tnsgsnmp
TSNMPNAMES= snmptns
TSNMPINT = nrstest
SNMPAGENTTESTEXECS = nmdtest nmdtrap
SNMPAUX=nmd
SNMPFLAG=-DORACLE_SNMP_PEER
SNMPINCLUDE=$(I_SYM)$(SITESRC)/peer/include $(I_SYM)$(SITESRC)/peer/src/include


LIBTCL=$(NETLIBHOME)/libtcl.a
DBSNMP= dbsnmp
TCLSHDEBUG= oratclsh
OEMEVENT=oemevent
AGENTTESTEXECS= nmitest nmitestd nmiqtest nmitclsh nmieutest
AGENT=nmi
AGENTINS=snmp
TCLFLAGS= -DVERSION7 -DHAVE_UNISTD_H=1 -DNO_FLOAT_H=1 -DNO_STDLIB_H=1 -DNO_STRING_H=1 -DNEED_MATHERR=1
TCLINCLUDE=$(I_SYM)$(SITESRC)/oratcl/include

NAMESRC=nnfo.c
NAMES=names
NAMESCTL=namesctl
TNNFGNAMES=tnnfgn
NAMESRV=nno
NCTL=nncc
NAMESINS=names
NAMESFLAG=-DNNFG_USEONAMES

LIBNIS=$(NETLIBHOME)/libntnis.a
NIS=yes
NISEXEC=tns2nis
TNNFGNIS=tnnfgy
NISINS=nisna
NISFLAG=-DNNFG_USENIS


NAV= navgatr
INTLSNR= intlsnr
PUMP= intpump
INTCTL= intctl
INTTEST= gtest
NAVTEST= nrtest
INTCHG=nr
INTCHGINS=intchg


# Exiting /local/SRCHOME/knl/network/platform.mk

NETHOME=$(ORACLE_HOME)/network
NETINCLUDE= $(I_SYM)$(NETHOME)/public $(I_SYM)$(NETHOME)/include

OSNTAB = $(ORACLE_HOME)/lib/osntab.o
OSNTABST = $(ORACLE_HOME)/lib/osntabst.o
NTCONTAB= $(LIBHOME)/ntcontab.o

LIBSQLNET=$(LIBHOME)/libsqlnet.a
LIBRPC=$(LIBHOME)/libncr.a
LIBTNSAPI=$(LIBHOME)/libtnsapi.a
LLIBSQLNET=-lsqlnet
LLIBRPC=-lncr
LLIBTNSAPI=-ltnsapi
LIBMIGV1=$(ORACLE_HOME)/network/lib/libmigv1.a
NETLIBD= $(LIBSQLNET) $(LIBRPC)
NETLIBS= $(LLIBSQLNET) $(LLIBRPC) $(LLIBSQLNET)

# Exiting /local/SRCHOME/knl/network/network.mk
# Entering /local/SRCHOME/knl/otrace/otrace.mk


TRACEHOME= $(ORACLE_HOME)/otrace

LIBEPC= $(LIBHOME)/libepc.$(SO)
LLIBEPC= -lepc
LIBEPCFE= $(LIBHOME)/libepcfe.$(SO)
LLIBEPCFE= -lepcfe
LIBEPCPT=$(LIBHOME)libepcpt.$(SO)
LLIBEPCPT= -lepcpt


TRACEPUBLIC=$(I_SYM)$(TRACEHOME)/public
TRACEINCLUDE=$(I_SYM)$(TRACEHOME)/include $(TRACEPUBLIC)

# Exiting /local/SRCHOME/knl/otrace/otrace.mk
# Entering /local/SRCHOME/knl/slax/slax.mk
SLAXHOME=$(ORACLE_HOME)/slax
SLAXINCLUDE=$(I_SYM)$(SLAXHOME)/include

LLIBSLAX=-lslax

LIBSLAXD=$(LIBHOME)/libslax.a
# Exiting /local/SRCHOME/knl/slax/slax.mk
# Entering /local/SRCHOME/knl/precomp/precomp.mk

PRECOMPHOME=$(ORACLE_HOME)/precomp
PRECOMPPUBLIC=$(I_SYM)$(PRECOMPHOME)/public


LLIBSQL=-lsql

LIBSQLD=$(LIBHOME)/libsql.a

PROADA = proada
PROCOB = procob
PROC16 = proc16
PROFOR = profor
PROPAS = propas
PROPLI = propli
PROC = proc
MODC = modc
MODADA = modada
RTSORA = rtsora

# Exiting /local/SRCHOME/knl/precomp/precomp.mk

PRODUCT=precomp
TOP = $(ORACLE_HOME)/precomp
TOOLS = $(ORACLE_HOME)/buildtools

.PHONY : archive restore compile library execs rmobjs rmlibs rmexecs



PRODHOME=$(ORACLE_HOME)/precomp
PRECOMPHOME=$(PRODHOME)
PRECOMPLIB=$(PRECOMPHOME)/lib
PRECOMPBIN=$(PRECOMPHOME)/bin
ADARTL=$(PRECOMPHOME)/pubsrc/adalib

PRODUCT_LIBHOME= -L$(PRECOMPLIB)

LIBPAD = $(TOP)/lib/libpad.a
LIBPC  = $(TOP)/lib/libpc.a
LIBPCC = $(TOP)/lib/libpcc.a
LIBPCO = $(TOP)/lib/libpco.a
LIBPFO = $(TOP)/lib/libpfo.a
LIBPGP = $(TOP)/lib/libpgp.a
LIBPPL = $(TOP)/lib/libppl.a
LIBPPA = $(TOP)/lib/libppa.a
LIBPCD = $(TOP)/lib/libpcd.a
LIBPROC2 = $(TOP)/lib/libproc2.a
LIBMOD = $(TOP)/lib/libmod.a
LIBSLAX= $(TOP)/lib/libslax.a
LIBSQL = $(TOP)/lib/libsql.a

LLIBPAD=-lpad
LLIBPC=-lpc
LLIBPCC=-lpcc
LLIBPCO=-lpco
LLIBPFO=-lpfo
LLIBPGP=-lpgp
LLIBPPL=-lppl
LLIBPPA=-lppa
LLIBPCD=-lpcd
LLIBPROC2=-lproc2
LLIBMOD=-lmod


PROLDLIBS=$(PROLLSsharedthread)
PROLLS=$(LLIBSQL) $(DEVTTLIBS)
PROLLSshared=$(LCLSH) $(PROLLS)
PROLLSthread=$(PROLLS) $(LLTHREAD)
PROLLSsharedthread=$(LCLSH) $(PROLLS) $(LLTHREAD)

ADAMAIN = $(TOP)/lib/pc5drv.o
COBMAIN = $(TOP)/lib/pc0drv.o
CMAIN = $(TOP)/lib/pc2drv.o
FORMAIN = $(TOP)/lib/pc1drv.o
PASMAIN = $(TOP)/lib/pc4drv.o
PLIMAIN = $(TOP)/lib/pc3drv.o
MAINOBJS = lib/main.o lib/pcdsfv.o lib/pcdlut.o
MODOBJS = lib/pmtsfv.o lib/pmtlut.o
MODCMAIN = $(TOP)/lib/pmscpr.o
MODADAMAIN = $(TOP)/lib/pmsapr.o

ADAPDC = lib/pda.o lib/pds.o
CPDC =   lib/pdc.o lib/pds.o
COBPDC = lib/pdb.o lib/pds.o
FORPDC = lib/pdf.o lib/pds.o
PASPDC = lib/pdp.o lib/pds.o
PLIPDC = lib/pd1.o lib/pds.o

COBSQLINTF = $(TOP)/lib/cobsqlintf.o

# Exiting loc_precomp.mk
# Entering osd_precomp.mk

# this must be comment out for Web CGI program
#LCLSH=-lclntsh

COB = cob
COBFLAGS=-C IBMCOMP -x
COBGNTFLAGS=-C IBMCOMP -u
GNT=.gnt
RTSPORTFLAGS=
FC=f77
FCFLAGS=
PC=pc
PCFLAGS= -Bstatic -g -L
ADAPORT=verdix
ADACC=ada -e
ADALD=a.ld
ADACLEAN= a.rmlib -f
PL1=lpipl1
PL1LD=ldpl1
PL1FLAGS= -lowercase
# Exiting osd_precomp.mk
# Entering /local/SRCHOME/knl/buildtools/cus_plfrm.mk

COMPOBJ=$(ORACLE_HOME)/lib
COMPOBJS=$(COMPOBJ)/crti.o $(COMPOBJ)/crt1.o $(COMPOBJ)/__fstd.o
 
LDSTRING= -R /opt/SUNWcluster/lib \
	-Y P,$(LD_LIBRARY_PATH):/opt/SUNWcluster/lib:/usr/ccs/lib:/usr/lib \
	-Qy -lc $(COMPOBJ)/crtn.o
OTHERLIBS= `cat $(ORACLE_HOME)/rdbms/lib/sysliblist` $(LLAIO) $(LDSTRING)
DEVTTLIBS=$(NETLIBS) $(LLIBORA) $(NETLIBS) $(LLIBORA) $(LIBPLSHACK) \
	$(LLIBEPC) $(CORELIBS) $(SPLIBS) $(LOCALLIBS) $(EXOSLIBS) $(LIBBSD) `cat $(ORACLE_HOME)/rdbms/lib/sysliblist`  $(SECLIBS) $(M6LIBS) $(MATHLIB)
# Exiting /local/SRCHOME/knl/buildtools/cus_plfrm.mk
