create or replace package webmaster is

procedure count(n number, webpasswd number);      
procedure deadlink;
procedure more_dead(start_num integer, total number);
procedure locat(n integer, p varchar2);    
procedure add_count(n number);
procedure summary;
function url(curl in varchar2, cname in varchar2) return varchar2;

root_url varchar2(200) := apollosearch.root_url;                               
root_url1 varchar2(200) := apollosearch.root_url1;
server_name varchar2(200) := apollosearch.server_name;                                   
end;                                                                            
/
show errors;
/


create or replace package body webmaster is                                                       
function url    (curl   in varchar2, cname   in varchar2) return varchar2 is
begin return('<a href="' || curl || '">' || cname || '</a>'); end;

procedure summary is
num integer;

begin
htp.p('<body background="'||server_name||'grey_profile.jpg">');
htp.p('<center><h2>Summary On Apollo</h2>');    
   htp.p('<img src="'||server_name||'forest.gif">');     
   htp.p('<p><table>');
   select count(distinct path) into num from search;
   htp.p('<tr><td>Total Pages(exclude dead links):</td><td>'||num||'</td></tr>');
   select sum(no_imgs) into num from search;
   htp.p('<tr><td>Total Linked Images:</td><td>'||num||'</td></tr>');
   select count(*) into num from search_urls where flag=4;
   htp.p('<tr><td>Dead Links:</td><td>');
   htp.p(url(root_url||'/webmaster.deadlink',num)||'</td></tr>');
   select sum(fsize) into num from search;
   htp.p('<tr><td>Total Size of All Documents(KB):</td><td>'||
	to_char(num/1024.,'FM999999D9')||'</td></tr>');
   select max(fsize) into num from search;
   htp.p('<tr><td>Longest Size(KB):</td><td>'||
	to_char(num/1024.,'FM999999D9')||'</td></tr>');
   select min(fsize) into num from search;
   htp.p('<tr><td>shortest Size(KB):</td><td>'||
	to_char(num/1024.,'FM999999D9')||'</td></tr>');
   htp.p('</table><p>');
   htp.p('<img src="'||server_name||'wavy.gif"></center>');
end;

procedure add_count(n number) is
i integer;
begin

i := n;
loop
  count(i,2483);
  i := i - 1;
  if i = 0 then exit; end if;
end loop;
end;

procedure count(n number, webpasswd number) is   
begin 
htp.p('<body background="'||server_name||'grey_profile.jpg">');      
if( webpasswd = 2483) then    
--  for i in n .. 1 loop    
    insert into location     
      select substr(path,1,instr(path,'/',1,n)),count(*),sum(fsize),max(fsize),   	min(fsize),sum(no_refs),sum(no_html),sum(no_imgs),sum(s_form),n         	from search                                                                    where (instr(path,'/',1,n)!=0)                                                 group by substr(path,1,instr(path,'/',1,n));         
--  end loop;
  htp.p('<center> The statistic is finished!</center>');
else                                                                             htp.p('<center><h2>Error</h2>');                                               htp.p(' Sorry, your password is wrong!');                                      htp.p('</center></body>');
end if;                                                                         
end;                                                                            

procedure deadlink is                                                          

cursor deadcur is                                                              	select * from search_urls where flag=4;
                                       
result_rec search_urls%ROWTYPE;                                                i integer;                                                                     j integer;                                                                     tot number(8);                                                                 ppath search_urls.oldpath%TYPE;                                                end_num number(8);                                                              
begin                                                                              open deadcur;                                                                  select count(*) into tot from search_urls where flag=4;                        if (tot=0) then                                                            	   	htp.p('No dead link found!');                                              else                                                                          	htp.p('<center><body background="'||server_name||'grey_profile.jpg">');
	htp.p('<h1>All Dead Links On Apollo</h1><p>');
	htp.p('<img src="'||server_name||'forest.gif">');
        htp.p('<br><p>');   
        htp.p('<strong>Host:http://apollo.wes.hpc.mil</strong>');                      htp.p('<br><table border=2 cellpadding=0 cellspacing=0 width=90%>');   
	htp.p('<tr align=center><th>Path</th><th>Parent Path</th></tr>');       	j := 0;                                                                		for i in 1..10 loop                                                    		    fetch deadcur into result_rec;                                      	    if (deadcur%NOTFOUND) then                                         			exit;                                                          		    end if;                                                            		    j := j+1;                                                          		    if (result_rec.oldpath IS NULL) then                               			ppath := 'http://apollo.wes.hpc.mil';                            	    else                                                                               ppath := result_rec.oldpath;                                   		    end if;                                                            		    htp.p('<tr><td align=left>'||result_rec.path||'</td>');            		    htp.p('<td align=left><a href="http://apollo.wes.hpc.mil'            		||result_rec.oldpath||'">'||ppath||                    				'</a></td></tr>');                                             		end loop;                                                              		htp.p('<tr align=center><td>Found:<b>'||tot||'</b></td><td>            		When:<i>'||to_char(sysdate,'Mon dd yy hh24:mi')||                        		' EST</i></td></tr>');                                            	htp.p('</table></center>');                                            
	if (j < tot) then                                                      		if ( j+10 < tot) then                                                       
		end_num := j+10;                                                              
	   else                                                                        
		end_num := tot;                                                               
	   end if;                                                                     
	   htp.p(url(root_url||'/webmaster.more_dead?start_num='||j||               
		'&total='||tot,'Next'||(j+1)||'-'||end_num)||' (of '||tot||')');              
	end if;                                                                        
    end if;                                                                     
    close deadcur;                                                             
end;                                                                            
procedure more_dead(start_num integer, total number) is                         
i integer;                                                                      
j integer;                                                                      
end_num integer;                                                                
ppath search_urls.oldpath%TYPE;                                                 
cursor deadcur is                                                               
        select * from search_urls where flag=4;                                 
result_rec search_urls%ROWTYPE;                                                 
begin                                                                           
   open deadcur;                                                                
   if ( start_num > 0) then                                                     
     for i in 1..start_num loop                                                 
	fetch deadcur into result_rec;                                                 
     end loop;                                                                  
   end if;                                                                      
   htp.p('<body background="'||server_name||'grey_profile.jpg"
>');                                                                              htp.p('<center><h2>All Dead Links On Apollo </h2></center>');                           
   htp.p('<br><img src="'||server_name||'forest.gif">'); 
   htp.p('<br><p>');                                                            
   htp.p(htf.bold('Host:http://apollo.wes.hpc.mil'));                             
   htp.p('<br><center><table border=2 cellpadding=0  cellspacing=0 width=90%>');
   htp.p('<tr align=center><th>Path</th><th>Parent Path</th></tr>');            
   j := 0;                                                                      
   for i in 1..10 loop                                                          
 	fetch deadcur into result_rec;                                                
        if (deadcur%NOTFOUND) then                                              
            exit;                                                               
        end if;                                                                 

	j := j+1;                                                                      
        if (result_rec.oldpath IS NULL) then                                    
           ppath := 'http://apollo.wes.hpc.mil';                                  
        else                                                                    
           ppath := result_rec.oldpath;                                         
        end if;                                                                 
        htp.p('<tr><td align=left>'||result_rec.path||'</td>');                 
        htp.p('<td align=left><a href="http://apollo.wes.hpc.mil'                 
		||result_rec.oldpath||'">'||                                                  
		ppath||'</a></td></tr>');                                                     
    end loop;                                                                   
    htp.p('<tr align=center><td>Found:<b>'||total||'</b></td><td>               
                When:<i>'||to_char(sysdate,'Mon dd yy hh24:mi')||               
                ' EST</i></td></tr>');                                          
    htp.p('</table></center>');                                                 
    if (j+start_num < total) then                                               
	if (j+start_num+10 < total) then                                               
	   end_num := j+start_num+10;                                                  
	else                                                                           
	   end_num := total;                                                           
	end if;                                                                        
	htp.p('<table width="100%"><tr>');                                             

	htp.p('<td align="left" width="35%">');                                        
	htp.p(url(root_url||'/webmaster.more_dead?start_num='||(j+start_num)        
		      ||'&total='||total,'Next '||(j+start_num+1)||                           
		      '-'||end_num)||' (of '||total||')');                                    
     end if;                                                                    
     if ( start_num >= 10) then                                                 
	htp.p('<td align="right">');                                                   
	htp.p(url(root_url||'/webmaster.more_dead?start_num='||(start_num-10)       
			||'&total='||total,'Prev'||(start_num-9)||                                   
			'-'||sTART_NUM)||' (of '||total||')');                                       
      end if;                                                                   
      htp.p('</table>');                                                        
      close deadcur;                                                            
end;                                                                            
procedure locat(n integer, p varchar2) is                                       
cursor cur (ll integer,p varchar2) is                                           
   select * from location                                                       
   where (instr(path,'/',1,ll)!=0) and l=ll                                     
	and (substr(path,1,instr(path,'/',1,(ll-1)))=p)                                
	order by substr(path,1,instr(path,'/',1,ll)) asc;                              
--	group by substr(path,1,instr(path,'/',1,ll));   
cursor fcur(p varchar2) is
	select fsize,time,no_html,no_imgs,path,host1 from search
	where (instr(path,p,1) = 1) 
	and ((instr(substr(path,length(p)+1),'/')=0)
		or (path=p))  
	order by substr(path,length(p)+1) asc;
num integer;                                                                   
res_path search.path%TYPE;
res_host search.host1%TYPE;
res_fsize search.fsize%TYPE;
res_link search.no_html%TYPE;
res_img  search.no_imgs%TYPE;
res_date search.time%TYPE;
result_rec location%ROWTYPE;                                                    
ppath varchar2(255);                                                            
subpath varchar2(255);                                                          
unitt varchar2(4);                                                              
scal number(8);   


begin                                                                           
   htp.p('<body background="'||server_name||'grey_profile.jpg">');                htp.p('<center><h2>Documents Distribution On Apollo</h2></center>');    
   htp.p('<img src="'||server_name||'forest.gif">');     
   htp.p('<p><center><table border=2 cellpadding=0 cellspacing=0 width=100%>');   htp.p('<tr align=center><th>Path</th><th>subpath</th><th>Pages</th>          		<th>Size(KB)</th><th>MaxSize(KB)</th><th>MinSize(KB)</th>
		<th>Links</th><th>Img</th><th>Last Update<br>(file only)</th></tr>');

   open cur(n+1,p);                                                             
   num := 0;                                                                    
   loop                                                                         
      fetch cur into result_rec;                                                
      if cur%NOTFOUND then 
	open fcur(p);--htp.p('pppp');return;
	loop
		num := num + 1;
		fetch fcur into res_fsize,res_date,res_link,res_img,res_path,res_host;
		if fcur%NOTFOUND then
		  exit;
		end if;
		
		htp.p('<tr align=left><td>'||'</td><td>');
		if ( res_path = p ) then
 		   htp.p(url('http://'||res_host||res_path,
			'index.html</td><td> 1 </td><td>'));
		else
		   htp.p(url('http://'||res_host||res_path,
 		       substr(res_path,length(p)+1)||'</td><td> 1 </td><td>'));
		end if;
		htp.p(to_char(res_fsize/1024.,'FM999999D9')||
		'</td><td>'||to_char(res_fsize/1024.,'FM999999D9')||
		'</td><td>'||to_char(res_fsize/1024.,'FM999999D9')||
		'</td><td>'||res_link||'</td><td>'||
		res_img||
		'</td><td>'||to_char(res_date,'mm/dd/yy')||
		'</td></tr>');
	end loop;
	close fcur;
	if (num=0) then                                                               
	  htp.p('<center><h2>There is no any documents here</h2></center></body>');                                                    
        end if;                                                                 
	   exit;                                                                       
      end if;                                                                   
      num := num + 1;                                                           
 	  ppath := substr(result_rec.path,1,instr(result_rec.path,'/',1,n));          
      subpath := substr(result_rec.path,instr(result_rec.path,'/',1,n)+1,       
				(instr(result_rec.path,'/',1,n+1)-1));                                      
	  htp.p('<tr align=left><td>'||'</td><td>');                                   
	  htp.p(url(root_url||'/webmaster.locat?n='||(n+1)||'&p='||                 
			result_rec.path,subpath));                                                   
	  htp.p('</td><td>'||result_rec.pages||'</td><td>'||                           
			to_char(result_rec.fsize/1024.,'FM999999D9')||'</td><td>'||                  
			to_char(result_rec.max_size/1024.,'FM999999D9')||'</td><td>'||               
			to_char(result_rec.min_size/1024.,'FM999999D9')||'</td><td>'                 
			||result_rec.no_html||'</td><td>'||result_rec.no_imgs||'</td></tr>');                                            
   end loop;                                                                    
   close cur;                                                                   
	select * into result_rec from location where path=p;                           
	if (n=1) then                                                                  
		unitt := '(MB)';                                                              
 		scal := (1024 * 1024);                                                       
	else                                                                           
		unitt := '(KB)';                                                              
		scal := 1024;                                                                 
    end if;                                                                     
    if (num != 0) then                                                          
      htp.p('<tr align=left><td>');                                             
      if (n>1) then                                                             
		 ppath := substr(result_rec.path,1,instr(result_rec.path,'/',1,n-1));         
	     htp.p(url(root_url||'/webmaster.locat?n='||(n-1)||'&p='||              
			ppath,result_rec.path));                                                     
      else                                                                      
	     htp.p(result_rec.path);                                                   
      end if;                                                                   
      htp.p('</td><td>Total</td><td>'                                           
    	||result_rec.pages||'</td><td>'||                                          
		to_char(result_rec.fsize/scal,'FM999999D9')||unitt||'</td><td>'||             
    	to_char(result_rec.max_size/scal,'FM999999D9')||unitt||'</td><td>'||       
		to_char(result_rec.min_size/scal,'FM999999D9')||unitt||'</td><td>'||          
		result_rec.no_html||'</td><td>'||            
		result_rec.no_imgs||'</td></tr>');            
      htp.p('</table></center></body>');                                        
    end if;                                                                     
	htp.p('<p>');                                                                  
    htp.p('<img src="'||server_name||'wavy.gif">');      
end;                                                                            
end webmaster;                                                                  
/
show errors;
/


