/*
** The operation index on class evaluation 
** Class: EvaluateIndex
** Author: Yuping Zhu
** Date: 04-07-1999
** Modify: 04-28-1999
** 	   Add Help Index
*/

package ascdb.admin;

// import package oracle.html to generate HTML page
import oracle.html.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import ascdb.conf;

public class EvaluateIndex extends HttpServlet {
   public void doGet(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
	// Output HTML page header
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();
	conf dbconf = new conf(req);
	
	String uid = req.getParameter("me");
	// Create the HTML Page head
	HtmlHead hd = new HtmlHead("Training DB Evaluation Index");
	
	// Create an HtmlBody Object
        HtmlBody bd = new HtmlBody();

        // Sets various attributes of HtmlBody
        bd.setBackgroundColor(Color.orange);

        // Creates an HtmlPage object using hd and bd
        HtmlPage hp = new HtmlPage(hd, bd);

//	bd.addItem(new SimpleItem("Training DB").setCenter().setBold().setFontColor(Color.black));
	bd.addItem(new Image(dbconf.ImageBase + "pet.gif","PET",IVAlign.TOP,false).setCenter());
	bd.addItem(SimpleItem.LineBreak);
//	bd.setFollowedLinkColor(Color.red);
	bd.setUnfollowedLinkColor(Color.white);
	bd.setActivatedLinkColor(Color.white);

	bd.addItem(new Link("ascdb.admin.CourseIndex?me=" + uid,"Courses").setBold().setFontSize(4))
	  .addItem(SimpleItem.LineBreak)
	  .addItem(new Link("ascdb.admin.ClassIndex?me=" + uid,"Classes").setBold().setFontSize(4))
	  .addItem(SimpleItem.LineBreak)
	  .addItem(new Link("ascdb.admin.UserIndex?me=" + uid, "Users").setBold().setFontSize(4))
	  .addItem(SimpleItem.LineBreak)
	  .addItem(new Link("ascdb.admin.TopIndex?me=" + uid, "Evaluations").setBold().setFontSize(4));

	Container dterms = new Container();
	DefinitionList dl = new DefinitionList();
/*	dl.addDef(dterms, new Link("ascdb.users.ListUser?op=1&me=" + uid, new SimpleItem("List"), "content").setFontSize(2))
	  .addDef(dterms, new Link("ascdb.users.ListUser?op=2&me=" + uid, new SimpleItem("Approve"),"content").setFontSize(2))
	  .addDef(dterms, new Link("ascdb.users.ListUser?op=3&me=" + uid, new SimpleItem("Modify"),"content").setFontSize(2))
	  .addDef(dterms, new Link("ascdb.users.ListUser?op=4&me=" + uid, new SimpleItem("Delete"),"content").setFontSize(2));*/
	dl.addDef(dterms,new SimpleItem("Will be finished in phrase 3"));
	bd.addItem(dl);
	
		
	bd	  
	  .addItem(new Link("ascdb.admin.LookupIndex?me=" + uid, "LookUp Tables").setBold().setFontSize(4))
	  .addItem(SimpleItem.LineBreak)
	  .addItem(new Link("ascdb.pub.Help?", new SimpleItem("Help"),"content").setBold().setFontSize(4));

	out.println(hp);
   }
}