/*
** Register a class
** Class: RegisterClass
** Author: Yuping Zhu
** Date: 03-31-1999
** Modified by Yuping Zhu At:01-25-2000
** Action: Change DB tables name
*/

package ascdb.classes;

// import package java.sql to use JDBC
import java.sql.*;

import javax.servlet.http.*;
import javax.servlet.*;
import java.io.*;

import ascdb.conf;
//import ascdb.pub.UserCheck;
import ascdb.users.UserValidation;

public class RegisterClass extends HttpServlet {
    public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException
	{
	
        // Output HTML page header
        res.setContentType("text/html");
	PrintWriter out = res.getWriter();
	conf dbconf= new conf(req);
	String uid = req.getParameter("uid");
	String cid = req.getParameter("cid");
	int ClassId = (new Integer(cid)).intValue();
	//	UserCheck u = new UserCheck(uid);
	UserValidation UserV = new UserValidation();

	try {
	   int TabRow = UserV.Validation(req);
	   if (TabRow < 4)
	   {
		out.println("Sorry! You can not register class!" + TabRow);
		return;
	   }
	   // Load the Oracle JDBC driver
	   Class.forName (dbconf.JdbcDriver);

	   // Connect to the database
	   Connection conn =
		DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
	
	   // Create a Statement
	   Statement stmt = conn.createStatement ();
	
	   // check if class seat full
	   int ClassSize = 0;
	   ResultSet rset1 = stmt.executeQuery("select class_size from classes where class_id = " + ClassId);
	   if (rset1.next())
		ClassSize = rset1.getInt("class_size");
	   rset1.close();	 

	   ResultSet rset2 = stmt.executeQuery("select count(*) from class_students where class_id = " + ClassId);
	
	   int Full = 1;
	   String Confirm = "N";
	   if (rset2.next())
	      if (ClassSize > rset2.getInt(1))
	      {
		  Full = 0;
		  Confirm = "Y";
	      }
	   rset2.close();
		
	   // Insert into DB
	   int rcount1 = stmt.executeUpdate("insert into class_students values(" + ClassId + ",'" + uid + "',sysdate,'" + Confirm + "')");
	   out.println("You have registered the class: " + ClassId);
	   if (Full == 1) 
		out.println(" But the class is full now, and you are in waiting list");
	   out.println("<form method=\"POST\" action=\"ascdb.users.FrontPage\">");
	    out.println("<input type=hidden name=\"uid\" value=\"" + uid + "\">");
	    out.println("<input type=submit name=\"submit\" value=\"Back To Main Menu\">");
	    out.println("</form>");
	   }
	   catch (ClassNotFoundException e) {
		out.println("Can not load JDBC driver: " + e.getMessage());
	   }
	   catch (SQLException e) {
		out.println(e.getMessage());
	   }
	   catch (Exception e) {
		out.println(e.getMessage());
	   }
}
}
