/*
** This is a config file for Training DB, it gets all configure parameters
** from congfigure file configure.txt
** Class: conf
** Author: Yuping Zhu
** Date: 03-10-1999
*/
package ascdb;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.RandomAccessFile;
//import java.io.File;
import javax.servlet.http.*;

public class conf extends HttpServlet {
	public static String JdbcDriver;
	public static String ServerURLBase;
	public static String ImageBase;
	public static String DBName;
	public static String DBPassword;
	public static String ConnectStr;
	public static String AdminEmail;
	public static String AdminName;
        public static String AdminPhone;
        public static String FreePhone;
        public static String OfficerName;
        public static String OfficerPh;
        public static String OfficerFax;
        public static String OfficerEmail;
        public static String DSN;
        public static String TMDEmail;
        public static String EmailServer;

        public static String ServletHome;

	public conf(HttpServletRequest req){
	
     	try {
	//RandomAccessFile f = new RandomAccessFile("/npac/home/yuzhu/java/webserver/JavaWebServer1.1.3/servlets/configure.txt","r");
	String HtmlHome = req.getRealPath("/");
	String ServletHome = HtmlHome.substring(0,HtmlHome.lastIndexOf('/',HtmlHome.length() - 2)) + "/servlets/ascdb/";

       	RandomAccessFile f = new RandomAccessFile(ServletHome + "configure.txt","r");
	String line = f.readLine();
	while (line != null) {
     //	System.out.println(line);
          if (line.equals("JdbcDriver:"))
		JdbcDriver = f.readLine();
    	  else if (line.equals("ServerURLBase:"))
		ServerURLBase = f.readLine();
	  else if (line.equals("ImageBase:"))
		ImageBase = f.readLine();
	  else if (line.equals("DBName:"))
		DBName = f.readLine();
	  else if (line.equals("DBPassword:"))
		DBPassword = f.readLine();
	  else if (line.equals("ConnectString:"))
		ConnectStr = f.readLine();
	  else if (line.equals("ContactEmail:"))
		AdminEmail = f.readLine();
	  else if (line.equals("ContactName:"))
		AdminName = f.readLine();
	  else if (line.equals("AdminPhone:"))
	        AdminPhone = f.readLine();
	  else if (line.equals("TollFree:"))
	        FreePhone = f.readLine();
	  else if (line.equals("OfficerName:"))
	        OfficerName = f.readLine();
	  else if (line.equals("OfficerPhone:"))
	        OfficerPh = f.readLine();
	  else if (line.equals("OfficerFax:"))
	        OfficerFax = f.readLine();
	  else if (line.equals("OfficerEmail:"))
	        OfficerEmail = f.readLine();
	  else if (line.equals("OfficerDSN:"))
	        DSN = f.readLine();
	  else if (line.equals("TMDEmail:"))
	        TMDEmail = f.readLine();
	  else if (line.equals("EmailServer:"))
	        EmailServer = f.readLine();
	  line = f.readLine();
	}
	f.close();
/*	System.out.println(JdbcDriver);
	System.out.println(ServerURLBase);
	System.out.println(DBPassword);
	System.out.println(ConnectStr);
	System.out.println(DBName);*/
      	}
	catch (IOException e)
	{
	 System.out.println(e);
	 }

}
}

	 

