/*
** Accept the input from create new course page with class CreateCourse
** Insert the Input into table : courses
** Class: InsertCourse
** Author: Yuping Zhu
** Date: 03-25-1999
*/

package ascdb.courses;

// import package java.sql to use JDBC 
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.conf;



public class InsertCourse extends HttpServlet {
    public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException
    {
    // Output HTML page header
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();
    conf dbconf= new conf(req);
    String CourseNum = req.getParameter("num");
    String Tit = req.getParameter("tit");
    String Day = req.getParameter("days");
    Integer toint = new Integer(Day);
    String Descriptions = req.getParameter("descriptions");

    out.println("<body bgcolor=\"fffff2\">");

//    out.println(Day + "\n" + toint);
//    out.println(CourseNum + "\n" + Tit + "\n" + Descriptions +"\n");
	
    try {
    // Load the Oracle JDBC driver
    Class.forName (dbconf.JdbcDriver);
    //out.println("Loading JDBCdriver");

	/*Connect to the database
   Connection conn =
      DriverManager.getConnection ("jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe","scott", "tiger");
	System.out.println("Connect to db");
    Statement stmt = conn.createStatement ();
    ResultSet rset = stmt.executeQuery ("select ename from emp");
System.out.println("Print out result:");
    while (rset.next ())
    System.out.println (rset.getString (1));*/

     // Connect to the database
     Connection conn =
          DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
     //System.out.println("Connect to db: ascdb");
     Statement stmt = conn.createStatement ();
     ResultSet IdSeq = stmt.executeQuery ("select courses_seq.nextval from dual");
     //    ResultSetMetaData rsmd = IdSeq.getMetaData();
     //    System.out.println("ffff" + rsmd.getColumnTypeName(1));
     int CourseId = 0;
     if (IdSeq.next ())
         CourseId = IdSeq.getInt(1);

     int rcount = stmt.executeUpdate ("insert into courses (course_id,course_num,title,overview,duration) values (" + CourseId + ",'" + CourseNum +"','" + Tit +"','" + Descriptions + "'," + toint +")");
    
//    out.println("Row Count:" + rcount);
      out.println("Course:" + CourseNum + " has been created with course_id: " + CourseId);
    
    }
    catch (SQLException e) {
	out.println("can not load JDBC driver: " + e.getMessage());
    }
    catch (Exception e) {
	out.println(e.getMessage());
    }
}

}
