/*
** This is uer login page for Training System
** Class: LoginPage
** Author: Yuping Zhu
** Date: 03-11-1999
** Modified Date: 06-17-1999
**          Action: Add information line
** Modified Date: 10-08-1999
**          Action: Redesign web interface by ASC
** Modified Date: 01-13-2000
**          Action: Redesign web interface by ASC
*/

package ascdb.pub;

import oracle.html.*;
import javax.servlet.*;
import javax.servlet.http.*;

import java.io.*;
import ascdb.conf;
import java.text.Collator;

public class WelcomePage extends HttpServlet {

    public void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
	{
	
        // Output HTML page header
        res.setContentType("text/html");
	PrintWriter out = res.getWriter();
      	conf dbconf= new conf(req);
	Collator cl = Collator.getInstance();

        try {
	// Creates an HtmlHead Object
	HtmlHead hd = new HtmlHead("Training System Welcome Page");
	
        // Create an HtmlBody Object
	HtmlBody bd = new HtmlBody();

	// Sets various attributes of HtmlBody
     	bd.setBackgroundColor("#fffff2");
//	bd.setBackgroundColor(new Color(10,10,10));	

	// Creates an HtmlPage object using hd and bd
	HtmlPage hp = new HtmlPage(hd, bd);
	Font f = new Font(Color.red,"myfont","+5");
	
 	hp
	  .addItem(new Image(dbconf.ImageBase + "pet.gif","PET",IVAlign.TOP,false).setCenter())
          .addItem(SimpleItem.Paragraph)
//	  .addItem(new SimpleItem("Welcome To the ASC MSRC PET").setCenter().setBold().setFontColor(Color.red))
	  .addItem(new SimpleItem(f.toHTML()))
	  .addItem(new SimpleItem("Welcome To the ASC MSRC PET").setCenter().setBold().setHeading(3))
	  .addItem(new SimpleItem("Training Management Database (TMD)").setCenter().setBold().setHeading(3))
	  .addItem(SimpleItem.HorizontalRule)
	  .addItem(SimpleItem.Paragraph);
	
	Font bf = new Font(Color.teal,null,"+1");
	hp.addItem(new SimpleItem(bf.toHTML()));	
	/*     
	Form loginUser = new Form("GET",dbconf.ServerURLBase + "ascdb.pub.LoginPage");
	loginUser.addItem(new Submit("submit", "        Login       ").setBold().setFontColor(Color.red));
		Form loginAdmin = new Form("GET",dbconf.ServerURLBase + "ascdb.pub.LoginPage");
		loginAdmin.addItem(new Submit("submit", "Login as Administrator").setBold().setFontColor(Color.red));
	Form searchfm = new Form("POST",dbconf.ServerURLBase + "ascdb.pub.PublicPage");
	searchfm
		.addItem(new Hidden("op","0"))
		.addItem(new Hidden("me","u"))
		.addItem(new Submit("submit","View Training Schedule").setBold().setFontColor(Color.red));

        Form RegisterOne = new Form("GET",dbconf.ServerURLBase + "ascdb.pub.UserRegister");
	RegisterOne
	        .addItem(new Hidden("op","0"))
	        .addItem(new Submit("submit","Register (One Time Only)").setBold().setFontColor(Color.red));
	
	Form LogOut = new Form("GET", dbconf.ServerURLBase + "ascdb.pub.UserRegister");
	LogOut
	        .addItem(new Hidden("op","1"))
	        .addItem(new Submit("submit","         Logout       ").setBold().setFontColor(Color.red));
	Form ChangePasswd = new Form("GET",dbconf.ServerURLBase + "ascdb.users.ChangePasswd");
	  ChangePasswd.addItem(new Submit("submit","Change Your Password").setBold().setFontColor(Color.red));*/

		
	// Create table to hold all these links
	DynamicTable tab = new DynamicTable(1);
	tab.setBackgroundColor (Color.aqua);
	//  tab.setBorderColor (Color.navy);
	tab.setBorder(0);
	tab.setCellSpacing(20);
	tab.setCellPadding(10);
	TableRow[] rows = new TableRow[4];
        for (int i=0; i<4; i++)
	    rows[i] = new TableRow();
	
	rows[0]
	    .addCell(new TableDataCell(new Link("ascdb.pub.UserRegister","Register (One Time Only)").setBold().setFontSize(4).setCenter()));
	rows[1]
	    .addCell(new TableDataCell(new Link("ascdb.pub.LoginPage","Login").setBold().setFontSize(4).setCenter()));
	rows[2]
	    .addCell(new TableDataCell(new Link("ascdb.classes.ClassList?op=1","View Training Schedule").setBold().setFontSize(4).setCenter()));
	rows[3]
	    .addCell(new TableDataCell(new Link("ascdb.users.UserLogout","Logout").setBold().setFontSize(4).setCenter()));
	
	for (int i=0; i<4; i++)
	    tab.addRow(rows[i]);
        bd.addItem(tab.setCenter());

	//bd.addItem(loginfm.setCenter());
	//bd.addItem(searchfm.setCenter());
	
	Font addrf = new Font(Color.black,null,"-1");
	hp.addItem(new SimpleItem(addrf.toHTML()));

	hp
	  .addItem(new Image(dbconf.ImageBase + "wavy.gif").setCenter())
	  .addItem(new SimpleItem("<center><address>For questions, contact "))
	  .addItem(new Link("mailto:" + dbconf.AdminEmail, dbconf.AdminName))
	  .addItem(new SimpleItem(" or call toll-free 1-888-MSRC-ASC (1-888-677-2272)."));
	hp.addItem(new SimpleItem(" </address></center>"));
	    //	  .addItem(SimpleItem.LineBreak)
	    // .addItem(new SimpleItem("Please send comments to <a mailto = '" + dbconf.AdminEmail + "'>" + dbconf.AdminName + "</a>").setItal().setCenter());

	
//	String ServerHome = req.getRealPath("/");
//	hp.addItem(new SimpleItem(ServerHome));
	out.println(hp);
       	}
	catch (Exception e) {
	 out.println("Could not generate Welcome Page!");
	}
	}
    
    public void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
    { doGet(req,res);}
}
	
	
