/*
** The form for user to register
** Class: UserRegister
** Author: Yuping Zhu
** Date: 10-25-1999
** Modified: 01-13-2000
** Modified: 03-01-2000
*/

package ascdb.pub;

//import package java.sql to use JDBC
import java.sql.*;

//import package oracle.html to generate dynamic HTML page
import oracle.html.*;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import ascdb.conf;

public class UserRegister extends HttpServlet {

  public void doGet(HttpServletRequest req, HttpServletResponse res)
        throws  ServletException, IOException
  {
    // Output HTML page header
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();
    //    int fg = (new Integer(req.getParameter("op"))).intValue();
    conf dbconf= new conf(req);
    String tit = "Student";
    /*   String fun = "attend";
    if (fg == 1) {
	tit = "Instructor";
	fun = "teach";
	}*/

    try {
	// Load the Oracle JDBC driver
	Class.forName (dbconf.JdbcDriver);
	
	// Connect to the database
	Connection conn =
	    DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);

	// Create a Statement
	Statement stmt = conn.createStatement ();

       	HtmlStringBuffer HTMLBuf = new HtmlStringBuffer();
	HTMLBuf.appendln("<HTML>");
	HTMLBuf.appendln("<HEAD>");
	HTMLBuf.appendln("<TITLE>ASC TMD Registration Form</TITLE>");

	//Create a JavaScript Object
	Script js = new Script("JavaScript");
	js.setCode("function Validation(form) {\n"
		 + "   if (myEmpty(form.firstname)) {\n"
		 + "      ErrorMsg(\"First Name\")\n"
		 + "      return false\n"
		 + "   }\n"

	      /*		 + "   if (! form.B_type[0].selected) {\n"
		 + "     alert(\"OK!\")\n"
                 + "     return false\n"
		 + "   }\n"*/

		 + "   if (myEmpty(form.lastname)) {\n"
		 + "      ErrorMsg(\"Last Name\")\n"
		 + "      return false\n"
		 + "   }\n"
		 + "   if (myEmpty(form.address)) {\n"
		 + "      ErrorMsg(\"Address\")\n"
		 + "      return false\n"
		 + "   }\n"
		 + "   if (myEmpty(form.city)) {\n"
		 + "      ErrorMsg(\"City\")\n"
		 + "      return false\n"
		 + "   }\n"
		 + "   if (myEmpty(form.zip)) {\n"
		 + "      ErrorMsg(\"Zip\")\n"
		 + "      return false\n"
		 + "   }\n"
		 + "   if (myEmpty(form.phone)) {\n"
		 + "      ErrorMsg(\"Phone\")\n"
		 + "      return false\n"
		 + "   }\n"
		 + "   if (myEmpty(form.email)) {\n"
		 + "      ErrorMsg(\"Email\")\n"
		 + "      return false\n"
		 + "   }\n"
		 + "   if (myEmpty(form.b_name)) {\n"
		 + "      ErrorMsg(\"Business Name\")\n"
		 + "      return false\n"
		 + "   }\n"
/*		 + "   if (myEmpty(form.passwd1)) {\n"
		 + "      ErrorMsg(\"Password\")\n"
		 + "      return false\n"
		 + "   }\n"*/

		 + "   if (! form.userType[3].selected) {\n"
		 + "      if (myEmpty(form.s_f_name)) {\n"
		 + "         ErrorSponsor(\"First Name\")\n"
		 + "         return false\n"
                 + "      }\n"
                 + "      if (myEmpty(form.s_l_name)) {\n"
		 + "         ErrorSponsor(\"Last Name\")\n"
		 + "         return false\n"
                 + "      }\n"
                 + "      if (myEmpty(form.s_phone)) {\n"
		 + "         ErrorSponsor(\"Phone\")\n"
		 + "         return false\n"
                 + "      }\n"
                 + "      if (myEmpty(form.s_email)) {\n"
		 + "         ErrorSponsor(\"Email\")\n"
		 + "         return false\n"
                 + "      }\n"
		 + "      if (myEmpty(form.s_address)) {\n"
		 + "         ErrorSponsor(\"Address\")\n"
		 + "         return false\n"
                 + "      }\n"
                 + "      if (myEmpty(form.s_city   )) {\n"
		 + "         ErrorSponsor(\"City\")\n"
		 + "         return false\n"
                 + "      }\n"
/*		 + "      if (form.passwd1.value != form.passwd2.value) {\n"
		 + "         alert(\"Your Password Confirm is not the same as your password input! Please correct it!\")\n"
                 + "         return false\n"
		 + "      }\n"*/

                 + "   }\n" 
		 + "   return true\n\n"
		 + "}\n\n"
		 + "function myEmpty(str) {\n"
		 + "   var typein = new String(str.value)\n"
		 + "   if (typein.length == 0) return true\n"
		 + "   while(typein.charCodeAt(0) == 32)\n"
		 + "        typein = typein.substring(1)\n"
                 + "   if (typein.length == 0) return true\n"
		 + "   return false\n"
		 + "}\n\n"
		 + "function ErrorMsg(err) {\n"
		 + "   alert(\"Your \" + err + \" was blank, Please go back to the form to correct it!\")\n"
		 + "}\n\n"
                 + "function ErrorSponsor(err) {\n"
		 + "   alert(\"Since your Employment is not DoD, you must provide Sponsor Information. Sponsor's \" + err + \" was blank. Please go back to the form and correct the error.\")\n"
		 + "}\n");

HTMLBuf.append(js);
HTMLBuf.appendln("</HEAD>");
//Create an HtmlBody Object
  HtmlBody bd = new HtmlBody();

// Sets various attributes of HtmlBody
  bd.setBackgroundColor("#ffffe6");


HTMLBuf.append("<FORM METHOD=\"POST\" ACTION=\"ascdb.pub.InsertUser\" OnSubmit=\"return Validation(this)\">");
//hp.addItem(js);
// Create the main form
//Form frm = new Form("POST","ascdb.pub.InsertUser");
 bd.addItem(new SimpleItem("TMD Registration Form").setBold().setFontSize(5).setCenter()); 

bd
    /*   .addItem(new SimpleItem("To register to " + fun + " ASC MSRC PET training courses, complete and submit this registration form. ").setBold().setItal().setFontColor(Color.olive).setFontSize(3))
	 .addItem(SimpleItem.LineBreak)*/
   .addItem(new SimpleItem("* Denotes Required Field").setBold().setItal().setFontColor(Color.red).setFontSize(3).setCenter())
   .addItem(SimpleItem.LineBreak)
   .addItem(new Image(dbconf.ImageBase + "wavy.gif"))
   .addItem(SimpleItem.Paragraph); 
    
// List all valid surtitles

ResultSet SurtitleRset = stmt.executeQuery("select * from domain where domain_name='SURTITLES' order by order_num asc");

Select Surtitle = new Select("surtitle");
while (SurtitleRset.next())
    Surtitle.addOption(new Option(SurtitleRset.getString("char_code")));
Surtitle.addOption(new Option("Surtitle*","surtit",true));
bd.addItem(Surtitle);

SurtitleRset.close();

bd
   .addItem(new SimpleItem("First Name*: ").setBold())
   .addItem(new TextField("firstname", 35, 15,""))
   .addItem(new SimpleItem("Middle Name: ").setBold())
   .addItem(new TextField("middlename", 35, 15,""))
   .addItem(new SimpleItem("Last Name*: ").setBold())
   .addItem(new TextField("lastname", 35, 15,""))
   .addItem(SimpleItem.LineBreak)
   .addItem(new SimpleItem("Primary Street Address*: ").setBold())
   .addItem(new TextField("address",50,30,""))
   .addItem(SimpleItem.LineBreak)
   .addItem(new SimpleItem("Secondary Address: ").setBold())
   .addItem(new TextField("address2",50,30,""))
   .addItem(SimpleItem.LineBreak)
   .addItem(new SimpleItem("Room Number: ").setBold())
   .addItem(new TextField("room",10,10,""))
   .addItem(new SimpleItem("Mail Stop: ").setBold())
   .addItem(new TextField("mail", 20, 20, ""))
   .addItem(SimpleItem.LineBreak)
   .addItem(new SimpleItem("City*: ").setBold())
   .addItem(new TextField("city",30,30,""));

bd.addItem(new SimpleItem("State*: ").setBold());

ResultSet StateRset = stmt.executeQuery("select * from domain where domain_name='STATES' order by expsn asc");

Select StateSelect = new Select("state");

while (StateRset.next())
   StateSelect.addOption(new Option(StateRset.getString("expsn")));

bd.addItem(StateSelect);
StateRset.close();


bd
   .addItem(new SimpleItem("Zip Code*: ").setBold())
   .addItem(new TextField("zip", 11, 11, ""))
   .addItem(SimpleItem.LineBreak);

bd.addItem(new SimpleItem("Country*: ").setBold());

ResultSet CRset = stmt.executeQuery("select * from domain where domain_name='COUNTRIES' order by order_num asc");

Select CountrySelect = new Select("country");

while (CRset.next())
      CountrySelect.addOption(new Option(CRset.getString("expsn")));
bd
   .addItem(CountrySelect)
   .addItem(SimpleItem.LineBreak);

CRset.close();   

bd
   .addItem(new SimpleItem("Phone*: ").setBold())
   .addItem(new TextField("phone", 15, 15, ""))
   .addItem(new SimpleItem("Phone Extension: ").setBold())
   .addItem(new TextField("ext", 5, 5, ""))
   .addItem(SimpleItem.LineBreak)
   .addItem(new SimpleItem("Alternate Phone: ").setBold())
   .addItem(new TextField("alt_phone", 15, 15, ""))
   .addItem(new SimpleItem("FAX: ").setBold())
   .addItem(new TextField("fax", 15, 15, ""))
   .addItem(SimpleItem.LineBreak)
   .addItem(new SimpleItem("Email Address*:").setBold()) 
   .addItem(new TextField("email", 50, 50, ""))
   .addItem(SimpleItem.LineBreak)
   .addItem(new SimpleItem("Would you like your email address to be shared with other attendees?*").setBold())
   .addItem(SimpleItem.LineBreak)
   .addItem(new SimpleItem("Yes"))
   .addItem(new Radio("shared","Y",true))
   .addItem(new SimpleItem("No"))
   .addItem(new Radio("shared","N"))
   .addItem(SimpleItem.LineBreak)
   .addItem(new SimpleItem("Would you like us to add your email address to our ASC PET mailing list?* ").setBold())
   .addItem(SimpleItem.LineBreak)
   .addItem(new SimpleItem("Yes"))
   .addItem(new Radio("list","Y",true))
   .addItem(new SimpleItem("No"))
   .addItem(new Radio("list","N"))
   .addItem(SimpleItem.LineBreak)
   .addItem(new SimpleItem("Which is your Computational Technology Area (CTA)?").setBold())
   .addItem(SimpleItem.LineBreak);
 
ResultSet CTAset = stmt.executeQuery("select * from domain where domain_name='CTAS' order by order_num asc");
 
Select CTAs = new Select("cta");
while (CTAset.next())
    CTAs.addOption(new Option(CTAset.getString("expsn")));
//CTAs.addOption(new Option("None","none",true));
bd
    .addItem(CTAs)
    .addItem(SimpleItem.LineBreak)
    .addItem(new SimpleItem("What other CTAs do you have interest in?(Choose all that apply.)").setBold())
   .addItem(SimpleItem.LineBreak);
CTAset.close(); 

ResultSet CTAset2 = stmt.executeQuery("select * from domain where domain_name='CTAS' order by order_num asc");
 
Select CTAs2 = new Select("cta2",4,true);
while (CTAset2.next())
    CTAs2.addOption(new Option(CTAset2.getString("expsn")));
//CTAs2.addOption(new Option("None","none",true));
bd
    .addItem(CTAs2)
    .addItem(SimpleItem.LineBreak)
    .addItem(new SimpleItem("List special needs (e.g., mobility impaired):").setBold())
    .addItem(SimpleItem.LineBreak)
    .addItem(new TextArea("comments", 60,3))
    .addItem(SimpleItem.LineBreak);
CTAset2.close();

// List all valid countries
bd.addItem(new SimpleItem("Citizenship*: ").setBold());

ResultSet CountryRset = stmt.executeQuery("select * from domain where domain_name='COUNTRIES' order by order_num asc");

Select Country = new Select("citizenship");

while (CountryRset.next())
      Country.addOption(new Option(CountryRset.getString("expsn")));
bd
   .addItem(Country)
   .addItem(SimpleItem.LineBreak);

CountryRset.close();

bd
    .addItem(new SimpleItem("** Please note: All ASC MSRC students must meet citizenship requiremens as per"))
    .addItem(SimpleItem.LineBreak)
    .addItem(new SimpleItem("\"Foreign National Access to the ASC MSRC\" document.").setBold())
    .addItem(SimpleItem.LineBreak)
    .addItem(new SimpleItem("Permit Type").setBold());

ResultSet PermitRset = stmt.executeQuery("select * from domain where domain_name='PERMIT TYPES' order by order_num asc");

Select Permit = new Select("permit");
while (PermitRset.next())
    Permit.addOption(new Option(PermitRset.getString("char_code")));
PermitRset.close();
bd
    .addItem(Permit)
    .addItem(SimpleItem.LineBreak)
    .addItem(new SimpleItem("Permit Number").setBold())
    .addItem(new TextField("p_num",20,20,""))
    .addItem(new SimpleItem("Expiration Date (dd/mm/yyyy) ").setBold())
    .addItem(new TextField("exp_date",20,20,""))
    .addItem(SimpleItem.LineBreak)
    .addItem(new SimpleItem("Do you have a NAC or Security Clearance? ").setBold());


ResultSet NacSet = stmt.executeQuery("select * from domain where domain_name='NAC TYPES' order by order_num asc");
Select Nac = new Select("nac_type");
while( NacSet.next())
    Nac.addOption(new Option(NacSet.getString("char_code")));
NacSet.close();

bd.addItem(Nac);

/*bd
    .addItem(new SimpleItem("Yes").setBold())
    .addItem(new Radio("nac","Y"))
    .addItem(new SimpleItem("No").setBold())
    .addItem(new Radio("nac","Y"))*/
bd
    .addItem(SimpleItem.LineBreak)
    .addItem(new SimpleItem("What is your Business Types?* ").setBold());

ResultSet Brset = stmt.executeQuery("select * from domain where domain_name='BUSINESS TYPES' order by order_num asc");
Select Business = new Select("B_type");
while(Brset.next())
    Business.addOption(new Option(Brset.getString("char_code")));
bd
    .addItem(Business)
    .addItem(SimpleItem.LineBreak)
    .addItem(new SimpleItem("User Type: ").setBold());

    ResultSet UtypeSet = stmt.executeQuery("select * from domain where domain_name = 'USER TYPES' order by order_num");
Select Utype = new Select("userType");
while (UtypeSet.next())
    Utype.addOption(new Option(UtypeSet.getString("char_code")));
    
bd
    .addItem(Utype)
    .addItem(SimpleItem.LineBreak)
    .addItem(new SimpleItem("What is your Business Name?* ").setBold())
    .addItem(new TextField("b_name",50,50,""))
    .addItem(SimpleItem.LineBreak)
    .addItem(new SimpleItem("Please provide a 4-digit number to be used for account verification purpose (For example, if you forget your password you will be asked for this number when you call): ").setBold())
    .addItem(new TextField("ssn",4,4,""))
    .addItem(SimpleItem.LineBreak)
    .addItem(new SimpleItem("If you have a current MSRC account, please provide your User Name.").setBold())
    .addItem(new TextField("msrc_acct",20,20,""))
    .addItem(SimpleItem.Paragraph)
    .addItem(new Image(dbconf.ImageBase + "wavy.gif"))
    .addItem(SimpleItem.Paragraph)
    .addItem(new SimpleItem("IF APPLICANT IS NOT A DOD EMPLOYEE, COMPLETE THE FOLLOWING SECTION:").setBold())
    .addItem(SimpleItem.LineBreak)
    /*    .addItem(new SimpleItem("Sponsor Information:").setBold().setFontColor(Color.red).setFontSize(3))
    .addItem(SimpleItem.LineBreak)
    .addItem(new SimpleItem("Sponsor's First Name*: ").setBold())
    .addItem(new TextField("s_f_name",35,35,""))
    .addItem(SimpleItem.LineBreak)
    .addItem(new SimpleItem("Sponsor's Last Name*: ").setBold())
    .addItem(new TextField("s_l_name",35,35,""))
    .addItem(SimpleItem.LineBreak)*/
    .addItem(new SimpleItem("Sponsor's Organization*").setBold());
Brset.close();

ResultSet orgSet = stmt.executeQuery("select * from domain where domain_name='ORGANIZATIONS' order by order_num asc");
Select orgS = new Select("org");
while (orgSet.next())
    orgS.addOption(new Option(orgSet.getString("char_code")));
bd
    .addItem(orgS)
    .addItem(SimpleItem.LineBreak);

ResultSet SurRset = stmt.executeQuery("select * from domain where domain_name='SURTITLES' order by order_num asc");

Select Surtit = new Select("s_surtitle");
while (SurRset.next())
      Surtit.addOption(new Option(SurRset.getString("char_code")));
Surtit.addOption(new Option("Surtitle*","surtit",true));
	    SurRset.close();

	    bd
	       .addItem(Surtit)
	       .addItem(new SimpleItem("First Name*: ").setBold())
	       .addItem(new TextField("s_f_name",35,15,""))
	       .addItem(new SimpleItem("Middle Name: ").setBold())
	       .addItem(new TextField("s_m_name",35,15,""))
	       .addItem(new SimpleItem("Last Name*: ").setBold())
	       .addItem(new TextField("s_l_name",35,15,""))
	       .addItem(SimpleItem.LineBreak)
	       .addItem(new SimpleItem("Primary Street Address*: ").setBold())
	       .addItem(new TextField("s_address",50,50,""))
	       .addItem(SimpleItem.LineBreak)
	       .addItem(new SimpleItem("Secondary Address: ").setBold())
	       .addItem(new TextField("s_address2",50,50,""))
	       .addItem(SimpleItem.LineBreak)
	       .addItem(new SimpleItem("Room Number: ").setBold())
	       .addItem(new TextField("s_room",10,10,""))
	       .addItem(new SimpleItem("Mail Stop: ").setBold())
	       .addItem(new TextField("s_mail", 20, 20, ""))
	       .addItem(SimpleItem.LineBreak)
	       .addItem(new SimpleItem("City*: ").setBold())
	       .addItem(new TextField("s_city",30,20,""));

	    bd.addItem(new SimpleItem("State*: ").setBold());

	    StateRset = stmt.executeQuery("select * from domain where domain_name='STATES' order by expsn asc");

	    Select s_StateSelect = new Select("s_state");

	    while (StateRset.next())
		s_StateSelect.addOption(new Option(StateRset.getString("expsn")));

	    bd.addItem(s_StateSelect);
	    StateRset.close();


	    bd
		.addItem(new SimpleItem("Zip Code*: ").setBold())
		.addItem(new TextField("s_zip", 11, 11, ""))
		.addItem(SimpleItem.LineBreak);

	    bd.addItem(new SimpleItem("Country*: ").setBold());

	    ResultSet s_CRset = stmt.executeQuery("select * from domain where domain_name='COUNTRIES' order by order_num asc");

	    Select s_CountrySelect = new Select("s_country");

	    while (s_CRset.next())
		s_CountrySelect.addOption(new Option(s_CRset.getString("expsn")));
	    bd
		.addItem(s_CountrySelect)
		.addItem(SimpleItem.LineBreak);

	    s_CRset.close();   

	    bd
		.addItem(new SimpleItem("Phone*: ").setBold())
		.addItem(new TextField("s_phone", 15, 15, ""))
		.addItem(new SimpleItem("Phone Extension: ").setBold())
		.addItem(new TextField("s_ext", 5, 5, ""))
		.addItem(SimpleItem.LineBreak)
		.addItem(new SimpleItem("Alternate Phone: ").setBold())
		.addItem(new TextField("s_alt_phone", 15, 15, ""))
		.addItem(new SimpleItem("FAX: ").setBold())
		.addItem(new TextField("s_fax", 15, 15, ""))
		.addItem(SimpleItem.LineBreak)
		.addItem(new SimpleItem("Email*:").setBold()) 
		.addItem(new TextField("s_email", 50, 50, ""))
		.addItem(SimpleItem.Paragraph);
    /*
    .addItem(new SimpleItem("Sponsor's Phone* (###-###-####): ").setBold())
    .addItem(new TextField("s_phone",15,15,""))
    .addItem(new SimpleItem("Sponsor's Ext: ").setBold())
    .addItem(new TextField("s_ext",15,15,""))
    .addItem(SimpleItem.LineBreak)
    .addItem(new SimpleItem("Sponsor's FAX: ").setBold())
    .addItem(new TextField("s_fax",15,15,""))
    .addItem(SimpleItem.LineBreak)
    .addItem(new SimpleItem("Sponsor's Email Address*: ").setBold())
    .addItem(new TextField("s_email",50,50,""))
    .addItem(SimpleItem.LineBreak)
    .addItem(new Image(dbconf.ImageBase + "wavy.gif"))
    .addItem(SimpleItem.Paragraph); 
    .addItem(SimpleItem.LineBreak)
    .addItem(new SimpleItem("Password: ").setBold())
    .addItem(new PasswordField("passwd1",30,30,""))
    .addItem(new SimpleItem("Password Confirm: ").setBold())
    .addItem(new PasswordField("passwd2",30,30,""))
    .addItem(SimpleItem.LineBreak)*/
    

bd
//    .addItem(new Hidden("purpose",tit))
    .addItem(new Hidden("op","0"));
bd
    .addItem(SimpleItem.Paragraph)
    .addItem(new Submit("submit", "Submit Form").setBold())
    .addItem(new Reset("Reset").setBold());             
 
  // Adds form to HtmlBody
  //  bd.addItem(frm);
//  hp.printHeader();
//  hp.print();

  HTMLBuf.append(bd);
  //  HTMLBuf.append("<input type=\"button\"  value=\"Test\" onClick=\"Validation(frm)\">");
  
  out.println(HTMLBuf);
  //  out.println(hp.toHTML());
}
catch (ClassNotFoundException e) {
	out.println("Couldn't load database driver: " + e.getMessage());
}
catch (SQLException e) {
	out.println(e.getMessage());
}
}

}

   
   
   
  
