drop package MAILS3;
/
create or replace package MAILS3 is

  mailbox_name constant varchar2(50) := MAILS.mailbox_name;
  mailbox_path constant varchar2(50) := MAILS.mailbox_path;
  mailbox_logo constant varchar2(50) := MAILS.mailbox_logo;
  inbox_path constant varchar2(50) := MAILS.inbox_path;
  inbox_logo constant varchar2(50) := MAILS.inbox_logo;
  owner_uid constant varchar2(10) := MAILS.owner_uid;
  cgi_bin1 constant varchar2(30) := MAILS.cgi_bin1;
  cgi_bin constant varchar2(30) := MAILS.cgi_bin;
  owner_name constant varchar2(20) := MAILS.owner_name;
  username constant varchar2(10) := owner_uid;
  password constant varchar2(20) := owner_uid;
  maxmsg constant number(8) := MAILS.maxmsg;
  my_url  constant varchar2(50) := MAILS.my_url;
  sysdate_est date;

  procedure index_chat(host varchar2,browser varchar2,name varchar2);
  procedure chat_home(email varchar2,host varchar2,cname varchar2,uid 
	varchar2,subject varchar2,cbody varchar2);
  procedure index_chat1(email varchar2,host varchar2,name varchar2,
	uid varchar2,subject varchar2,body varchar2);
  end;
/
show errors;
/
create or replace package body MAILS3 is

total_visitors number(7);
h_id header.id%TYPE;
h_msg_date header.msg_date%TYPE;
h_subject header.subject%TYPE;
h_sender header.sender%TYPE;
h_bytes header.bytes%TYPE;
h_name people.email%TYPE;
h_email people.email%TYPE;
fpath folder.path%TYPE := 'Feedback';

procedure index_chat(host varchar2,browser varchar2,name varchar2) is
fname folder.name%TYPE;
fid folder.id%TYPE;
cursor cfolder(f_path varchar2) is select id,name from folder where f_path=path;
begin
	htp.p(htf.line);
	htp.p('Your feedback is very important to us !<br>');
	htp.p('Please write any comment, suggestions, ideas of using, improving');
	htp.p(' this archive service, or whatever information you''d like to share ');
	htp.p(' with us and all the other users of this service. Please note that your');
	htp.p(' feedback here will be stored in the database in the form of email and will');
	htp.p(' be viewed by all the users, exactly like mails in a newsgroup. We are using');
	htp.p(' the same system capability to build '||htf.bold('Chat Board')||' of the');
	htp.p(' feedback information. Thanks.');
	htp.p(htf.line);
	open cfolder(fpath);
	fetch cfolder into fid,fname;
	if (cfolder%FOUND) then
		htp.p('You can find all the '||htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||
			'&op=1&hit=20','feedback information')||' of yours and others under a folder '||
			htf.url(cgi_bin||'MAILS.folderinfo?fid='||fid,htf.bold(fname))||'.');
		htp.p(htf.line);
	end if;
	close cfolder;
	if (name = 'unknown') then
		h_name := NULL;
	else
		h_name := name;
	end if;
	
	htp.formOpen(cgi_bin||'MAILS3.chat_home');
	htp.p('<pre>');
	htp.p('Your Email Address: <input name="email" size="40" value="'||h_name||'@'||host||'">');
	htp.p('<p>         Your Name: <input name="cname" size="40" value="'||h_name||'">');
	htp.p('<input name="host" type="hidden" value="'||host||'">');
	htp.p('<input name="uid" type="hidden" value="'||h_name||'">');
	htp.p('<br>           Subject: <input name="subject" size="40" value="">');
	htp.p(htf.line);
	htp.p('Your comment about this archive: (use two quotes '''' for a single quote '')');
	htp.p('</pre>');
	htp.p('<p><TEXTAREA cols=60 rows=10 name="cbody"></TEXTAREA>');
	htp.p(htf.para||htf.formDo('Submit Your Comment')||' '||htf.formUndo);
	htp.p(htf.formClose);
	wow.sig;	
end;

procedure chat_home(email varchar2,host varchar2,cname varchar2,uid varchar2,
	subject varchar2,cbody varchar2) is
myuid people.userid%TYPE;
myemail people.email%TYPE;
myname people.name%TYPE;
cursor cdomain(do varchar2) is select code from domain where code=do;
dom varchar2(20);
dom_host varchar2(20);
fname folder.name%TYPE := 'Feedback (Chat-board)';
f_name folder.name%TYPE;
fid folder.id%TYPE;
cursor cfolder(f_path varchar2) is select id,name,max_msgid from folder where f_path=path;
maxid header.id%TYPE;
n number(4);
i number(6);
k integer;
tmp varchar2(2000);
now date;
mybody varchar2(32000);
myid header.id%TYPE;

begin
	
	myemail := replace(email,' ','');
	if ((myemail IS NULL) or (instr(myemail,'@',1) = 0) or (instr(myemail,'.',1) = 0)) then
		htp.p(htf.line);
		htp.p('<i>Your email address '||htf.bold(email)||' is incorrect. Please re-enter it.</i>');
		index_chat1(email,host,cname,uid,subject,cbody);
		return;
	else
		dom := UPPER(substr(myemail,instr(myemail,'.',-1)+1));
		dom_host := UPPER(substr(host,instr(host,'.',-1)+1));
		if (ascii(substr(dom,1,1)) between 65 and 90) then
			open cdomain(dom);			
			fetch cdomain into dom;
			if (cdomain%NOTFOUND or ((ascii(substr(dom_host,1,1)) 
				between 65 and 90) and (dom_host != dom))) then
				close cdomain;
				htp.p(htf.line);
				htp.p('<i>Your email address '||htf.bold(email)||' is incorrect. Please re-enter it.</i>');
				index_chat1(email,host,cname,uid,subject,cbody);
				return;
			end if;
			close cdomain;
		else
			if ((ascii(substr(dom_host,1,1)) 
				not between 65 and 90) and (dom_host != dom)) then
				htp.p('<i>Your email address '||htf.bold(email)||
					' is incorrect. Please re-enter it.</i>');
				index_chat1(email,host,cname,uid,subject,cbody);
				return;
			end if;	
		end if;	
	end if;
	if (replace(uid,' ','') is null) then
		myuid := substr(myemail,1,instr(myemail,'@',1)-1);
	else
		myuid := uid;
	end if;
	
	if (replace(cname,' ','') is null) then
		myname := myuid;
	else
		myname := cname;
	end if;

	n := length(cbody);
	myemail := myemail||'['||host||']';
	open cfolder(fpath);
	fetch cfolder into fid,f_name,maxid;
	if (cfolder%FOUND) then
		myid := maxid + (fid-1)*maxmsg;
		select subject,sender,bytes into h_subject,h_sender,h_bytes
			from header where id=myid;
		if ((h_subject=subject) and (h_sender=myemail) and (h_bytes=n)) then
			close cfolder;
			htp.p('You''ve already submitted the same comment. Please check '||
				htf.url(cgi_bin1||'showbody?bid='||myid||'&word=~1','your previous comment')
				||' to avoid duplication. Thanks.');
			wow.sig;
			return;
		end if;
		maxid := maxid + 1;
		fname := f_name;
	else
		maxid := 1;
	end if; 
	close cfolder;
	now := sysdate;
	MAILS.insert_header(maxid,to_char(now,'dd mon yyyy hh24:mi'),subject,myemail,fname,
		maxid,n,'text/plain',fpath,NULL,'EST',NULL,myuid,myname,myemail);
	MAILS.insert_body(maxid,'text/plain',0,0,0,fpath);

	if (maxid = 1) then
		select id into fid from folder where path=fpath;
		update folder set name=name||' (Chat-Board)' where path=fpath;
		commit;
	end if;

	myid := maxid + (fid-1)*maxmsg;
	i := 1;
	k := 1;
	while (i <= n and k <= 10) loop
		tmp := substr(cbody,i,2000);
		if (k = 1) then
			update body set msg_body1=tmp where id = myid;
		elsif (k = 2) then
			update body set msg_body2=tmp where id = myid;
		elsif (k = 3) then
			update body set msg_body3=tmp where id = myid;
		elsif (k = 4) then
			update body set msg_body4=tmp where id = myid;
		elsif (k = 5) then
			update body set msg_body5=tmp where id = myid;
		elsif (k = 6) then
			update body set msg_body6=tmp where id = myid;
		elsif (k = 7) then
			update body set msg_body7=tmp where id = myid;
		elsif (k = 8) then
			update body set msg_body8=tmp where id = myid;
		elsif (k = 9) then
			update body set msg_body9=tmp where id = myid;
		elsif (k = 10) then
			update body set msg_body10=tmp where id = myid;
		end if;
		i := i + 2000;
		k := k + 1;
	end loop;
	if ( i>n and k>10 ) then
		update body set msg_body11=(substr(cbody,i)) where id = myid;
	end if;
	commit;
		
	htp.p(htf.line);
	htp.p('Thank you for your comment. Your submission is successful and the message');
	htp.p(' is now in the database and can be viewed/searched in the archive under folder '||
		htf.bold(fname)||', such as '||htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||
		'&op=1&hit=20','Query By Header'));
	htp.p('. Or you may choose any of the query options: <hr>');
	MAILS.button;
	htp.p('<hr>Your final comment is shown as follows:<p>');

	MAILS.showbody(myid,'~1',NULL);
	return;
	htp.p('<pre>');
	htp.p('Folder: '||htf.url(cgi_bin||'MAILS.folderinfo?fid='||fid,fname)||
		'; thread id: '||maxid||'<br>');
	htp.p('   <b>From:</b> '||myemail||' ('||myname||')');
	htp.p('     <b>To:</b> '||fname);	
	htp.p('   <b>Date:</b> '||to_char(now,'Dy, dd Mon yyyy hh:mi:ssam'));
	h_subject := replace(subject,'&','&amp');
	h_subject := replace(subject,'<','&lt');
	h_subject := replace(subject,'>','&gt');
	h_subject := replace(subject,'"','&quot');
	htp.p('<b>Subject</b>'||': <font size="+1">'||h_subject||'</font><hr>');

	--n := length(cbody);
	i := 1;
	while (i <= n) loop
		tmp := substr(cbody,i,254);
		k := instr(tmp,chr(10),-1);
		if (k != 0) then
			htp.p(substr(tmp,1,k-1));
			i := i + k;
		else
			htp.p(tmp);
			i := i + 254;
		end if;
	end loop;		
	htp.p('</pre>');
	wow.sig;
end;

procedure index_chat1(email varchar2,host varchar2,name varchar2,
	uid varchar2,subject varchar2,body varchar2) is
n number(4);
i integer;
k integer;
tmp varchar2(256);
fname folder.name%TYPE;
fid folder.id%TYPE;
cursor cfolder(f_path varchar2) is select id,name from folder where f_path=path;
begin
	htp.p(htf.line);
	htp.p('Your feedback is very important to us !<br>');
	htp.p('Please write any comment, suggestions, ideas of using, improving');
	htp.p(' this archive service, or whatever information you''d like to share ');
	htp.p(' with us and all the other users of this service. Please note that your');
	htp.p(' feedback here will be stored in the database in the form of email and will');
	htp.p(' be viewed by all the users, exactly like mails in a newsgroup. We are using');
	htp.p(' the same system capability to build '||htf.bold('Chat Board')||' of the');
	htp.p(' feedback information. Thanks.');
	htp.p(htf.line);
	open cfolder(fpath);
	fetch cfolder into fid,fname;
	if (cfolder%FOUND) then
		htp.p('You can find all the '||htf.url(cgi_bin||'MAILS2.listheader?fid='||fid||
			'&op=1&hit=20','feedback information')||' of yours and others under a folder '||
			htf.url(cgi_bin||'MAILS.folderinfo?fid='||fid,htf.bold(fname))||'.');
		htp.p(htf.line);
	end if;
	close cfolder;
	htp.formOpen(cgi_bin||'MAILS3.chat_home');
	htp.p('<pre>');
	htp.p('Your Email Address: <input name="email" size="40" value="'||email||'">');
	htp.p('<p>         Your Name: <input name="cname" size="40" value="'||name||'">');
	htp.p('<input name="host" type="hidden" value="'||host||'">');
	htp.p('<input name="uid" type="hidden" value="'||uid||'">');
	htp.p('<br>           Subject: <input name="subject" size="40" value="'||subject||'">');
	htp.p(htf.line);
	htp.p('Your comment about this archive: (use two quotes '''' for a single quote '')');
	htp.p('</pre>');

	htp.p('<p><TEXTAREA cols=60 rows=10 name="cbody">');
	n := length(body);
	i := 1;
	while (i <= n) loop
		tmp := substr(body,i,254);
		k := instr(tmp,chr(10),-1);
		if (k != 0) then
			htp.p(substr(tmp,1,k-1));
			i := i + k;
		else
			htp.p(tmp);
			i := i + 254;
		end if;
	end loop;		
	htp.p('</TEXTAREA>');
	htp.p(htf.para||htf.formDo('Submit Your Comment')||' '||htf.formUndo);
	htp.p(htf.formClose);
	wow.sig;		
end;

end MAILS3;
/
show errors;
/
