include env_precomp.mk

.SUFFIXES: .pc .c .o

LDSTRING=
PRODUCT_LIBHOME=
MAKEFILE=proc.mk
PROCPLSFLAGS= sqlcheck=semantics userid=$(USERID) dbms=v6_char 
PROCPPFLAGS= code=cpp include=/usr/include include=/opt/SUNWspro/SC3.0.1/include/CC
USERID=grid1/grid1
INCLUDE=$(I_SYM). $(PRECOMPPUBLIC)

PROCFLAGS = sqlcheck=semantics userid=$(USERID)


CPPSAMPLES=

# Rule to compile any program (specify EXE= and OBJS= on command line)

build: $(OBJS)
	$(CC) -o $(EXE) $(OBJS) config.o -L$(LIBHOME) $(PROLDLIBS)

cppbuild:
	$(PROC) $(PROCPPFLAGS) iname=$(EXE)
	CC -c $(INCLUDE) $(EXE).c
	CC -o $(EXE) $(OBJS) -L$(LIBHOME) $(PROLDLIBS)

all: update;
cppsamples: $(CPPSAMPLES)

update: update.o 
	$(MAKE) -f $(MAKEFILE) build OBJS=$@.o EXE=$@ 


$(CPPSAMPLES):
	$(MAKE) -f $(MAKEFILE) cppbuild OBJS=$@.o EXE=$@


.pc.c:
	$(PROC) $(PROCFLAGS)  iname=$*.pc

.pc.o:
	$(PROC) $(PROCFLAGS)  iname=$*.pc
	$(CC) $(CFLAGS) -c $*.c

.c.o:
	$(CC) $(CFLAGS) -c $*.c

update.o : update.pc
	$(PROC) mode=ansi varchar=yes dbms=v6_char sqlcheck=semantics \
		ireclen=132 oreclen=132 select_error=no userid=$(USERID) iname=$*.pc
	$(CC) $(CFLAGS) $(PRECOMPPUBLIC) -c $*.c 


