
/* Result Sets Interface */
#ifndef SQL_CRSR
#  define SQL_CRSR
  struct sql_cursor
  {
    unsigned int curocn;
    void *ptr1;
    void *ptr2;
    unsigned long magic;
  };
  typedef struct sql_cursor sql_cursor;
  typedef struct sql_cursor SQL_CURSOR;
#endif /* SQL_CRSR */

/* Thread Safety */
typedef void * sql_context;
typedef void * SQL_CONTEXT;

/* File name & Package Name */
struct sqlcxp
{
  unsigned short fillen;
           char  filnam[10];
};
static struct sqlcxp sqlfpn =
{
    9,
    "update.pc"
};


static unsigned long sqlctx = 40739;


static struct sqlexd {
   unsigned int   sqlvsn;
   unsigned int   arrsiz;
   unsigned int   iters;
   unsigned int   offset;
   unsigned short selerr;
   unsigned short sqlety;
   unsigned int   unused;
            short *cud;
   unsigned char  *sqlest;
            char  *stmt;
   unsigned char  **sqphsv;
   unsigned int   *sqphsl;
            short **sqpind;
   unsigned int   *sqparm;
   unsigned int   **sqparc;
   unsigned char  *sqhstv[7];
   unsigned int   sqhstl[7];
            short *sqindv[7];
   unsigned int   sqharm[7];
   unsigned int   *sqharc[7];
} sqlstm = {8,7};

/* Prototypes */
extern sqlcxt (/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlcx2t(/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlbuft(/*_ void **, char * _*/);
extern sqlgs2t(/*_ void **, char * _*/);
extern sqlorat(/*_ void **, unsigned long *, void * _*/);

/* Forms Interface */
static int IAPSUCC = 0;
static int IAPFAIL = 1403;
static int IAPFTL  = 535;
extern sqliem(/*_ char *, int * _*/);

 static char *sq0001 = 
"select rowid ,host_id ,prot ,host1 ,path ,fid ,time  from search where statu\
s=0 order by fid desc            ";
typedef struct { unsigned short len; unsigned char arr[1]; } VARCHAR;
typedef struct { unsigned short len; unsigned char arr[1]; } varchar;

/* cud (compilation unit data) array */
static short sqlcud0[] =
{8,4112,
2,0,0,2,0,0,27,300,0,3,3,0,1,0,1,9,0,0,1,10,0,0,1,10,0,0,
28,0,0,1,109,0,9,304,0,0,0,0,1,0,
42,0,0,1,0,0,13,307,0,7,0,0,1,0,2,9,0,0,2,3,0,0,2,9,0,0,2,9,0,0,2,9,0,0,2,3,0,
0,2,1,0,0,
84,0,0,3,43,0,5,319,0,1,1,0,1,0,1,9,0,0,
102,0,0,4,60,0,5,327,0,2,2,0,1,0,1,9,0,0,1,9,0,0,
124,0,0,5,35,0,2,331,0,1,1,0,1,0,1,9,0,0,
142,0,0,1,0,0,15,338,0,0,0,0,1,0,
156,0,0,6,0,0,30,339,0,0,0,0,1,0,
170,0,0,1,0,0,15,350,0,0,0,0,1,0,
184,0,0,7,0,0,30,351,0,0,0,0,1,0,
};


#ifdef RCSID
static char *RCSid='costamcostam';
#endif
#define TXRAPP
#define OK 0
#include <stdio.h>
#include <string.h>
#include <netdb.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <ctype.h>
#include <signal.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ipc.h>
#include <sys/mode.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <sys/stat.h>

/* EXEC SQL INCLUDE sqlca;
 */ 
/*
 * $Header: sqlca.h,v 1.3 1994/12/12 19:27:27 jbasu Exp $ sqlca.h 
 */

/* Copyright (c) 1985,1986 by Oracle Corporation. */
 
/*
NAME
  SQLCA : SQL Communications Area.
FUNCTION
  Contains no code. Oracle fills in the SQLCA with status info
  during the execution of a SQL stmt.
NOTES
  **************************************************************
  ***                                                        ***
  *** This file is SOSD.  Porters must change the data types ***
  *** appropriately on their platform.  See notes/pcport.doc ***
  *** for more information.                                  ***
  ***                                                        ***
  **************************************************************

  If the symbol SQLCA_STORAGE_CLASS is defined, then the SQLCA
  will be defined to have this storage class. For example:
 
    #define SQLCA_STORAGE_CLASS extern
 
  will define the SQLCA as an extern.
 
  If the symbol SQLCA_INIT is defined, then the SQLCA will be
  statically initialized. Although this is not necessary in order
  to use the SQLCA, it is a good pgming practice not to have
  unitialized variables. However, some C compilers/OS's don't
  allow automatic variables to be init'd in this manner. Therefore,
  if you are INCLUDE'ing the SQLCA in a place where it would be
  an automatic AND your C compiler/OS doesn't allow this style
  of initialization, then SQLCA_INIT should be left undefined --
  all others can define SQLCA_INIT if they wish.

  If the symbol SQLCA_NONE is defined, then the SQLCA variable will
  not be defined at all.  The symbol SQLCA_NONE should not be defined
  in source modules that have embedded SQL.  However, source modules
  that have no embedded SQL, but need to manipulate a sqlca struct
  passed in as a parameter, can set the SQLCA_NONE symbol to avoid
  creation of an extraneous sqlca variable.
 
MODIFIED
    jbasu      12/12/94 -  Bug 217878: note this is an SOSD file
    losborne   08/11/92 -  No sqlca var if SQLCA_NONE macro set 
  Clare      12/06/84 - Ch SQLCA to not be an extern.
  Clare      10/21/85 - Add initialization.
  Bradbury   01/05/86 - Only initialize when SQLCA_INIT set
  Clare      06/12/86 - Add SQLCA_STORAGE_CLASS option.
*/
 
#ifndef SQLCA
#define SQLCA 1
 
struct   sqlca
         {
         /* ub1 */ char    sqlcaid[8];
         /* b4  */ long    sqlabc;
         /* b4  */ long    sqlcode;
         struct
           {
           /* ub2 */ unsigned short sqlerrml;
           /* ub1 */ char           sqlerrmc[70];
           } sqlerrm;
         /* ub1 */ char    sqlerrp[8];
         /* b4  */ long    sqlerrd[6];
         /* ub1 */ char    sqlwarn[8];
         /* ub1 */ char    sqlext[8];
         };

#ifndef SQLCA_NONE 
#ifdef   SQLCA_STORAGE_CLASS
SQLCA_STORAGE_CLASS struct sqlca sqlca
#else
         struct sqlca sqlca
#endif
 
#ifdef  SQLCA_INIT
         = {
         {'S', 'Q', 'L', 'C', 'A', ' ', ' ', ' '},
         sizeof(struct sqlca),
         0,
         { 0, {0}},
         {'N', 'O', 'T', ' ', 'S', 'E', 'T', ' '},
         {0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0}
         }
#endif
         ;
#endif
 
#endif
 
/* end SQLCA */


typedef struct head_info
{
  struct date
  {
    int day;
    int mon;
    int year;
  } date,ltime;
  char   encoding[80];
  long   length;
  char	 ctype[80];
  char	 location[255];
  int	 code;
  int   nr_html,nr_refs,nr_imgs,is_form;
  char	title[255],subject[512];
} head_info;

struct sellist
{
  int fdsmask[1];
};
 
int sock;
struct timeval timeout={500,0};
int running=1;
char USR_PWD[80];

int error(str) 
{
   fprintf(stderr,"%s\n",str); 
   if(shutdown(sock,2)!=0) printf("ERROR SHUT SOCKET\n"); 
   if(close(sock)!=0) printf("ERROR CLOSING SOCK\n"); 
   return 1; 
}
   
static char header[4096];
void inthandle(int);

int opensocket(char* host, char* path)
{
  char *tmp, *point, qstring[530];
  int length,port=80, urllen, i , fl;
  struct sockaddr_in server;

  struct hostent *hp;
  struct sellist rsl,wsl,esl;
  int retval, len=0;
	
  if((tmp = strchr(host , ':'))!=NULL)
  {
    *tmp++=0;			/* read port here if given	    */
    port=atoi(tmp);		/* otherwise assume 80		    */
  }

  sock=socket(AF_INET,SOCK_STREAM,PF_NS);	/* create a socket  */
  if (sock<0) error("Couldn't create socket");  
  server.sin_family = AF_INET;

  hp = gethostbyname(host);
  if (hp == NULL) error("Couldn't get hostname");
  bcopy(hp->h_addr, &server.sin_addr, hp->h_length);

  server.sin_port = htons(port);
  if (connect(sock, (struct sockaddr *)&server, sizeof(server))!=0) 
			/* connect to http      */
    error("Couldn't connect");			/* server	        */

  if(sock>4) {
    printf("%d high socket number\n",sock);
    sleep(5);
  }
  if(sock>7) exit(1);
  rsl.fdsmask[0]=0;
  wsl.fdsmask[0]=1<<sock;
  esl.fdsmask[0]=1<<sock;
  
/*  if(select(sock+1,&rsl,&wsl,&esl, &timeout)<=0) */
  if(select(sock+1,(fd_set *)rsl.fdsmask,(fd_set *)wsl.fdsmask,(fd_set *)esl.fdsmask, &timeout)<=0)
    error("Couldn't write to socket");		/* check if can write   */
  if(path[0]=='/')
    sprintf(qstring,
      "HEAD %s HTTP/1.0\r\nAccept: text/html\r\nUser-Agent: NPACagent \r\n\r\n",
      path);                /* make the request     */
  else 
    sprintf(qstring,
	  "HEAD /%s HTTP/1.0\r\nAccept: text/html\r\nUser-Agent: NPACagent \r\n\r\n",
	  path);				/* make the request     */
  if(write(sock,qstring,strlen(qstring))!=strlen(qstring))
    error("Error while writing to socket");     /* write request to sock*/

  /* get document						*/
  strcpy(header,"");

  rsl.fdsmask[0]=1<<sock;
  wsl.fdsmask[0]=0;
  esl.fdsmask[0]=1<<sock;

  do
  {
/*    if(select(sock+1,&rsl,NULL,&esl, &timeout)<=0) */
    if(select(sock+1,(fd_set *)rsl.fdsmask,NULL,(fd_set *)esl.fdsmask, &timeout)<=0)
      error("Can't read from socket");       /* check if ready for read */
    retval=read(sock,qstring,512);
    if(retval<0) error("Error occured when reading from socket");
    if(strlen(header)>4096-512)
	error("Too long header");
    qstring[retval]='\0';
    strcat(header,qstring);
printf("header information=%s\n", header);
    if((point=strstr(header,"\n\n")) || (point=strstr(header,"\r\r")) ||
	 (point=strstr(header,"\r\n\r\n")))
     {
	*point='\0';
	len=retval-(point-header)+2;
	break;
     }
  }
  while(retval!=0);
  if(shutdown(sock,2)!=0) printf("ERROR SHUTDOWN SOCKET \n");
  if(close(sock)!=0) printf("ERROR CLOSING SOCKET \n");   /* closing of a socket and exiting without    */
  return len;    	  /* error code					*/
}


process_header(char* header,head_info* hi)
{
  int   i,head_len=strlen(header);
  char* line;

    
  for(i=0;i<head_len;i++)
    header[i]=tolower(header[i]);
  do
  {
    line=header;
    header=strchr(header,'\n');
    if(header) *header++='\0';

    if(strncmp("http",line,4)==0)
    {
      if((line=strchr(line,' '))==NULL) continue;
      hi->code=atoi(line);
      continue;
    }
    if(strncmp("content-length",line,14)==0)
    {
      if((line=strchr(line,' '))==NULL) continue;
      hi->length=atoi(line);
      continue;
    }
    if(strncmp("content-type",line,9)==0)
    {
      if(line=strchr(line,':')) line++; else continue;
      strcpy(hi->ctype,line);
      continue;
    }
    if(strncmp("location",line,8)==0)
    {
      if (line=strchr(line,':')) line++; else continue;
      while (*line == ' ') line++;
      strcpy(hi->location,line);
      continue;
    }
    if(strncmp("last-modified",line,13)==0)
    {
      char *day,*mon,*year;
      if(line=strchr(line,':')) line++; else continue;
      while((*line<'0' || *line>'9') && *line!=0) line++;
      day=line;
      while(*line>='0' && *line<='9' && *line!=0) line++;
      if(*line !=0) *line++=0;
      while((*line<'a' || *line>'z') && *line!=0) line++;
      mon=line;
      while(*line>='a' && *line<='z' && *line!=0) line++;
      if(*line !=0) *line++=0;
      while((*line<'0' || *line>'9') && *line!=0) line++;
      year=line;
      while(*line>='0' && *line<='9' && *line!=0) line++;
      if(*line !=0) *line++=0;
      hi->date.day=atoi(day);
      hi->date.mon=mon_num(mon);
      hi->date.year=atoi(year);
      if(hi->date.year<1900) hi->date.year+=1900;
    }
  }
  while(header);
}

int equal(char* oldtime, struct date newtime) 
{
   char *tmp1, tmp2[5], tmp[]="19";
   int i, dd;

printf("newtime=%d-%d-%d\n",newtime.day,newtime.mon,newtime.year);
   tmp1 = oldtime;
   strncpy(tmp2,tmp1,2);
   tmp2[2] = '\0';
printf("oldday=%s   ",tmp2);
   dd = atoi(tmp2);
   if (dd != newtime.day) return 1;	
   if (tmp1 = strchr(tmp1,'-')) tmp1++;
   strncpy(tmp2,tmp1,3);
   tmp2[3] = '\0';
printf("oldmon=%s   ",tmp2);
   dd = mon_num(tmp2);
printf("dd=%d\n",dd);
   if (dd != newtime.mon) return 1;
   if (tmp1 = strchr(tmp1,'-')) tmp1++;
   strncpy(tmp2,tmp1,2);
   tmp2[2] = '\0';
printf("oldyear=%s    ",tmp2);
   strcat(tmp,tmp2);
printf("oldyear=%s\n",tmp);
   dd = atoi(tmp);
   if ( dd != newtime.year) return 1;
   return 0;
}

   
int update(char* up_time,char* re_host,char* re_path) 
{
char* re_url;
char* tmp_url;
head_info hi={{0,0,0},{0,0,0},"",0,"","",0,0,0,0,0,"",""};

process_header(header, &hi);
if (hi.code==200)
	if (equal(up_time, hi.date) == 0)
		return 0;
	else
		return 1;
else
 if (hi.code==301 || hi.code==302) {
	if(re_url=strchr(hi.location,':')) re_url= re_url + 3;
        if(tmp_url=strchr(re_url,'/')) { 
	strcpy(re_path,tmp_url);
        tmp_url = '\0';
      }
      else 
	re_path[0] = '\0';
      strcpy(re_host,re_url);
      return 2;
 }
return 0;	
}

main()
{

char re_host[80];
char re_path[255];
int ret_val;

/* EXEC SQL BEGIN DECLARE SECTION; */ 

    /* VARCHAR user_pwd[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } user_pwd;

    /* VARCHAR hostname[60]; */ 
struct { unsigned short len; unsigned char arr[60]; } hostname;

    /* VARCHAR pathname[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } pathname;

    /* VARCHAR protname[10]; */ 
struct { unsigned short len; unsigned char arr[10]; } protname;

    /* VARCHAR row_id[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } row_id;

    long h_id;
    long f_id;
    char up_time[10];
/* EXEC SQL END DECLARE SECTION; */ 


/* EXEC SQL DECLARE searchcur CURSOR FOR
	SELECT rowid, host_id, prot, host1, path, fid, time
	FROM search
	WHERE status=0
	ORDER BY fid desc; */ 


get_config_value("userid/passwd",USR_PWD);
USR_PWD[strlen(USR_PWD)-1] = '\0';
user_pwd.len=sprintf((char *)user_pwd.arr,"%s",USR_PWD);
/* EXEC SQL CONNECT :user_pwd; */ 

{
struct sqlexd sqlstm;

sqlstm.sqlvsn = 8;
sqlstm.arrsiz = 3;
sqlstm.iters = (unsigned int  )10;
sqlstm.offset = (unsigned int  )2;
sqlstm.cud = sqlcud0;
sqlstm.sqlest = (unsigned char  *)&sqlca;
sqlstm.sqlety = (unsigned short)0;
sqlstm.sqhstv[0] = (unsigned char  *)&user_pwd;
sqlstm.sqhstl[0] = (unsigned int  )257;
sqlstm.sqindv[0] = (         short *)0;
sqlstm.sqharm[0] = (unsigned int  )0;
sqlstm.sqphsv = sqlstm.sqhstv;
sqlstm.sqphsl = sqlstm.sqhstl;
sqlstm.sqpind = sqlstm.sqindv;
sqlstm.sqparm = sqlstm.sqharm;
sqlstm.sqparc = sqlstm.sqharc;
sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  
printf("usrpwd=%s   len=%d\n", user_pwd.arr,user_pwd.len);
signal(SIGINT,&inthandle);
/* EXEC SQL OPEN searchcur; */ 

{
struct sqlexd sqlstm;

sqlstm.sqlvsn = 8;
sqlstm.arrsiz = 3;
sqlstm.stmt = sq0001;
sqlstm.iters = (unsigned int  )1;
sqlstm.offset = (unsigned int  )28;
sqlstm.cud = sqlcud0;
sqlstm.sqlest = (unsigned char  *)&sqlca;
sqlstm.sqlety = (unsigned short)0;
sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


while(running) {
	/* EXEC SQL WHENEVER NOTFOUND GOTO notfound; */ 

	/* EXEC SQL FETCH searchcur
	INTO :row_id,:h_id,:protname,:hostname,:pathname,:f_id,:up_time; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )42;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&row_id;
 sqlstm.sqhstl[0] = (unsigned int  )257;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&h_id;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&protname;
 sqlstm.sqhstl[2] = (unsigned int  )12;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqhstv[3] = (unsigned char  *)&hostname;
 sqlstm.sqhstl[3] = (unsigned int  )62;
 sqlstm.sqindv[3] = (         short *)0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqhstv[4] = (unsigned char  *)&pathname;
 sqlstm.sqhstl[4] = (unsigned int  )257;
 sqlstm.sqindv[4] = (         short *)0;
 sqlstm.sqharm[4] = (unsigned int  )0;
 sqlstm.sqhstv[5] = (unsigned char  *)&f_id;
 sqlstm.sqhstl[5] = (unsigned int  )4;
 sqlstm.sqindv[5] = (         short *)0;
 sqlstm.sqharm[5] = (unsigned int  )0;
 sqlstm.sqhstv[6] = (unsigned char  *)up_time;
 sqlstm.sqhstl[6] = (unsigned int  )10;
 sqlstm.sqindv[6] = (         short *)0;
 sqlstm.sqharm[6] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode == 100) goto notfound;
}


	pathname.arr[pathname.len] = '\0';
	hostname.arr[hostname.len] = '\0';
	printf("host=%s    path=%s\n",hostname.arr,pathname.arr);
	opensocket((char *)hostname.arr, (char *)pathname.arr);
	ret_val = update(up_time,re_host,re_path);
	while(ret_val==2) {
		opensocket(re_host,re_path);
		ret_val=update(up_time,re_host,re_path);
	}
	if ( ret_val == 0) {
		/* EXEC SQL UPDATE search set status=1
			WHERE (rowid = :row_id); */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update search  set status=1 where rowid=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )84;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&row_id;
  sqlstm.sqhstl[0] = (unsigned int  )257;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 100) goto notfound;
}


	/*	EXEC SQL COMMIT;*/
		continue;
	}		
/*	EXEC SQL INSERT INTO 
search_urls(host_id,prot,host,path,oldpath,flag,priority,depth,fid)
	   VALUES (:h_id,:protname,:hostname,:pathname,'','0',50,0,0);*/
	/* EXEC SQL UPDATE search_urls set flag=0
		WHERE host = :hostname
		AND   path = :pathname; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "update search_urls  set flag=0 where (host=:b0 and path=:b1)";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )102;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&hostname;
 sqlstm.sqhstl[0] = (unsigned int  )62;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&pathname;
 sqlstm.sqhstl[1] = (unsigned int  )257;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode == 100) goto notfound;
}



	/* EXEC SQL DELETE FROM search 
		WHERE (rowid = :row_id); */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from search  where rowid=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )124;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&row_id;
 sqlstm.sqhstl[0] = (unsigned int  )257;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode == 100) goto notfound;
}


	printf("Delete:\n");
	printf("oldtime=%s   path=%s\n", up_time,pathname.arr);
/*	EXEC SQL COMMIT;*/
}
notfound:
/* EXEC SQL CLOSE searchcur; */ 

{
struct sqlexd sqlstm;

sqlstm.sqlvsn = 8;
sqlstm.arrsiz = 7;
sqlstm.iters = (unsigned int  )1;
sqlstm.offset = (unsigned int  )142;
sqlstm.cud = sqlcud0;
sqlstm.sqlest = (unsigned char  *)&sqlca;
sqlstm.sqlety = (unsigned short)0;
sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


/* EXEC SQL COMMIT WORK RELEASE; */ 

{
struct sqlexd sqlstm;

sqlstm.sqlvsn = 8;
sqlstm.arrsiz = 7;
sqlstm.iters = (unsigned int  )1;
sqlstm.offset = (unsigned int  )156;
sqlstm.cud = sqlcud0;
sqlstm.sqlest = (unsigned char  *)&sqlca;
sqlstm.sqlety = (unsigned short)0;
sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


printf("running=%d\n",running);
}

void inthandle(int x)
{
if (running=1)
	running=0;
else
{
printf("shutdown!\n");
/* EXEC SQL CLOSE searchcur; */ 

{
struct sqlexd sqlstm;

sqlstm.sqlvsn = 8;
sqlstm.arrsiz = 7;
sqlstm.iters = (unsigned int  )1;
sqlstm.offset = (unsigned int  )170;
sqlstm.cud = sqlcud0;
sqlstm.sqlest = (unsigned char  *)&sqlca;
sqlstm.sqlety = (unsigned short)0;
sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


/* EXEC SQL COMMIT WORK RELEASE; */ 

{
struct sqlexd sqlstm;

sqlstm.sqlvsn = 8;
sqlstm.arrsiz = 7;
sqlstm.iters = (unsigned int  )1;
sqlstm.offset = (unsigned int  )184;
sqlstm.cud = sqlcud0;
sqlstm.sqlest = (unsigned char  *)&sqlca;
sqlstm.sqlety = (unsigned short)0;
sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


printf("running=%d\n",running);
exit(0);
}
signal(SIGINT,&inthandle);
}

int mon_num(char* str)
{
  if(strcmp(str,"jan")==0 || strcmp(str,"JAN")==0) return 1;
  if(strcmp(str,"feb")==0 || strcmp(str,"FEB")==0) return 2;
  if(strcmp(str,"mar")==0 || strcmp(str,"MAR")==0) return 3;
  if(strcmp(str,"apr")==0 || strcmp(str,"APR")==0) return 4;
  if(strcmp(str,"may")==0 || strcmp(str,"MAY")==0) return 5;
  if(strcmp(str,"jun")==0 || strcmp(str,"JUN")==0) return 6;
  if(strcmp(str,"jul")==0 || strcmp(str,"JUL")==0) return 7;
  if(strcmp(str,"aug")==0 || strcmp(str,"AUG")==0) return 8;
  if(strcmp(str,"sep")==0 || strcmp(str,"SEP")==0) return 9;
  if(strcmp(str,"oct")==0 || strcmp(str,"OCT")==0) return 10;
  if(strcmp(str,"nov")==0 || strcmp(str,"NOV")==0) return 11;
  if(strcmp(str,"dec")==0 || strcmp(str,"DEC")==0) return 12;
  return 0;
}
