
/* Result Sets Interface */
#ifndef SQL_CRSR
#  define SQL_CRSR
  struct sql_cursor
  {
    unsigned int curocn;
    void *ptr1;
    void *ptr2;
    unsigned long magic;
  };
  typedef struct sql_cursor sql_cursor;
  typedef struct sql_cursor SQL_CURSOR;
#endif /* SQL_CRSR */

/* Thread Safety */
typedef void * sql_context;
typedef void * SQL_CONTEXT;

/* File name & Package Name */
struct sqlcxp
{
  unsigned short fillen;
           char  filnam[7];
};
static struct sqlcxp sqlfpn =
{
    6,
    "ser.pc"
};


static unsigned long sqlctx = 4827;


static struct sqlexd {
   unsigned int   sqlvsn;
   unsigned int   arrsiz;
   unsigned int   iters;
   unsigned int   offset;
   unsigned short selerr;
   unsigned short sqlety;
   unsigned int   unused;
            short *cud;
   unsigned char  *sqlest;
            char  *stmt;
   unsigned char  **sqphsv;
   unsigned int   *sqphsl;
            short **sqpind;
   unsigned int   *sqparm;
   unsigned int   **sqparc;
   unsigned char  *sqhstv[7];
   unsigned int   sqhstl[7];
            short *sqindv[7];
   unsigned int   sqharm[7];
   unsigned int   *sqharc[7];
} sqlstm = {8,7};

/* Prototypes */
extern sqlcxt (/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlcx2t(/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlbuft(/*_ void **, char * _*/);
extern sqlgs2t(/*_ void **, char * _*/);
extern sqlorat(/*_ void **, unsigned long *, void * _*/);

/* Forms Interface */
static int IAPSUCC = 0;
static int IAPFAIL = 1403;
static int IAPFTL  = 535;
extern sqliem(/*_ char *, int * _*/);

 static char *sq0002 = 
"select rowid ,host_id ,prot ,host ,path ,depth ,fid  from search_urls where \
flag='0'           ";
typedef struct { unsigned short len; unsigned char arr[1]; } VARCHAR;
typedef struct { unsigned short len; unsigned char arr[1]; } varchar;

/* cud (compilation unit data) array */
static short sqlcud0[] =
{8,4112,
2,0,0,1,37,0,1,107,0,0,0,0,1,0,
16,0,0,3,58,0,4,115,0,1,0,0,1,0,2,3,0,0,
34,0,0,2,95,0,9,120,0,0,0,0,1,0,
48,0,0,2,0,0,13,125,0,7,0,0,1,0,2,9,0,0,2,3,0,0,2,9,0,0,2,9,0,0,2,9,0,0,2,3,0,
0,2,3,0,0,
90,0,0,4,63,0,5,132,0,1,1,0,1,0,1,9,0,0,
108,0,0,2,0,0,15,156,0,0,0,0,1,0,
122,0,0,2,0,0,15,166,0,0,0,0,1,0,
136,0,0,5,0,0,29,189,0,0,0,0,1,0,
150,0,0,6,47,0,5,219,0,0,0,0,1,0,
164,0,0,7,0,0,29,220,0,0,0,0,1,0,
178,0,0,8,37,0,1,267,0,0,0,0,1,0,
192,0,0,9,65,0,5,272,0,2,2,0,1,0,1,3,0,0,1,9,0,0,
214,0,0,10,65,0,5,280,0,2,2,0,1,0,1,3,0,0,1,9,0,0,
236,0,0,11,0,0,29,286,0,0,0,0,1,0,
250,0,0,12,0,0,27,352,0,3,3,0,1,0,1,9,0,0,1,10,0,0,1,10,0,0,
276,0,0,13,37,0,1,354,0,0,0,0,1,0,
290,0,0,14,43,0,5,355,0,0,0,0,1,0,
304,0,0,15,0,0,29,356,0,0,0,0,1,0,
318,0,0,16,37,0,1,405,0,0,0,0,1,0,
332,0,0,17,62,0,5,411,0,2,2,0,1,0,1,9,0,0,1,9,0,0,
354,0,0,18,62,0,5,419,0,2,2,0,1,0,1,9,0,0,1,9,0,0,
376,0,0,19,0,0,30,434,0,0,0,0,1,0,
};


#ifdef RCSID
static char *RCSid='costamcostam';
#endif
#define TXRAPP
#define OK 0
#include <stdio.h>
#include <string.h>
#include <netdb.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <ctype.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/mode.h>
#include <sys/msg.h>
#include <sys/sem.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>

#include <sys/stat.h>
#define USR_PWD "search/search"

#define URL 2
#define NEXT 3
/*char filename[] = "/export/project/kyk22/ora_tmp/tmp/urls.tmp";*/
char filename[] = "/oracle/usr/search/load/tmp2/urls.tmp";
/*char command[] = "rtload.sh >> /export/project/kyk22/ora_tmp/tmp/aixterm.log";*/
char command[] = "ctxload.sh >> /oracle/usr/search/load/tmp2/aixterm.log";

/* EXEC SQL INCLUDE sqlca;
 */ 
/*
 * $Header: sqlca.h,v 1.3 1994/12/12 19:27:27 jbasu Exp $ sqlca.h 
 */

/* Copyright (c) 1985,1986 by Oracle Corporation. */
 
/*
NAME
  SQLCA : SQL Communications Area.
FUNCTION
  Contains no code. Oracle fills in the SQLCA with status info
  during the execution of a SQL stmt.
NOTES
  **************************************************************
  ***                                                        ***
  *** This file is SOSD.  Porters must change the data types ***
  *** appropriately on their platform.  See notes/pcport.doc ***
  *** for more information.                                  ***
  ***                                                        ***
  **************************************************************

  If the symbol SQLCA_STORAGE_CLASS is defined, then the SQLCA
  will be defined to have this storage class. For example:
 
    #define SQLCA_STORAGE_CLASS extern
 
  will define the SQLCA as an extern.
 
  If the symbol SQLCA_INIT is defined, then the SQLCA will be
  statically initialized. Although this is not necessary in order
  to use the SQLCA, it is a good pgming practice not to have
  unitialized variables. However, some C compilers/OS's don't
  allow automatic variables to be init'd in this manner. Therefore,
  if you are INCLUDE'ing the SQLCA in a place where it would be
  an automatic AND your C compiler/OS doesn't allow this style
  of initialization, then SQLCA_INIT should be left undefined --
  all others can define SQLCA_INIT if they wish.

  If the symbol SQLCA_NONE is defined, then the SQLCA variable will
  not be defined at all.  The symbol SQLCA_NONE should not be defined
  in source modules that have embedded SQL.  However, source modules
  that have no embedded SQL, but need to manipulate a sqlca struct
  passed in as a parameter, can set the SQLCA_NONE symbol to avoid
  creation of an extraneous sqlca variable.
 
MODIFIED
    jbasu      12/12/94 -  Bug 217878: note this is an SOSD file
    losborne   08/11/92 -  No sqlca var if SQLCA_NONE macro set 
  Clare      12/06/84 - Ch SQLCA to not be an extern.
  Clare      10/21/85 - Add initialization.
  Bradbury   01/05/86 - Only initialize when SQLCA_INIT set
  Clare      06/12/86 - Add SQLCA_STORAGE_CLASS option.
*/
 
#ifndef SQLCA
#define SQLCA 1
 
struct   sqlca
         {
         /* ub1 */ char    sqlcaid[8];
         /* b4  */ long    sqlabc;
         /* b4  */ long    sqlcode;
         struct
           {
           /* ub2 */ unsigned short sqlerrml;
           /* ub1 */ char           sqlerrmc[70];
           } sqlerrm;
         /* ub1 */ char    sqlerrp[8];
         /* b4  */ long    sqlerrd[6];
         /* ub1 */ char    sqlwarn[8];
         /* ub1 */ char    sqlext[8];
         };

#ifndef SQLCA_NONE 
#ifdef   SQLCA_STORAGE_CLASS
SQLCA_STORAGE_CLASS struct sqlca sqlca
#else
         struct sqlca sqlca
#endif
 
#ifdef  SQLCA_INIT
         = {
         {'S', 'Q', 'L', 'C', 'A', ' ', ' ', ' '},
         sizeof(struct sqlca),
         0,
         { 0, {0}},
         {'N', 'O', 'T', ' ', 'S', 'E', 'T', ' '},
         {0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0}
         }
#endif
         ;
#endif
 
#endif
 
/* end SQLCA */


/* key used for IPC initialization  */
static long key=989690581l;
static int URL_QUEUE_SIZE=5000;

struct url_str
{
  long  fid;
  long  hid;
  int   depth;
  char  prot[10];
  char  host[60];
  char  path[255];
};

  struct messagebuf
  {
    long msgid;
    long fid;
    long hid_flag;
    long depth;
/*    long host_offset;
    long path_offset;
    char msg[255];*/
	char prot[10];
	char host[60];
	char path[255];
};

/*union semun {
            int val;
            struct semid_ds *buf;
            ushort *array;
          	} arg;*/

int shmid;  /* shared memory identifier */
int msgid, msgida;  /* message queue identifier */
int semid;  /* semaphore identifier     */

void ser_handler();

/*# This procedure sends passed in argument number of url to gathering program
# It also marks these urls as send ( flag 1)
*/

send_addrs(int number)
{
  struct messagebuf  mb={0,0,0,0,"","",""};
  int urlnum, i, j;
  struct msqid_ds arg;

  /* EXEC SQL BEGIN DECLARE SECTION; */ 

/*	VARCHAR hostname[120][255];
	VARCHAR pathname[120][255];
	VARCHAR protname[120][255];
	VARCHAR url_rowid[120][255];
	long h_id[120];
	int depth[120];
	long f_id[120];*/
	/* VARCHAR hostname[60]; */ 
struct { unsigned short len; unsigned char arr[60]; } hostname;

	/* VARCHAR pathname[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } pathname;

	/* VARCHAR protname[10]; */ 
struct { unsigned short len; unsigned char arr[10]; } protname;

	/* VARCHAR url_rowid[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } url_rowid;

	long h_id;
	int depth;
	long f_id;
	int total;
  /* EXEC SQL END DECLARE SECTION; */ 


  /* EXEC SQL LOCK TABLE search_urls IN SHARE MODE; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 0;
  sqlstm.stmt = "lock table search_urls in share mode ";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )2;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  /* EXEC SQL DECLARE initurl CURSOR FOR 
           SELECT rowid, host_id, prot, host, path, depth, fid 
 		   FROM search_urls 
		   WHERE flag='0'; */ 

/*		   ORDER BY PRIORITY DESC;*/
  printf("send_addr\n");
  while(1) {
	/* EXEC SQL SELECT count(*) INTO :total FROM search_urls
			 WHERE flag='0'; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 1;
 sqlstm.stmt = "select count(*)  into :b0  from search_urls where flag='0'";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )16;
 sqlstm.selerr = (unsigned short)0;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&total;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	if ( total > number )  
		total=number;
/*    EXEC SQL WHENEVER NOTFOUND GOTO notfound;*/
    /* EXEC SQL OPEN initurl; */ 

{
    struct sqlexd sqlstm;

    sqlstm.sqlvsn = 8;
    sqlstm.arrsiz = 1;
    sqlstm.stmt = sq0002;
    sqlstm.iters = (unsigned int  )1;
    sqlstm.offset = (unsigned int  )34;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char  *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


/*	for (i=0; i<total; i++) 
*/
	{
/*    EXEC SQL WHENEVER NOTFOUND GOTO notfound;*/
	  /* EXEC SQL FETCH initurl
/o		INTO :url_rowid[i], :h_id[i], :protname[i], :hostname[i], 
		:pathname[i], :depth[i], :f_id[i];
		printf("host = %s h_id = %d\n", hostname[i].arr,h_id[i]);o/
		INTO :url_rowid, :h_id, :protname, :hostname, 
		:pathname, :depth, :f_id; */ 

{
   struct sqlexd sqlstm;

   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 7;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )48;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&url_rowid;
   sqlstm.sqhstl[0] = (unsigned int  )257;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&h_id;
   sqlstm.sqhstl[1] = (unsigned int  )4;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqhstv[2] = (unsigned char  *)&protname;
   sqlstm.sqhstl[2] = (unsigned int  )12;
   sqlstm.sqindv[2] = (         short *)0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqhstv[3] = (unsigned char  *)&hostname;
   sqlstm.sqhstl[3] = (unsigned int  )62;
   sqlstm.sqindv[3] = (         short *)0;
   sqlstm.sqharm[3] = (unsigned int  )0;
   sqlstm.sqhstv[4] = (unsigned char  *)&pathname;
   sqlstm.sqhstl[4] = (unsigned int  )257;
   sqlstm.sqindv[4] = (         short *)0;
   sqlstm.sqharm[4] = (unsigned int  )0;
   sqlstm.sqhstv[5] = (unsigned char  *)&depth;
   sqlstm.sqhstl[5] = (unsigned int  )4;
   sqlstm.sqindv[5] = (         short *)0;
   sqlstm.sqharm[5] = (unsigned int  )0;
   sqlstm.sqhstv[6] = (unsigned char  *)&f_id;
   sqlstm.sqhstl[6] = (unsigned int  )4;
   sqlstm.sqindv[6] = (         short *)0;
   sqlstm.sqharm[6] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}



		/* EXEC SQL UPDATE search_urls SET flag='1' WHERE
			rowid = :url_rowid AND flag='0'; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update search_urls  set flag='1' where (rowid=:b0 and flag=\
'0')";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )90;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&url_rowid;
  sqlstm.sqhstl[0] = (unsigned int  )257;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}



      mb.hid_flag = h_id;
      mb.fid = f_id;
      mb.depth = depth;
      mb.msgid = URL;
/*      mb.host_offset = protname.len + 1;
      mb.path_offset = mb.host_offset + hostname.len + 1;
      sprintf(mb.msg, "%s\0%s\0%s",protname.arr,hostname.arr,pathname.arr);
*/
	for (j=0;j<protname.len;j++) mb.prot[j]=protname.arr[j];
	mb.prot[j] = '\0';
	for (j=0;j<hostname.len;j++) mb.host[j]=hostname.arr[j];
	mb.host[j] = '\0';
	for (j=0;j<pathname.len;j++) mb.path[j]=pathname.arr[j];
	mb.path[j] = '\0';
printf("prot = %s host = %s path = %s\n",mb.prot,mb.host,mb.path);
      msgsnd(msgid, &mb, sizeof(mb), 0);

	
/*	if ( url_rowid[i]==0) break;*/
	}
	
	/* EXEC SQL CLOSE initurl; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )108;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	if (i!=0) break;

	{
	  msgctl(msgid, IPC_STAT, &arg);
	  if (arg.msg_qnum != 0) break;
	  sleep(10);
 	}
   notfound:
	printf("fail i= %d\n", i);
 	/* EXEC SQL CLOSE initurl; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )122;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


    /* EXEC SQL WHENEVER NOTFOUND CONTINUE; */ 

 }

	urlnum=i;
	printf("urlnum=%d\n",i);
/*	for (i=0; i<urlnum; i++) 
	{
	  EXEC SQL UPDATE search_urls SET flag='1' 
			   WHERE rowid='url_rowid[i]' AND flag='0';

      mb.hid_flag = h_id[i];
	  mb.fid = f_id[i];
	  mb.depth = depth[i];
	  mb.msgid = URL;
	  mb.host_offset = protname[i].len + 1;
	  mb.path_offset = mb.host_offset + hostname[i].len + 1;
	  sprintf(mb.msg, "%s%s%s",protname[i].arr,hostname[i].arr,pathname[i].arr);
	  msgsnd(msgid, &mb, sizeof(mb), 0);

	}
*/
	printf("ffffffffffffffffffff\n");
	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )136;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	
}

/* # This procedure loads data into TR database. It continues execution
immediatelly,
# but it waits berore running next load for termination of a previous one.
# If rtload is interrupted database is reloaded
# after wait it also checks if it has connection with oracle. If Delete
command cannot
# be executed it logson and tries to repeat oracle operation.
*/

load_to_TR()
{
	struct sembuf sba={0,-1,0},sbb={0,1,0};
	char commd[80];

/*	if(child_pid != 0) {
	  status=0;
	  wait;
      if ((status & 255) != 0) {
		status=0;
		status=system(command);
		print" Return code:tatus\n";
	    }
	  }
	}*/

	semop(semid, &sba, 0);
	/* EXEC SQL UPDATE search_urls SET flag='3' WHERE flag='2'; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "update search_urls  set flag='3' where flag='2'";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )150;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )164;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	sprintf(commd,"mv %s %s.rtd",filename,filename);
	system(commd); 
	semop(semid, &sbb, 0);
	system(command);
}


/*# this is main server of urls procedure. It receives maessages from gathering
# programs and if number of messages in message queue drops below certain
# number it starts sending urls
# It also check and if size of file to which data is loaded exceeds 1 MB it runs
# rtload application to load it to TR
*/

server()
{
	struct msqid_ds arg;
	struct stat info;
    struct messagebuf  mb={0,0,0,0,"","",""};
	struct url_str url;

  /* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* VARCHAR pathname[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } pathname;

	long id;
  /* EXEC SQL END DECLARE SECTION; */ 


	signal(SIGINT, &ser_handler);
	signal(SIGTERM, &ser_handler);
	printf("1234567\n");
	while(1) {
		msgrcv(msgid, &mb, sizeof(mb), NEXT, 0);
	/*	msgrcv(msgid, &mb, 255, NEXT, 0);*/
		printf("message received Okay.\n");
		url.fid = mb.fid;
		url.hid = mb.hid_flag;
		url.depth = mb.depth;
/*		strcpy(url.prot, mb.msg);
		strcpy(url.host, mb.msg+mb.host_offset);
		strcpy(url.path, mb.msg+mb.path_offset);
*/
		strcpy(url.prot, mb.prot);
		strcpy(url.host, mb.host);
		strcpy(url.path, mb.path);
		
		if (strcmp(url.prot,"") != 0)
		{
			/* EXEC SQL LOCK TABLE search_urls IN SHARE MODE; */ 

{
   struct sqlexd sqlstm;

   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 7;
   sqlstm.stmt = "lock table search_urls in share mode ";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )178;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


		if (url.fid == 0)
			{
			id = url.hid;
			pathname.len = sprintf(pathname.arr, "%s", url.path);
			/* EXEC SQL UPDATE search_urls SET flag='2' WHERE host_id=:id AND
path = :pathname; */ 

{
   struct sqlexd sqlstm;

   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 7;
   sqlstm.stmt = "update search_urls  set flag='2' where (host_id=:b0 and pa\
th=:b1)";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )192;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&id;
   sqlstm.sqhstl[0] = (unsigned int  )4;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&pathname;
   sqlstm.sqhstl[1] = (unsigned int  )257;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


			printf("IN*OK: %s://%s%s\n",url.prot,url.host,url.path);
			}
		else
			{
			id = url.hid;
            pathname.len = sprintf(pathname.arr, "%s", url.path);
            /* EXEC SQL UPDATE search_urls SET flag='4' WHERE host_id=:id AND
path = :pathname; */ 

{
            struct sqlexd sqlstm;

            sqlstm.sqlvsn = 8;
            sqlstm.arrsiz = 7;
            sqlstm.stmt = "update search_urls  set flag='4' where (host_id=:\
b0 and path=:b1)";
            sqlstm.iters = (unsigned int  )1;
            sqlstm.offset = (unsigned int  )214;
            sqlstm.cud = sqlcud0;
            sqlstm.sqlest = (unsigned char  *)&sqlca;
            sqlstm.sqlety = (unsigned short)0;
            sqlstm.sqhstv[0] = (unsigned char  *)&id;
            sqlstm.sqhstl[0] = (unsigned int  )4;
            sqlstm.sqindv[0] = (         short *)0;
            sqlstm.sqharm[0] = (unsigned int  )0;
            sqlstm.sqhstv[1] = (unsigned char  *)&pathname;
            sqlstm.sqhstl[1] = (unsigned int  )257;
            sqlstm.sqindv[1] = (         short *)0;
            sqlstm.sqharm[1] = (unsigned int  )0;
            sqlstm.sqphsv = sqlstm.sqhstv;
            sqlstm.sqphsl = sqlstm.sqhstl;
            sqlstm.sqpind = sqlstm.sqindv;
            sqlstm.sqparm = sqlstm.sqharm;
            sqlstm.sqparc = sqlstm.sqharc;
            sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


			printf("IN*ER: %s://%s%s\n",url.prot,url.host,url.path);
			}
		}

		/* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )236;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


		msgctl(msgid, IPC_STAT, &arg);
		printf("222222222222222222222\n");

	if (arg.msg_qnum < 60) send_addrs(120-arg.msg_qnum);
	printf("33333333333333333\n");	
	stat(filename, &info);
	if (info.st_size > 1000000) load_to_TR();
	}
}


main()
{
int ret;
  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    /* VARCHAR user_pwd[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } user_pwd;

  /* EXEC SQL END DECLARE SECTION; */ 



union semun {
            int val;
            struct semid_ds *buf;
            ushort *array;
            } arg;


/* 
  initialization of semaphores and messages
  this module actually does not use msgida but it still opens this message queue
  for use by other modules.
  I just prefered to have all queues opened here
*/

	semid = semget(key,2, IPC_CREAT | S_IRUSR | S_IWUSR);
			/* create the semophore */
    if (semid < 0) {
		printf("can't open semaphore\n");
		exit(1);
	}
	printf("000000000000000000000\n");
	
	arg.val = 1;
    if ((ret=semctl(semid, 0, SETVAL, arg, 00200)) < 0) {
		printf("can't set semaphore. ret = %d\n",ret);
		exit(1);
	}
	printf("000000000000000000000\n");
	arg.val = URL_QUEUE_SIZE;
	if (semctl(semid, 1, SETVAL, arg, 00200) < 0) {
		printf("can't set semaphore2\n");
		exit(1);
	}

	msgid = msgget(key, IPC_CREAT | S_IRUSR | S_IWUSR);
	if (msgid < 0) {
		printf("can't open message queue\n");
		exit(1);
	}
	msgida = msgget(key+1, IPC_CREAT | S_IRUSR | S_IWUSR);
	if (msgida < 0) {
        printf("can't open message queue\n");
        exit(1);
	}

  user_pwd.len=sprintf(user_pwd.arr,"%s",USR_PWD);
  /* EXEC SQL CONNECT :user_pwd; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )10;
  sqlstm.offset = (unsigned int  )250;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&user_pwd;
  sqlstm.sqhstl[0] = (unsigned int  )257;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


printf("111111111111111111\n");
	/* EXEC SQL LOCK TABLE search_urls IN SHARE MODE; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "lock table search_urls in share mode ";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )276;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	/* EXEC SQL UPDATE search_urls SET FLAG=0 WHERE FLAG=1; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "update search_urls  set FLAG=0 where FLAG=1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )290;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )304;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	printf("wwwww000000000000000000000\n");
	server();
}

/*
# this procedure handles interrupts
# it receives all messages that are in queue
# and marks records in urls tables accordingly to returned status
# Then it closes down all message queues and semaphores
# waits for loading process to finish and logsoff from oracle
*/

void ser_handler()
{
  struct messagebuf  mb={0,0,0,0,"","",""};
    struct url_str url;

union semun {
            int val;
            struct semid_ds *buf;
            ushort *array;
                } arg;



  /* EXEC SQL BEGIN DECLARE SECTION; */ 

    /* VARCHAR pathname[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } pathname;

	/* VARCHAR hostname[255]; */ 
struct { unsigned short len; unsigned char arr[255]; } hostname;

  /* EXEC SQL END DECLARE SECTION; */ 



	printf("shutting down\n");
    signal(SIGINT, &ser_handler);
	signal(SIGTERM, &ser_handler);

	while (msgrcv(msgid, &mb, sizeof(mb), NEXT, IPC_NOWAIT))
	{
        url.fid = mb.fid;
        url.hid = mb.hid_flag;
        url.depth = mb.depth;
		strcpy(url.prot, mb.prot);
		strcpy(url.host, mb.host);
		strcpy(url.path, mb.path);
		printf("dead loop prot=%s	\n", url.prot);
		printf("host=%s    path=%s\n",url.host,url.path);

		if (strcmp(mb.host, "")!=0)
		{
			/* EXEC SQL LOCK TABLE search_urls IN SHARE MODE; */ 

{
   struct sqlexd sqlstm;

   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 7;
   sqlstm.stmt = "lock table search_urls in share mode ";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )318;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


			if (url.fid == 0)
			{
			printf("FLAG CHANGED TO 2!\n");
            hostname.len = sprintf(hostname.arr, "%s", url.host);
            pathname.len = sprintf(pathname.arr, "%s", url.path);
			/* EXEC SQL UPDATE search_urls SET flag='2' WHERE 
				host = :hostname AND path = :pathname; */ 

{
   struct sqlexd sqlstm;

   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 7;
   sqlstm.stmt = "update search_urls  set flag='2' where (host=:b0 and path=\
:b1)";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )332;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&hostname;
   sqlstm.sqhstl[0] = (unsigned int  )257;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&pathname;
   sqlstm.sqhstl[1] = (unsigned int  )257;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


			}
			else
			{
			printf("FLAG CHANGED TO 4!\n");
            hostname.len = sprintf(hostname.arr, "%s", url.host);
            pathname.len = sprintf(pathname.arr, "%s", url.path);
			/* EXEC SQL UPDATE search_urls SET flag='4' WHERE
                host = :hostname AND path = :pathname; */ 

{
   struct sqlexd sqlstm;

   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 7;
   sqlstm.stmt = "update search_urls  set flag='4' where (host=:b0 and path=\
:b1)";
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )354;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlstm.sqhstv[0] = (unsigned char  *)&hostname;
   sqlstm.sqhstl[0] = (unsigned int  )257;
   sqlstm.sqindv[0] = (         short *)0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqhstv[1] = (unsigned char  *)&pathname;
   sqlstm.sqhstl[1] = (unsigned int  )257;
   sqlstm.sqindv[1] = (         short *)0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


			}
		}
		else break;

	}
	arg.val = 0;
	semctl(semid, 0, IPC_RMID, arg);
	printf("semaphore closed\n");
	msgctl(msgid, IPC_RMID, 0);
	msgctl(msgida, IPC_RMID, 0);
	printf("message queues closed\n");
/*	wait();*/
	printf("children terminated\n");
	/* EXEC SQL COMMIT WORK RELEASE; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )376;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	exit(0);
}
