drop table docs;
create table docs (m

id varchar2(10) primary key,
title varchar2(100),
author varchar2(100),
doc_format varchar2(20),
doc blob
);

execute ctx_ddl.create_preference('doc_type','INSO_FILTER');
execute ctx_ddl.create_preference('mystore','DIRECT_DATASTORE');
create index docindex on docs(doc) indextype is ctxsys.context
	parameters('datastore mystore filter doc_type');

create index docindex on docs(doc) indextype is ctxsys.context;

create table test_explain (
         explain_id varchar2(30),
         id number,
         parent_id number,
         operation varchar2(30),
         options varchar2(30),
         object_name varchar2(64),
         position number,
         cardinality number);

create table filtertab (query_id  number,   
                        document  clob); 

drop sequence idseq;
create sequence idseq increment by 1 start with 1 maxvalue 50 cycle;



