drop table emp;
create table emp (
id varchar2(10),
first_name varchar2(20),
last_name varchar2(20),
title varchar(50),
phone varchar2(20),
email varchar2(20)
);

drop table classes;
drop type class_type;
drop type student_list_t;
drop type student_type;

CREATE TYPE student_type AS OBJECT (
first_name varchar2(20),
last_name varchar2(20)
);

/

create type student_list_t as table of student_type;

/

create type class_type as object (
num varchar2(10),
title varchar2(50),
dept varchar2(50),
instructor varchar2(20),
student_list student_list_t
);

/

create table classes of class_type (
PRIMARY KEY (num)
)
NESTED TABLE student_list STORE AS student_tab;


 



