/* List all documents in DB with different format, and transfer to HTML using
** ctx_doc.filter procedure
** Class: DocList
** Author: Yuping Zhu
** Date: 08-04-1999
*/

package ioe;

import java.io.*;

// import the JDBC package
import java.sql.*;
import oracle.sql.*;
import oracle.jdbc.driver.*;

// import Servlet package
import javax.servlet.*;
import javax.servlet.http.*;

public class DocList extends HttpServlet {

    public static String myServletPath = null;

    public void doGet(HttpServletRequest req, HttpServletResponse res)
           throws ServletException, IOException
    {
    // set the output content type
    res.setContentType("text/html");
    
    PrintWriter out = res.getWriter();
    
    if (myServletPath == null)
	myServletPath = req.getRequestURI();

    //if ( req.getParameter("op") == null)
	// output the first page
          out.println(searchInterface());
    
    try {
    // Load Oracle JDBC driver
       DriverManager.registerDriver( new oracle.jdbc.driver.OracleDriver());
    // or Class.forName("oracle.jdbc.driver.OracleDriver")

    // Connect to DB
       Connection conn = DriverManager.getConnection("jdbc:oracle:thin:@mira.npac.syr.edu:1521:mira", "ioexml","xml");
    // Create Statement
       Statement stmt = conn.createStatement();
    
       String queryString;
       String myKeyword;

       out.println("Click on documen ID to view document<br><br>\n");
       out.println("<table border=2>");
       out.println("<tr><td>ID</td><td>Title</td><td>Author</td><td>Format</td></tr>");
    
       if (req.getParameter("op") == null) 
	// List all documents
	   queryString = "select id, title, author, doc_format from docs order by id asc";
       else {
	// keyword search
	   myKeyword = req.getParameter("typein");
	   queryString = "select id, title, author, doc_format from docs where contains(doc, '" + myKeyword + "') > 0 order by id asc"; 
       }
    
       ResultSet rset = stmt.executeQuery(queryString);
       
       String newServletPath = myServletPath.substring(0,myServletPath.lastIndexOf(".")+1);
       while (rset.next()) {
	   out.println("<tr><td><a href=\"" + newServletPath + "DocView?id=" + rset.getString(1) + "&fmt="+ rset.getString(4) + "\">" + rset.getString(1) + "</a></td>");
	   out.println("<td>" + rset.getString(2) + "</td>");
	   out.println("<td>" + rset.getString(3) + "</td>");
	   out.println("<td>" + rset.getString(4) + "</td></tr>");
       }
       out.println("</table></HTML>");
    }
    catch (SQLException e) {
	out.println(e.getMessage());
    }
    }    

      
    public static String searchInterface() {
        StringBuffer myStringBuffer = new StringBuffer(1500);
	myStringBuffer.append("<HTML>\n");
	myStringBuffer.append("<TITLE>interMedia Document Manage demo</TITLE>");
	myStringBuffer.append("<BODY bgcolor=\"white\"><CENTER>\n");
	myStringBuffer.append("<FORM ACTION=\""+myServletPath+"\" METHOD=\"GET\">\n");
	myStringBuffer.append("<font color=red size= +3>Use Keyword search formatted document</font><br>\n");
	myStringBuffer.append("<bold>Keyword: </bold>");
	myStringBuffer.append("<INPUT NAME=\"typein\" size=\"30\">\n");
	myStringBuffer.append("<INPUT TYPE= \"hidden\" NAME=\"op\" VALUE=\"1\">");
	myStringBuffer.append("<INPUT TYPE=\"submit\" VALUE=\"GO!\"><br>\n\n");
	myStringBuffer.append("</FORM>");
	String returnString = new String(myStringBuffer);
	return returnString;
    }
}
