/* Retrieve formatted document from DB table with BLOB column
** Class: getDBDoc
** Author: Yuping Zhu
** Date: 07-29-1999
*/

package ioe;

import java.io.*;

// import the packages for JDBC
import java.sql.*;
import oracle.sql.*;
import oracle.jdbc.driver.*;

// import the packages for servlet
import javax.servlet.*;
import javax.servlet.http.*;

// import package oracle.html to generate dynamic HTML page
// import oracle.html.*;

public class getDBDoc extends HttpServlet {

    public static String myServletPath = null;

    public void doGet(HttpServletRequest req, HttpServletResponse res)
           throws ServletException, IOException 
    {
    // set the content type of the response
    res.setContentType("text/html");
    
    if(this.myServletPath == null)
       myServletPath = req.getRequestURI();

    // Create a ServletOutputStream to write the output
    ServletOutputStream l_out = res.getOutputStream();

    if (req.getParameter("op") == null)
 
    // Output the HTML form to let user input
    l_out.print(postForm());


    // get the request from user

     int op = (new Integer(req.getParameter("op"))).intValue();
   
    
        try {
	// Load the Oracle JDBC driver: 
	Class.forName ("oracle.jdbc.driver.OracleDriver");

	// Connect to the database: 
	Connection conn =
	    DriverManager.getConnection ("jdbc:oracle:thin:@mira.npac.syr.edu:1521:mira", "ioexml", "xml");
   
	// Create a Statement: 
	Statement stmt = conn.createStatement ();
    
       	BLOB doc_blob = null;
	ResultSet rset = stmt.executeQuery("select title,doc from docs");
	while(rset.next())
	    {
    		doc_blob = ((OracleResultSet)rset).getBLOB(2);
		l_out.println("Title is : " + rset.getString(1));
		l_out.println("The length of doc is : " + Long.toString(doc_blob.length()));
		l_out.println(doc_blob);
		l_out.println("<br>");
	    }
	stmt.close();
	conn.close();
    }
    catch (SQLException e) {
	l_out.println(e.getMessage());
    }
    catch (ClassNotFoundException e) {
	l_out.println("Can not load the JDBC Driver!");
	}
     }

    
    public static String postForm() {
      	StringBuffer l_stringBuffer = new StringBuffer(1500);
      	l_stringBuffer.append("<HTML>\n");
	l_stringBuffer.append("<TITLE>Get the document length</TITLE>\n");
	l_stringBuffer.append("<BODY bgcolor=\"white\"><Center>");
      	l_stringBuffer.append("<FORM METHOD=\"GET\" ACTION=\""+myServletPath+"\">");
	l_stringBuffer.append("Select display method : ");
	l_stringBuffer.append("<SELECT NAME=\"op\">");
	l_stringBuffer.append("<OPTION VALUE=\"0\"> Metadata only");
	l_stringBuffer.append("<OPTION VALUE=\"1\"> Text only");
	l_stringBuffer.append("<OPTION VALUE=\"2\"> Both");
	l_stringBuffer.append("</SELECT>");
	l_stringBuffer.append("<INPUT TYPE=submit VALUE=\"Go\">");
        l_stringBuffer.append("</FORM>");
	l_stringBuffer.append("</Center>");
//       	l_stringBuffer.append("</HTML>");
	String myReturnString = new String(l_stringBuffer);
	return myReturnString;
    }

}



