/* Retrieve formatted document from DB table with BLOB column
** Class: getDoc
** Author: Yuping Zhu
** Date: 07-29-1999
*/

package ioe;

import java.io.*;

// import the packages for JDBC
import java.sql.*;
import oracle.sql.*;
import oracle.jdbc.driver.*;

// import the packages for servlet
import javax.servlet.*;
import javax.servlet.http.*;

// import package oracle.html to generate dynamic HTML page
// import oracle.html.*;

public class getDoc extends HttpServlet {

    public static String myservletPath = null;

    public void init(ServletConfig config) throws ServletException {
    super.init(config);
  }
    

    public void doGet(HttpServletRequest req, HttpServletResponse res)
           throws ServletException, IOException 
    {
    // set the content type of the response
    res.setContentType("text/html");

    // Create a Writer
    PrintWriter out = res.getWriter();

  // Create a ServletOutputStream to write the output
    ServletOutputStream l_out = res.getOutputStream();

    // Output the HTML form to let user input
    l_out.print(this.postForm());

    // get the request from user
    int op = (new Integer(req.getParameter("op"))).intValue();

    try {
	// Load the Oracle JDBC driver: 
	Class.forName ("oracle.jdbc.driver.OracleDriver");

	// Connect to the database: 
	Connection conn =
	    DriverManager.getConnection ("jdbc:oracle:oci8:@", "ioexml", "xml");
   
	// Create a Statement: 
	Statement stmt = conn.createStatement ();
    
	BLOB doc_blob = null;
	ResultSet rset = stmt.executeQuery("select title,doc from docs");
	while(rset.next())
	    {
    		doc_blob = ((OracleResultSet)rset).getBLOB(2);
		out.println("Title is : " + rset.getString(1));
		out.println("The length of doc is : " + Long.toString(doc_blob.length()));
	    }
	stmt.close();
	conn.close();
    }
    catch (SQLException e) {
	out.println(e.getMessage());
    }
    catch (ClassNotFoundException e) {
	out.println("Can not load the JDBC Driver!");
    }
    }
    
    public static String postForm() {
	StringBuffer l_stringBuffer = new StringBuffer(1500);
	l_stringBuffer.append("<HTML>\n");
	l_stringBuffer.append("<TITLE>Get the document length</TITLE>\n");
	l_stringBuffer.append("<BODY bgcolor=\"white\"><Center>");
	l_stringBuffer.append("<FORM METHOD=\"GET\" ACTION=\"myServletPath\">");
	l_stringBuffer.append("Select display method : ");
	l_stringBuffer.append("<SELECT NAME=\"op\">");
	l_stringBuffer.append("<VALUE=\"0\"> Metadata only");
	l_stringBuffer.append("<VALUE=\"1\"> Text only");
	l_stringBuffer.append("<VALUE=\"2\"> Both");
	l_stringBuffer.append("<INPUT TYPE=submit VLAUE=\"Go\">");
        l_stringBuffer.append("</FORM>");
	l_stringBuffer.append("</Center>");
	l_stringBuffer.append("</HTML>");
	String myReturnString = new String(l_stringBuffer);
	return myReturnString;
    }
}
