/* Retrieve formatted document from DB table with BLOB column
** Class: getDBDoc
** Author: Yuping Zhu
** Date: 07-29-1999
*/

package ioe;

import java.io.*;

// import the packages for JDBC
import java.sql.*;
import oracle.sql.*;
import oracle.jdbc.driver.*;

// import the packages for servlet
import javax.servlet.*;
import javax.servlet.http.*;

// import package oracle.html to generate dynamic HTML page
// import oracle.html.*;

public class testGetDbDoc extends HttpServlet {

    public static String myServletPath = null;

    public void init(ServletConfig config) throws ServletException {
    super.init(config);
  }
    

    public void doGet(HttpServletRequest req, HttpServletResponse res)
           throws ServletException, IOException 
    {
    // set the content type of the response
    res.setContentType("text/html");
    
    if(this.myServletPath == null)
       myServletPath = req.getRequestURI();

    // Create a Writer
    //    PrintWriter out = res.getWriter();

  // Create a ServletOutputStream to write the output
    ServletOutputStream l_out = res.getOutputStream();

    // Output the HTML form to let user input
     l_out.print(this.printMyForm());

      l_out.println("OK"); 

    }
    
    public static String printMyForm() {
	StringBuffer l_stringBuffer = new StringBuffer(1500);
      	l_stringBuffer.append("<HTML>\n");
	l_stringBuffer.append("OK");
	l_stringBuffer.append("</HTML>");
	String myReturnString = new String(l_stringBuffer);
	return myReturnString;
    }


    public String getServletInfo() {
	return "Test servlets by Yuping Zhu";
  }

  public void destroy() {
     super.destroy();
  }
}



