
/* Result Sets Interface */
#ifndef SQL_CRSR
#  define SQL_CRSR
  struct sql_cursor
  {
    unsigned int curocn;
    void *ptr1;
    void *ptr2;
    unsigned long magic;
  };
  typedef struct sql_cursor sql_cursor;
  typedef struct sql_cursor SQL_CURSOR;
#endif /* SQL_CRSR */

/* Thread Safety */
typedef void * sql_context;
typedef void * SQL_CONTEXT;

/* File name & Package Name */
struct sqlcxp
{
  unsigned short fillen;
           char  filnam[11];
};
static struct sqlcxp sqlfpn =
{
    10,
    "loaddoc.pc"
};


static unsigned long sqlctx = 76195;


static struct sqlexd {
   unsigned int   sqlvsn;
   unsigned int   arrsiz;
   unsigned int   iters;
   unsigned int   offset;
   unsigned short selerr;
   unsigned short sqlety;
   unsigned int   unused;
            short *cud;
   unsigned char  *sqlest;
            char  *stmt;
   unsigned char  **sqphsv;
   unsigned int   *sqphsl;
            short **sqpind;
   unsigned int   *sqparm;
   unsigned int   **sqparc;
   unsigned char  *sqhstv[7];
   unsigned int   sqhstl[7];
            short *sqindv[7];
   unsigned int   sqharm[7];
   unsigned int   *sqharc[7];
} sqlstm = {8,7};

/* Prototypes */
extern sqlcxt (/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlcx2t(/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlbuft(/*_ void **, char * _*/);
extern sqlgs2t(/*_ void **, char * _*/);
extern sqlorat(/*_ void **, unsigned long *, void * _*/);

/* Forms Interface */
static int IAPSUCC = 0;
static int IAPFAIL = 1403;
static int IAPFTL  = 535;
extern sqliem(/*_ char *, int * _*/);

 static char *sq0010 = 
"select url  from weburls where  not dir is null            ";
 static char *sq0013 = 
"select url ,dir  from weburls where  not url is null            ";
typedef struct { unsigned short len; unsigned char arr[1]; } VARCHAR;
typedef struct { unsigned short len; unsigned char arr[1]; } varchar;

/* cud (compilation unit data) array */
static short sqlcud0[] =
{8,4112,
2,0,0,1,0,0,27,118,0,3,3,0,1,0,1,1,0,0,1,1,0,0,1,10,0,0,
28,0,0,2,30,0,2,122,0,1,1,0,1,0,1,3,0,0,
46,0,0,3,0,0,29,123,0,0,0,0,1,0,
60,0,0,4,115,0,5,130,0,7,7,0,1,0,1,1,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,1,0,
0,1,3,0,0,
102,0,0,5,0,0,29,140,0,0,0,0,1,0,
116,0,0,6,50,0,4,154,0,2,1,0,1,0,2,3,0,0,1,3,0,0,
138,0,0,7,31,0,2,156,0,1,1,0,1,0,1,3,0,0,
156,0,0,8,0,0,29,157,0,0,0,0,1,0,
170,0,0,9,0,0,29,164,0,0,0,0,1,0,
184,0,0,10,59,0,9,460,0,0,0,0,1,0,
198,0,0,11,40,0,4,463,0,1,0,0,1,0,2,3,0,0,
216,0,0,10,0,0,13,466,0,1,0,0,1,0,2,9,0,0,
234,0,0,12,47,0,4,470,0,2,1,0,1,0,2,9,0,0,1,9,0,0,
256,0,0,13,64,0,9,571,0,0,0,0,1,0,
270,0,0,14,40,0,4,572,0,1,0,0,1,0,2,3,0,0,
288,0,0,13,0,0,13,576,0,2,0,0,1,0,2,9,0,0,2,9,0,0,
310,0,0,13,0,0,15,607,0,0,0,0,1,0,
324,0,0,15,51,0,4,629,0,2,1,0,1,0,2,3,0,0,1,9,0,0,
346,0,0,16,44,0,5,635,0,1,1,0,1,0,1,9,0,0,
364,0,0,17,57,0,4,640,0,2,1,0,1,0,2,3,0,0,1,9,0,0,
386,0,0,18,51,0,4,644,0,2,1,0,1,0,2,9,0,0,1,9,0,0,
408,0,0,19,45,0,5,649,0,2,2,0,1,0,1,9,0,0,1,9,0,0,
430,0,0,20,49,0,3,656,0,2,2,0,1,0,1,9,0,0,1,9,0,0,
452,0,0,21,0,0,29,660,0,0,0,0,1,0,
};


#ifdef RCSID
static char *RCSid='costamcostam';
#endif
#define TXRAPP
#define OK 0
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sqlca.h>
#include <sys/types.h>
#include <ctype.h>
#include <sys/stat.h>
#include <time.h>
#include <sys/time.h>
#include <sys/stat.h>


/* EXEC SQL INCLUDE sqlca;
 */ 
/*
 * $Header: sqlca.h,v 1.3 1994/12/12 19:27:27 jbasu Exp $ sqlca.h 
 */

/* Copyright (c) 1985,1986 by Oracle Corporation. */
 
/*
NAME
  SQLCA : SQL Communications Area.
FUNCTION
  Contains no code. Oracle fills in the SQLCA with status info
  during the execution of a SQL stmt.
NOTES
  **************************************************************
  ***                                                        ***
  *** This file is SOSD.  Porters must change the data types ***
  *** appropriately on their platform.  See notes/pcport.doc ***
  *** for more information.                                  ***
  ***                                                        ***
  **************************************************************

  If the symbol SQLCA_STORAGE_CLASS is defined, then the SQLCA
  will be defined to have this storage class. For example:
 
    #define SQLCA_STORAGE_CLASS extern
 
  will define the SQLCA as an extern.
 
  If the symbol SQLCA_INIT is defined, then the SQLCA will be
  statically initialized. Although this is not necessary in order
  to use the SQLCA, it is a good pgming practice not to have
  unitialized variables. However, some C compilers/OS's don't
  allow automatic variables to be init'd in this manner. Therefore,
  if you are INCLUDE'ing the SQLCA in a place where it would be
  an automatic AND your C compiler/OS doesn't allow this style
  of initialization, then SQLCA_INIT should be left undefined --
  all others can define SQLCA_INIT if they wish.

  If the symbol SQLCA_NONE is defined, then the SQLCA variable will
  not be defined at all.  The symbol SQLCA_NONE should not be defined
  in source modules that have embedded SQL.  However, source modules
  that have no embedded SQL, but need to manipulate a sqlca struct
  passed in as a parameter, can set the SQLCA_NONE symbol to avoid
  creation of an extraneous sqlca variable.
 
MODIFIED
    jbasu      12/12/94 -  Bug 217878: note this is an SOSD file
    losborne   08/11/92 -  No sqlca var if SQLCA_NONE macro set 
  Clare      12/06/84 - Ch SQLCA to not be an extern.
  Clare      10/21/85 - Add initialization.
  Bradbury   01/05/86 - Only initialize when SQLCA_INIT set
  Clare      06/12/86 - Add SQLCA_STORAGE_CLASS option.
*/
 
#ifndef SQLCA
#define SQLCA 1
 
struct   sqlca
         {
         /* ub1 */ char    sqlcaid[8];
         /* b4  */ long    sqlabc;
         /* b4  */ long    sqlcode;
         struct
           {
           /* ub2 */ unsigned short sqlerrml;
           /* ub1 */ char           sqlerrmc[70];
           } sqlerrm;
         /* ub1 */ char    sqlerrp[8];
         /* b4  */ long    sqlerrd[6];
         /* ub1 */ char    sqlwarn[8];
         /* ub1 */ char    sqlext[8];
         };

#ifndef SQLCA_NONE 
#ifdef   SQLCA_STORAGE_CLASS
SQLCA_STORAGE_CLASS struct sqlca sqlca
#else
         struct sqlca sqlca
#endif
 
#ifdef  SQLCA_INIT
         = {
         {'S', 'Q', 'L', 'C', 'A', ' ', ' ', ' '},
         sizeof(struct sqlca),
         0,
         { 0, {0}},
         {'N', 'O', 'T', ' ', 'S', 'E', 'T', ' '},
         {0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0}
         }
#endif
         ;
#endif
 
#endif
 
/* end SQLCA */
/*  */ 
/*
 * $Header: sqlca.h,v 1.3 1994/12/12 19:27:27 jbasu Exp $ sqlca.h 
 */

/* Copyright (c) 1985,1986 by Oracle Corporation. */
 
/*
NAME
  SQLCA : SQL Communications Area.
FUNCTION
  Contains no code. Oracle fills in the SQLCA with status info
  during the execution of a SQL stmt.
NOTES
  **************************************************************
  ***                                                        ***
  *** This file is SOSD.  Porters must change the data types ***
  *** appropriately on their platform.  See notes/pcport.doc ***
  *** for more information.                                  ***
  ***                                                        ***
  **************************************************************

  If the symbol SQLCA_STORAGE_CLASS is defined, then the SQLCA
  will be defined to have this storage class. For example:
 
    #define SQLCA_STORAGE_CLASS extern
 
  will define the SQLCA as an extern.
 
  If the symbol SQLCA_INIT is defined, then the SQLCA will be
  statically initialized. Although this is not necessary in order
  to use the SQLCA, it is a good pgming practice not to have
  unitialized variables. However, some C compilers/OS's don't
  allow automatic variables to be init'd in this manner. Therefore,
  if you are INCLUDE'ing the SQLCA in a place where it would be
  an automatic AND your C compiler/OS doesn't allow this style
  of initialization, then SQLCA_INIT should be left undefined --
  all others can define SQLCA_INIT if they wish.

  If the symbol SQLCA_NONE is defined, then the SQLCA variable will
  not be defined at all.  The symbol SQLCA_NONE should not be defined
  in source modules that have embedded SQL.  However, source modules
  that have no embedded SQL, but need to manipulate a sqlca struct
  passed in as a parameter, can set the SQLCA_NONE symbol to avoid
  creation of an extraneous sqlca variable.
 
MODIFIED
    jbasu      12/12/94 -  Bug 217878: note this is an SOSD file
    losborne   08/11/92 -  No sqlca var if SQLCA_NONE macro set 
  Clare      12/06/84 - Ch SQLCA to not be an extern.
  Clare      10/21/85 - Add initialization.
  Bradbury   01/05/86 - Only initialize when SQLCA_INIT set
  Clare      06/12/86 - Add SQLCA_STORAGE_CLASS option.
*/
 
#ifndef SQLCA
#define SQLCA 1
 
struct   sqlca
         {
         /* ub1 */ char    sqlcaid[8];
         /* b4  */ long    sqlabc;
         /* b4  */ long    sqlcode;
         struct
           {
           /* ub2 */ unsigned short sqlerrml;
           /* ub1 */ char           sqlerrmc[70];
           } sqlerrm;
         /* ub1 */ char    sqlerrp[8];
         /* b4  */ long    sqlerrd[6];
         /* ub1 */ char    sqlwarn[8];
         /* ub1 */ char    sqlext[8];
         };

#ifndef SQLCA_NONE 
#ifdef   SQLCA_STORAGE_CLASS
SQLCA_STORAGE_CLASS struct sqlca sqlca
#else
         struct sqlca sqlca
#endif
 
#ifdef  SQLCA_INIT
         = {
         {'S', 'Q', 'L', 'C', 'A', ' ', ' ', ' '},
         sizeof(struct sqlca),
         0,
         { 0, {0}},
         {'N', 'O', 'T', ' ', 'S', 'E', 'T', ' '},
         {0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0}
         }
#endif
         ;
#endif
 
#endif
 
/* end SQLCA */


typedef struct {
    char name[128];
    char val[128];
} entry;

char *months[]={"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul",
                "Aug", "Sep", "Oct", "Nov", "Dec"};
char *grp_name[]={"MSRC","PET","Both"};

char command[]="ctxload.sh >> /oracle/usr/wsms/cgi-bin/ctxload.log";
char command1[]="ctxload1.sh >> /oracle/usr/wsms/cgi-bin/ctxload1.log";

/* EXEC SQL BEGIN DECLARE SECTION; */ 

	char username[20];
	char password[20];
	long fid,doc_size;
	int group;
/*	char uid[50];
	char aut[255];
	char tit[255];*/
	int ref_no,html_no,img_no;
	char sub[512];
	char doc_path[255];
	char ld[20],pubd[20];
	char grp_n[10];
	char lsub[255];
	int textnum;
	char afid[8];
/* EXEC SQL END DECLARE SECTION; */ 



int main(int argc, char* argv[])
{
  struct stat docinfo;
  entry entries[100];
  char *cl;
  struct tm *ptr;
  time_t lt;
  char commd[80];
  char filename[] = "tmp.txt";
  int x,m;
  
  printf("Content-type: text/html%c%c",10,10);
  if(getenv("ORACLE_HOME")==NULL) putenv("ORACLE_HOME=/oracle/app/oracle/product/7.3.2");
  if(getenv("ORACLE_SID")==NULL) putenv("ORACLE_SID=osprey7");
  
  /* parse URL */
  cl = getenv("QUERY_STRING");
  if(cl == NULL) {
      printf("No query information to decode.\n");
        exit(1);
  }

  for(x=0;cl[0] != '\0';x++) {
        m=x;
        getword(entries[x].val,cl,'&');
        plustospace(entries[x].val);
        unescape_url(entries[x].val);
        getword(entries[x].name,entries[x].val,'=');
  }

  for (x=0; x <= m; x++)
	if (strcmp(entries[x].name,"fid") == 0)
	{
		fid = atol(entries[x].val);
		strcpy(afid,entries[x].val);
	}
/*	else if (strcmp(entries[x].name,"aut") == 0)
		strcpy(aut,entries[x].val);
	else if (strcmp(entries[x].name,"tit") == 0)
		strcpy(tit,entries[x].val);*/
	else if (strcmp(entries[x].name,"docpath") == 0)
		strcpy(doc_path,entries[x].val);
	else if (strcmp(entries[x].name,"grp1") == 0)
		group = atoi(entries[x].val);
/*	else if (strcmp(entries[x].name,"uid") == 0)
		strcpy(uid,entries[x].val);*/

  strcpy(grp_n,grp_name[group - 1]);

/* Public time is system date*/
  lt = time(NULL);
  ptr = localtime(&lt);
  sprintf(pubd,"%d-%s-%d",ptr->tm_mday, months[ptr->tm_mon],ptr->tm_year+1900);

  stat(doc_path,&docinfo);
  doc_size = docinfo.st_size;

/* Last modify date*/
  ptr = gmtime(&docinfo.st_mtime);
  sprintf(ld,"%d-%s-%d",ptr->tm_mday, months[ptr->tm_mon],ptr->tm_year+1900);

  
  
/* Connect to ORACLE. */

  strcpy(username, "wsms");
  strcpy(password, "wsms"); 
  /* EXEC SQL CONNECT :username IDENTIFIED BY :password; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 3;
  sqlstm.iters = (unsigned int  )10;
  sqlstm.offset = (unsigned int  )2;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)username;
  sqlstm.sqhstl[0] = (unsigned int  )20;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)password;
  sqlstm.sqhstl[1] = (unsigned int  )20;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}



  if (!(get_text(fid)==0)) {
	 printf("Please make sure the raw file exists!<br>");
	 /* EXEC SQL DELETE FROM docs WHERE id=:fid; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 3;
  sqlstm.stmt = "delete from docs  where id=:b0";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )28;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&fid;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	 /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 3;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )46;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	 return 1;
  }

printf("ld: %s<br>",ld);
strcpy(lsub,sub);

/* EXEC SQL UPDATE docs SET group_name=:grp_n, no_refs=:ref_no,no_html=:html_no,
			no_imgs=:img_no,fsize=:doc_size,subject=:lsub,
			orphanflag=0
	WHERE id=:fid; */ 

{
struct sqlexd sqlstm;

sqlstm.sqlvsn = 8;
sqlstm.arrsiz = 7;
sqlstm.stmt = "update docs  set group_name=:b0,no_refs=:b1,no_html=:b2,no_im\
gs=:b3,fsize=:b4,subject=:b5,orphanflag=0 where id=:b6";
sqlstm.iters = (unsigned int  )1;
sqlstm.offset = (unsigned int  )60;
sqlstm.cud = sqlcud0;
sqlstm.sqlest = (unsigned char  *)&sqlca;
sqlstm.sqlety = (unsigned short)0;
sqlstm.sqhstv[0] = (unsigned char  *)grp_n;
sqlstm.sqhstl[0] = (unsigned int  )10;
sqlstm.sqindv[0] = (         short *)0;
sqlstm.sqharm[0] = (unsigned int  )0;
sqlstm.sqhstv[1] = (unsigned char  *)&ref_no;
sqlstm.sqhstl[1] = (unsigned int  )4;
sqlstm.sqindv[1] = (         short *)0;
sqlstm.sqharm[1] = (unsigned int  )0;
sqlstm.sqhstv[2] = (unsigned char  *)&html_no;
sqlstm.sqhstl[2] = (unsigned int  )4;
sqlstm.sqindv[2] = (         short *)0;
sqlstm.sqharm[2] = (unsigned int  )0;
sqlstm.sqhstv[3] = (unsigned char  *)&img_no;
sqlstm.sqhstl[3] = (unsigned int  )4;
sqlstm.sqindv[3] = (         short *)0;
sqlstm.sqharm[3] = (unsigned int  )0;
sqlstm.sqhstv[4] = (unsigned char  *)&doc_size;
sqlstm.sqhstl[4] = (unsigned int  )4;
sqlstm.sqindv[4] = (         short *)0;
sqlstm.sqharm[4] = (unsigned int  )0;
sqlstm.sqhstv[5] = (unsigned char  *)lsub;
sqlstm.sqhstl[5] = (unsigned int  )255;
sqlstm.sqindv[5] = (         short *)0;
sqlstm.sqharm[5] = (unsigned int  )0;
sqlstm.sqhstv[6] = (unsigned char  *)&fid;
sqlstm.sqhstl[6] = (unsigned int  )4;
sqlstm.sqindv[6] = (         short *)0;
sqlstm.sqharm[6] = (unsigned int  )0;
sqlstm.sqphsv = sqlstm.sqhstv;
sqlstm.sqphsl = sqlstm.sqhstl;
sqlstm.sqpind = sqlstm.sqindv;
sqlstm.sqparm = sqlstm.sqharm;
sqlstm.sqparc = sqlstm.sqharc;
sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}



/*
EXEC SQL INSERT INTO docs(id,author,title,reviewer,expdate,reviewdate,type,group_no,group_name,path,no_refs,no_html,no_imgs,fsize,subject)
	 VALUES(:fid,:aut,:tit,NULL,NULL,NULL,1,:group,:grp_n,:doc_path,:ref_no,:html_no,:img_no,:doc_size,:lsub);*/


/* EXEC SQL COMMIT; */ 

{
struct sqlexd sqlstm;

sqlstm.sqlvsn = 8;
sqlstm.arrsiz = 7;
sqlstm.iters = (unsigned int  )1;
sqlstm.offset = (unsigned int  )102;
sqlstm.cud = sqlcud0;
sqlstm.sqlest = (unsigned char  *)&sqlca;
sqlstm.sqlety = (unsigned short)0;
sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}



printf("path---%s<br>ref--%d<br>html--%d<br>img--%d<br>size--%d<br>",doc_path,ref_no,html_no,img_no,doc_size);
printf("subjetc--%s<br>sub_len=%d<br>",sub,strlen(sub));

 /* EXEC SQL INSERT INTO docs(id,author,title,reviewer,expdate,reviewdate,
			type,group_no,group_name,path,no_refs,
			no_html,no_imgs,fsize,subject)
   	VALUES(:fid,:aut,:tit,NULL,NULL,NULL,1,:group,:grp_n,
	 :doc_path,:ref_no,:html_no,:img_no,:doc_size,:sub);*/

  printf("Finish to insert Metadata!<br>");

/* check if the document is new or updated */
  /* EXEC SQL SELECT count(*) INTO :textnum FROM texts WHERE id=:fid; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "select count(*)  into :b0  from texts where id=:b1";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )116;
  sqlstm.selerr = (unsigned short)1;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&textnum;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&fid;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  if (textnum != 0) { 
	/* EXEC SQL DELETE FROM texts WHERE id=:fid; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "delete from texts  where id=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )138;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&fid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	/* EXEC SQL COMMIT; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )156;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  }
  printf("status=%d<br>",system(command));
  printf("Finish to load text!<br>");
  sprintf(commd,"mv %s %s.old",filename,filename);
  system(commd);
/*  /usr/local/bin/system(command1);*/
  /* EXEC SQL COMMIT; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )170;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


    
} 


int get_text(long docid)
{
  int  string_len=0,c,i,commt=0;
  int  state=0;
  int  title_len=0,subject_len=0;
  char string[4096];
  char *href,*point;
  FILE *rawfp, *rtdfp;
#define ST_L  1
#define TITLE 2
#define SUBJ  4

void remove_blanks(char* s) ;
char* chk_href(char *s) ;
char* chk_frame(char *s) ;
void chk_deadlink(char* href);
char* calculate_address(char* href);
  
  if (!(rawfp = fopen(doc_path,"r")))
	{
		printf("Cannot open the raw file!\n");
		return 1;
 	}
  if (!(rtdfp = fopen("tmp.txt","w")))
	{
		printf("Cannot create the new load file!\n");
		return 2;
	}
  fprintf(rtdfp,"<TEXTSTART: ");
  fprintf(rtdfp,"TYPE=1,",docid);
  fprintf(rtdfp,"ID=%ld,",docid);
  fprintf(rtdfp,"LDATE='%s'>\n",ld);
  
  while ((c = getc(rawfp)) != EOF)
  {
	   putc(c,rtdfp);
	   if(state & ST_L) 
	   {
      	      if(c!='>' && string_len<4095) {
	  		if ( c != '\0' && c != '\n')
	  			string[string_len++]=c;
        		if (string_len==3 && string[0]=='!' && string[1]=='-' && string[2]=='-')
	  			commt = 1;
      	      }
      	      else
		 if(c=='>')
		 { 
	  	   if (commt==1) {
	    		i=string_len;
	    		while(string[i--]==' '); 
	    		if (string[i]=='-' && string[i-1]=='-') {
	      			state &= ~ST_L;
	      			string_len=0;
	      			commt=0; 
	    		}
	  	   }
	  	   else {
	    		string[string_len]=0;
	
  			if(href=chk_href(string))
			  {
				ref_no++;
				if(chk_html(href)) html_no++;
				chk_deadlink(href);
			  }
			else if (href=chk_frame(string)) {
				if(chk_html(href)) html_no++;}
			else if(chk_img(string))   img_no++;
			else if(chk_title(string)) state |= TITLE;
	    		else if(chk_etitle(string))state &= ~TITLE;
	    		state &= ~ST_L;
	    		string_len=0;
		   }
		}

	   }
	   else {
		if(c=='<')
      		{
			state |= ST_L;
			continue;
      		}

		if(subject_len<512)
			if(c > ' ')
			{
			  if(c=='\'') c='"';
	  		  sub[subject_len++]=c;
			}
			else
	  		  if(subject_len>0 && sub[subject_len-1] > ' ')
	    		sub[subject_len++]=' ';

	  }
  }
  
 /* hi->title[title_len]='\0';*/
  sub[subject_len]='\0';
 /* remove_blanks(hi->title);*/
  remove_blanks(sub);
  fprintf(rtdfp,"\n<TEXTEND>\n");
  fclose(rawfp);
  fclose(rtdfp);
  return 0;	

}


void remove_blanks(char* str)
{
  int n,len,i=0;
  len=strlen(str);
  for(i=0;i<len;i++)
    if(str[i]<' ' || str[i]>'z') str[i]=' ';
  i=0;
  while(str[i]==' ') i++;
  len=len-i;
  for(n=0;n<=len;n++)
    str[n]=str[n+i];
  while(len!=0 && str[--len]==' ')str[len]='\0';
}

char* chk_frame(char* str)
{
  static char href[256] ;
  char * tmp=NULL;
  int	 poiner_a,length,i;
  enum {NORM, QUOT} state=NORM;

  while(*str==' ' || *str=='\t' || *str=='\n') str++;

  if(*str!='f' && *str!='F') return 0; else str++;
  if(*str!='r' && *str!='R') return 0; else str++;
  if(*str!='a' && *str!='A') return 0; else str++;
  if(*str!='m' && *str!='M') return 0; else str++;
  if(*str!='e' && *str!='E') return 0; else str++;

  for(;*str!=0;str++)
  {
    if(*str=='"')
    {
      if(state==NORM) state=QUOT;
      if(state==QUOT) state=NORM;
    }
    if(state==QUOT) continue;
    if(*str>' ' || *str=='\0') continue; else str++;
    if(*str!='s' && *str!='S') continue; else str++;
    if(*str!='r' && *str!='R') continue; else str++;
    if(*str!='c' && *str!='C') continue; else str++;
    break;
  }

  if(*str=='\0') return NULL;
  while(*str!='=' && *str!='\0') str++;
  str++;
  while(*str<=' ' && *str!='\0') str++;
  if(*str=='"') str++;
  tmp=href;

  while(*str!=' ' && *str!='"' && *str!='\0')
  {
    if(tmp-href>254) return NULL;
    *tmp++=*str++;
  }
  
  *tmp='\0';
  return href; 
}

char* chk_href(char* str)
{
  static char href[256];
  char * tmp=NULL;
  int	 poiner_a,length,i;
  enum {NORM, QUOT} state=NORM;

  while(*str==' ' || *str=='\t' || *str=='\n') str++;
  if(*str != 'a' && *str != 'A') return 0;
  str++;
  if(*str!=' ' && *str!='\t' && *str!='\n') return 0;

  for(;*str!=0;str++)
  {
    if(*str=='"')
    {
      if(state==NORM) state=QUOT;
      if(state==QUOT) state=NORM;
    }
    if(state==QUOT) continue;
    if(*str>' ' || *str=='\0') continue; else str++;
    if(*str!='h' && *str!='H') continue; else str++;
    if(*str!='r' && *str!='R') continue; else str++;
    if(*str!='e' && *str!='E') continue; else str++;
    if(*str!='f' && *str!='F') continue; else str++;
    break;
  }
  if(*str=='\0') return NULL;
  while(*str!='=' && *str!='\0') str++;
  str++;
  while(*str<=' ' && *str!='\0') str++;
  if(*str=='"') str++;
  tmp=href;
  while(*str!=' ' && *str!='"' && *str!='\0')
  {
    if(tmp-href>254) return NULL;
    *tmp++=*str++;
  }
  *tmp='\0';
  return href; 
}
    
int chk_html(char* href)
{
  char *ext;
  int length=strlen(href);
  if(href[length-1]=='/') return 1;
  ext=strrchr(href,'.');
  if (ext == NULL) return 0;
  if(strcmp(ext,".html")==0) return 1;
  if(strcmp(ext,".htm")==0) return 1;
  if(strcmp(ext,".ht")==0) return 1;
  return 0;
}
  
int chk_img(char* str)
{
  while(*str<' ' && *str != 0) str++;
  if(str[0]!='I' && str[0]!='i') return 0;
  if(str[1]!='M' && str[1]!='m') return 0;
  if(str[2]!='G' && str[2]!='g') return 0;
  return 1;
}
      
int chk_title(char* str)
{
  static char buffer[255];
  int length;
  while(*str<' ' && *str != 0) str++;
  if(str[0]!='T' && str[0]!='t') return 0;
  if(str[1]!='I' && str[1]!='i') return 0;
  if(str[2]!='T' && str[2]!='t') return 0;
  if(str[3]!='L' && str[3]!='l') return 0;
  if(str[4]!='E' && str[4]!='e') return 0;
  return 1;
}
  
int chk_etitle(char* str)
{
  static char buffer[255];
  int length;
  while(*str<' ' && *str != 0) str++;
  if(str[0]!='/') return 0;
  if(str[1]!='T' && str[1]!='t') return 0;
  if(str[2]!='I' && str[2]!='i') return 0;
  if(str[3]!='T' && str[3]!='t') return 0;
  if(str[4]!='L' && str[4]!='l') return 0;
  if(str[5]!='E' && str[5]!='e') return 0;
  return 1;
}  

char* calculate_address(char* href)
{
  char *point;
  char *point1,*point2;
  char old_url[200]="";
  char tmpdir[200]="";
  char tmp_path[100];
  int i;

  /* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* VARCHAR web_dir[100]; */ 
struct { unsigned short len; unsigned char arr[100]; } web_dir;

	/* VARCHAR web_url[100]; */ 
struct { unsigned short len; unsigned char arr[100]; } web_url;

	int tot;
  /* EXEC SQL END DECLARE SECTION; */ 


  /* EXEC SQL DECLARE cdir CURSOR FOR
	SELECT url
	FROM weburls
	WHERE not(dir IS NULL); */ 


  if(strchr(href,'?')) return NULL;
  if(strchr(href,'&')) return NULL;

  while(*href<=' ' && *href!='\0') href++;

  point1=strchr(href,':');
  point2=strchr(href,'/');
  
  if(point1!=NULL && (point2==NULL || point1<point2))
	return href;
  /* Transfer old file path to URL */
  /* EXEC SQL OPEN cdir; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = sq0010;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )184;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  web_dir.len=0;
  web_dir.len=0;
  /* EXEC SQL SELECT count(*) INTO :tot FROM weburls; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "select count(*)  into :b0  from weburls ";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )198;
  sqlstm.selerr = (unsigned short)1;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&tot;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  for (i=0;i<tot;i++)
  {
	/* EXEC SQL FETCH cdir INTO :web_url; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )216;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&web_url;
 sqlstm.sqhstl[0] = (unsigned int  )102;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


/*	printf("<br>web_url:  %s<br>",web_url.arr);
	strcpy(old_url,web_url.arr);
	old_url[web_url.len]='\0';*/
	/* EXEC SQL SELECT dir INTO :web_dir 
		FROM weburls
		WHERE url=:web_url; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "select dir into :b0  from weburls where url=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )234;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&web_dir;
 sqlstm.sqhstl[0] = (unsigned int  )102;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&web_url;
 sqlstm.sqhstl[1] = (unsigned int  )102;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


/*	printf("<br>web_url:  %s<br>web_dir:   %s<br>",old_url,web_dir.arr);
	if ((strstr(doc_path,web_dir)) && (web_dir.len> strlen(tmpdir)))*/

	point = strstr(doc_path,(char *)web_dir.arr);
/*	printf("<br>point:  %s<br>",point);*/
	if ((point != NULL) && (web_dir.len> strlen(tmpdir)))
	{	
		strcpy(old_url,(char *)web_url.arr);
		old_url[web_url.len] = '\0';
		strcpy(tmpdir,(char *)web_dir.arr);
		tmpdir[web_dir.len] = '\0';
	}
  }
  point = strstr(doc_path,tmpdir) + strlen(tmpdir);
  strcpy(tmp_path,point);
  point1 = strrchr(tmp_path,'/');
  *(point1 + 1) = '\0';

/* For debug
if (point && old_url) printf("point:   %s<br>old_url:   %s<br>",point,old_url);
*/

  strcat(old_url,tmp_path);

/* For debug
if (old_url && tmpdir)
  printf("old_url:  %s<br>tmpdir:  %s<br>",old_url,tmpdir);
*/

  /* attach relative path to parent path */
  if (href[0] != '/')
  {
	point = strrchr(old_url,'/');	
	if (*(point-1) == '/')
		strcat(old_url,"/");
  }
  else
  {
	point = strstr(old_url,"//");
	point1 = strstr(point+2,"/");
	*point1 = '\0';
  }
  strcat(old_url,href);

/* For debug
if (old_url)
printf("old_url:   %s<br>",old_url); 
*/

  while ( point = strstr(old_url,"/../"))
  {
	point1 = point + 3;
	*point = '\0';
	point2 = strrchr(old_url,'/');
	*point2 = '\0';
	strcat(old_url,point1);
  }
  while ( point = strstr(old_url,"./"))
  {
	point1 = point + 2;
	*point = '\0';
	strcat(old_url,point1);
  }
  strcpy(href,old_url);
  return href;
}	 
 


void chk_deadlink(char* href)
{
char* point;
int urlen;
int i;
char final_url[100]="";
char final_dir[100]="";
char test[200];
char tmp_href[200];
int offsite=1;

/* EXEC SQL DECLARE curl CURSOR FOR
	SELECT url,dir
	FROM weburls
	WHERE not(url IS NULL); */ 


/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* VARCHAR tmp_url[100]; */ 
struct { unsigned short len; unsigned char arr[100]; } tmp_url;

	/* VARCHAR tmp_dir[100]; */ 
struct { unsigned short len; unsigned char arr[100]; } tmp_dir;

	/* VARCHAR f_dir[200]; */ 
struct { unsigned short len; unsigned char arr[200]; } f_dir;

	int tot;
	int deadtot;
	long tmpid;
	/* VARCHAR p_id[2000]; */ 
struct { unsigned short len; unsigned char arr[2000]; } p_id;

/* EXEC SQL END DECLARE SECTION; */ 


  if((href=calculate_address(href))==NULL) return;
printf("href===%s\n",href);
  urlen = 0;
  /* EXEC SQL OPEN curl; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = sq0013;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )256;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  /* EXEC SQL SELECT count(*) INTO :tot FROM weburls; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "select count(*)  into :b0  from weburls ";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )270;
  sqlstm.selerr = (unsigned short)1;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&tot;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


/*  EXEC SQL WHENEVER NOT FOUND DO break;*/
  for(i=0;i<tot;i++)
  {
	/* EXEC SQL FETCH curl into :tmp_url,:tmp_dir; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )288;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&tmp_url;
 sqlstm.sqhstl[0] = (unsigned int  )102;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&tmp_dir;
 sqlstm.sqhstl[1] = (unsigned int  )102;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	strcpy(test,(char *)tmp_url.arr);
	test[tmp_url.len] = '\0';

/* For debug
printf("<br>tmp_url:  %s<br>tmp_dir:  %s<br>",tmp_url.arr,tmp_dir.arr);
*/
	
	point = strstr(href,test);
 
/* For debug
printf("tmp_urllen=%d   urlen=%d<br>",tmp_url.len,urlen);

	if (point != NULL) 
		printf("point:   %s<br>",point); 
*/

	if (point!=NULL)
	{
		offsite = 0;
		if (tmp_url.len > urlen)
		{
			urlen = tmp_url.len;
			strcpy(final_url,(char *)tmp_url.arr);
			final_url[tmp_url.len] = '\0';
			strcpy(final_dir,(char *)tmp_dir.arr);
			final_dir[tmp_dir.len] = '\0';
		}	
	}
  }

  /* EXEC SQL CLOSE curl; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )310;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  if (offsite == 1) return;

/* For debug
if (final_dir) printf("final_dir1:   %s<br>",final_dir);
*/
 
 point=href+strlen(final_url);
  strcat(final_dir,point);
  strcpy((char *)f_dir.arr,final_dir);
  f_dir.len = strlen(final_dir);

/* For debug
if (final_url && (f_dir.len >0) );
printf("<br>final_url:  %s<br>f_dir:   %s<br>final_dir:   %s<br>",final_url,f_dir.arr,final_dir);
*/

/*  EXEC SQL DECLARE c_dir CURSOR FOR
	SELECT id
	FROM docs
	WHERE path=:f_dir;*/
  tot = 0;
  /* EXEC SQL SELECT count(*) INTO :tot FROM docs WHERE path=:f_dir; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "select count(*)  into :b0  from docs where path=:b1";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )324;
  sqlstm.selerr = (unsigned short)1;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&tot;
  sqlstm.sqhstl[0] = (unsigned int  )4;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&f_dir;
  sqlstm.sqhstl[1] = (unsigned int  )202;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  if (tot>0) 
  {
/*	EXEC SQL OPEN c_dir;
	EXEC SQL FETCH c_dir INTO :tmpid;
	EXEC SQL CLOSE c_dir;*/
	/* EXEC SQL UPDATE docs SET orphanflag=1 WHERE path=:f_dir; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "update docs  set orphanflag=1 where path=:b0";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )346;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&f_dir;
 sqlstm.sqhstl[0] = (unsigned int  )202;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


  }
  else
  {
	deadtot = 0;
	/* EXEC SQL SELECT count(*) INTO :deadtot FROM deadlinks
		 WHERE dfile=:f_dir; */ 

{
 struct sqlexd sqlstm;

 sqlstm.sqlvsn = 8;
 sqlstm.arrsiz = 7;
 sqlstm.stmt = "select count(*)  into :b0  from deadlinks where dfile=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )364;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (unsigned char  *)&deadtot;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&f_dir;
 sqlstm.sqhstl[1] = (unsigned int  )202;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	if (deadtot >0)
	{
		/* EXEC SQL SELECT pid INTO :p_id FROM deadlinks 
			WHERE dfile=:f_dir; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "select pid into :b0  from deadlinks where dfile=:b1";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )386;
  sqlstm.selerr = (unsigned short)1;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&p_id;
  sqlstm.sqhstl[0] = (unsigned int  )2002;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&f_dir;
  sqlstm.sqhstl[1] = (unsigned int  )202;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


		strcat((char *)p_id.arr,",");
		strcat((char *)p_id.arr,afid);
		p_id.len = p_id.len + strlen(afid) + 1;
		/* EXEC SQL UPDATE deadlinks SET pid=:p_id 
			WHERE dfile=:f_dir; */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "update deadlinks  set pid=:b0 where dfile=:b1";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )408;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&p_id;
  sqlstm.sqhstl[0] = (unsigned int  )2002;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&f_dir;
  sqlstm.sqhstl[1] = (unsigned int  )202;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	}
	else
	{
		strcpy((char *)p_id.arr,afid);
		p_id.len = strlen(afid);
		/* EXEC SQL INSERT INTO deadlinks(dfile,pid)
			VALUES(:f_dir,:p_id); */ 

{
  struct sqlexd sqlstm;

  sqlstm.sqlvsn = 8;
  sqlstm.arrsiz = 7;
  sqlstm.stmt = "insert into deadlinks(dfile,pid) values (:b0,:b1)";
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )430;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char  *)&f_dir;
  sqlstm.sqhstl[0] = (unsigned int  )202;
  sqlstm.sqindv[0] = (         short *)0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqhstv[1] = (unsigned char  *)&p_id;
  sqlstm.sqhstl[1] = (unsigned int  )2002;
  sqlstm.sqindv[1] = (         short *)0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	}
  }
  	/* EXEC SQL COMMIT; */ 

{
   struct sqlexd sqlstm;

   sqlstm.sqlvsn = 8;
   sqlstm.arrsiz = 7;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )452;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)0;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


}
	


